<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\Util\TkEntity;

class FpafaixatabelaEntity extends TkEntity
{
    private static  $_faixas = array();
    const TYPE_DAO = 'D';
    const TYPE_ENTITY = 'E';
    const TYPE_FACADE = 'F';
    const TYPE_LOGIC = 'L';
    
    public function __construct($entityManager, $hcmParameters){
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();
        parent::__construct(null, $entityManager);
    }
    
    public static function inicializaLista($data_competencia){
        $tmp = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_FAIXATABELA)->retornaFaixas($data_competencia);
        foreach ($tmp as $tmp_faixa) {
            self::$_faixas[$tmp_faixa->getNrtabelafolha()][] = $tmp_faixa;
        }

    }
    
     public static function retornaValorAliquota2020($vr_base, $nr_tabela, $data_competencia, &$percentual ){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }
        
        $tabela = self::$_faixas[$nr_tabela];
        $resultados = [];
        $baseAnterior = 0;
        
        foreach ($tabela as $item) {
            if ($vr_base >= $item->getVrlimitsupfaixa()) {
                $percentual = (float)$item->getVrpecalculoresu();
                $base = $item->getVrlimitsupfaixa() - $baseAnterior;
                $valor = ($base * $percentual) / 100;
                $valores = array('VALOR' => $valor, 'FAIXA' => $percentual, 'BASE' => $base, 'VRLIMITE' => $item->getVrmaxresultcalc());
                $resultados[] = $valores;
                
                $baseAnterior += $base;
            }else{
                $percentual = (float)$item->getVrpecalculoresu();
                $base = $vr_base - $baseAnterior;
                $valor = ($base * $percentual) / 100;
                $valores = array('VALOR' => $valor, 'FAIXA' => $percentual, 'BASE' => $base, 'VRLIMITE' => $item->getVrmaxresultcalc());
                $resultados[] = $valores;
                
                return $resultados;
            }
        }
        return $resultados;
    }
    
    public static function retornaValorProcessado($vr_base, $nr_tabela, $data_competencia, &$percentual ){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }

        $tabela = self::$_faixas[$nr_tabela];
        $iteracao = 0;
        foreach ($tabela as $item) {
            $iteracao++;
            $i = ($vr_base <= $item->getVrlimitsupfaixa());
            if ($vr_base <= $item->getVrlimitsupfaixa()) {
                $percentual = (float)$item->getVrpecalculoresu();

                $sub_total = ($vr_base * $percentual) / 100;

                if (((float)$item->getVrmaxresultcalc() !== 0.0)
                    && ((float)$item->getVrmaxresultcalc() < $sub_total)
                ) {
                    $sub_total = $item->getVrmaxresultcalc();
                }

                $sub_total += $item->getVraplicaresult();

                return $sub_total;
            }
        }

        return 0;
    }
    
    public static function retornaValorUltimaFaixa($vr_base, $nr_tabela, $data_competencia, &$percentual ){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }
        $tabela = self::$_faixas[$nr_tabela];
        $iteracao = 0;
        foreach ($tabela as $item) {
            $iteracao++;
            if ((float)$item->getVrmaxresultcalc() !== 0.0){
                $percentual = (float)$item->getVrpecalculoresu();
                $sub_total = ($vr_base * $percentual) / 100;

                if((float)$item->getVrmaxresultcalc() < $sub_total){
                    $sub_total = $item->getVrmaxresultcalc();
                }
                $sub_total += $item->getVraplicaresult();
                return $sub_total;
            }
        }

        return 0;
    }

    public static function retornaFaixasTabela($nr_tabela, $data_competencia){
        if (empty(self::$_faixas) === true) {
            self::inicializaLista($data_competencia);
        }
        return self::$_faixas[$nr_tabela];
    }
}

