<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;

class MonitEsocialRepository {

    protected  $connection;
    
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        
    }
    
    public function getMonitEsocial($filters, $params){
        
        $conditions = "";
        
        foreach ($filters as $filter) {
            if($filter["columnName"] != "NRORG" && $filter["columnName"] != "id"){
                if($filter["columnName"] == "DTHRINICIO"){
                    $conditions .= " AND A.DTHRINICIO BETWEEN :inicio AND :fim ";
                    $params["inicio"] = DateUtil::getDataDeString($filter["value"])->format('d/m/Y');
                    $params["fim"] = DateUtil::adicionaIntervalo(DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($filter["value"])), 1)->format('d/m/Y');
                }else{
                    $conditions .= " AND A.".$filter["columnName"]." ".$filter["operator"]." ".$filter["value"];
                }
            }
        }
        
		$query = "
		SELECT * FROM(
    		SELECT 
                DECODE(NVL(CC.DSPIDPROCESSO,'X'), 'X', 'N', 'S') AS IDLOTE ,
                --Tempo Executando
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((SYSDATE - CC.DTHRINICIO) * 86400)/3600),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),60),'FM00'), 
                --Tempo Total
                (TO_CHAR(TRUNC(((CC.DTHRFIM - CC.DTHRINICIO) * 86400)/3600),'FM9900') 
                || ':' || TO_CHAR(TRUNC(MOD(((CC.DTHRFIM - CC.DTHRINICIO) * 86400),3600)/60),'FM00') 
                || ':' || TO_CHAR(MOD(((CC.DTHRFIM - CC.DTHRINICIO) * 86400),60),'FM00'))
                ) AS DTHREXEC,    
                -- Tempo estimado
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS))/3600)),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS)),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / DECODE(CC.NRTOTPROCESS,0,1,CC.NRTOTPROCESS)) * (CC.NRTOTENVIOS - CC.NRTOTPROCESS)),60),'FM00'), NULL) AS DTHRESTIMADO,    
                -- Porcentagem do calculo
                ROUND((CC.NRTOTPROCESS / DECODE(CC.NRTOTENVIOS,0,1,CC.NRTOTENVIOS)) * 100) || '%' AS PERCENTCON,    
                CC.*
            FROM ESO_CONSUMER CC
		) A WHERE A.NRORG = :P_NRORG
		
		".$conditions." ORDER BY A.DTHRINICIO DESC";
		
        $sql = $this->entityManager->getConnection()->prepare($query);
        $sql->execute($params);
        return $sql->fetchAll();
    }
} 
