/*+
|                                                |
|      Trigger: DTULTATU_CONVMED                 |  
|      Tabela : CONV_MEDICO                      |
|                                                |
|      Criao:                                  |
|      07/02/2008 - Leonardo Bispo               |
|                                                |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONVMED' and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
   DROP TRIGGER DTULTATU_CONVMED
GO

CREATE TRIGGER DTULTATU_CONVMED
ON CONV_MEDICO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONV_MEDICO', null, 'CDCONVMEDI='+ CDCONVMEDI+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONV_MEDICO
      SET DTULTATUCONVMED = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONV_MEDICO.CDCONVMEDI,0) = ISNULL(INSERTED.CDCONVMEDI,0)) AND
            (ISNULL(CONV_MEDICO.NMCONVMEDI,0) = ISNULL(INSERTED.NMCONVMEDI,0));
   END;
END;
GO