/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3904_CDPFUNS_VALIDA_DATA_PRODUCAO.SQL

@C:\Web_505\Sql\End_Conv\sqlServer\3904_CDPFUNS_VALIDA_DATA_PRODUCAO.SQL

Descrio:
   Funo para enquadramento da data de produo nos dias e horarios disponiveis do equipamentos

Criao:
30/10/2008 - Welbert G. Moitinha
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VALIDA_DATA_PRODUCAO' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION VALIDA_DATA_PRODUCAO
GO

CREATE FUNCTION VALIDA_DATA_PRODUCAO ( @P_CDFILIAL  VARCHAR(4),
                                       @P_DTMRP DATETIME,
                                       @P_CDPRODUTO VARCHAR(10),
                                       @P_DATA_VALIDAR DATETIME,
                                       @P_NRTOTLOTEDIA INT,
                                       @P_CDPERIPRODU VARCHAR(2),
                                       @P_QTDEMINUTOSUTIL DOUBLE PRECISION,
                                       @P_CDEQUIPPRO VARCHAR(10),
                                       @P_DTATUAL DATETIME) RETURNS DATETIME

AS
BEGIN
   DECLARE @V_DTAPRODUZIR DATETIME;
   DECLARE @V_VEXISHORATUR VARCHAR(4);
   DECLARE @V_TURNOFIMANT VARCHAR(4);
   DECLARE @V_LOTEDISPON VARCHAR(1);
   DECLARE @V_DTPRODUCAO DATETIME;
   DECLARE @V_NRLOTESDIAS INT;
   DECLARE @V_NRTURNO VARCHAR(2);
   DECLARE @V_DTAUXI DATETIME;
   DECLARE @V_QTHRTURNO DOUBLE PRECISION;
   DECLARE @V_DTRESEREQUIP DATETIME;
   DECLARE @V_QTDEMINEQUIP DOUBLE PRECISION
   DECLARE @V_DTSOMA DATETIME;
   DECLARE @V_DTONTEM DATETIME;
END
GO

ALTER FUNCTION VALIDA_DATA_PRODUCAO ( @P_CDFILIAL  VARCHAR(4),
                                       @P_DTMRP DATETIME,
                                       @P_CDPRODUTO VARCHAR(10),
                                       @P_DATA_VALIDAR DATETIME,
                                       @P_NRTOTLOTEDIA INT,
                                       @P_CDPERIPRODU VARCHAR(2),
                                       @P_QTDEMINUTOSUTIL DOUBLE PRECISION,
                                       @P_CDEQUIPPRO VARCHAR(10),
                                       @P_DTATUAL DATETIME ) RETURNS DATETIME
AS

BEGIN
   DECLARE @V_DTAPRODUZIR DATETIME;
   DECLARE @V_VEXISHORATUR VARCHAR(4);
   DECLARE @V_TURNOFIMANT VARCHAR(4);
   DECLARE @V_LOTEDISPON VARCHAR(1);
   DECLARE @V_DTPRODUCAO DATETIME;
   DECLARE @V_NRLOTESDIAS INT;
   DECLARE @V_NRTURNO VARCHAR(2);
   DECLARE @V_DTAUXI DATETIME;
   DECLARE @V_QTHRTURNO DOUBLE PRECISION;
   DECLARE @V_DTRESEREQUIP DATETIME;
   DECLARE @V_QTDEMINEQUIP DOUBLE PRECISION
   DECLARE @V_DTSOMA DATETIME;
   DECLARE @V_DTONTEM DATETIME;

   SET @V_DTAPRODUZIR = @P_DATA_VALIDAR;

   IF @P_QTDEMINUTOSUTIL < (1/24) BEGIN
      SET @V_QTDEMINEQUIP = (1/24);
   END
   ELSE BEGIN
      SET @V_QTDEMINEQUIP = @P_QTDEMINUTOSUTIL;
   END;

   IF @P_DATA_VALIDAR < @P_DTATUAL BEGIN
      SET @V_DTAPRODUZIR = NULL;
      RETURN(@V_DTAPRODUZIR);
   END;


   SELECT
      @V_VEXISHORATUR = MAX(T.HRINITURNO)
   FROM
      (SELECT
          NRTURNO,
          HRINITURNO,
          HRFIMTURNO,
          CASE CONVERT(INT,HRFIMTURNO) - CONVERT(INT,HRINITURNO)
              WHEN ABS(CONVERT(INT,HRFIMTURNO) - CONVERT(INT,HRINITURNO)) THEN CONVERT(INT,HRFIMTURNO)
              ELSE CONVERT(INT, HRFIMTURNO) + 2400 END AS HRFINPRODU
       FROM TURNO_PRODUCAO
       WHERE
          (CDFILIAL = @P_CDFILIAL)
      ) T
   WHERE
      ((CASE CONVERT(INT,T.HRFIMTURNO) - CONVERT(INT,T.HRINITURNO) WHEN ABS(CONVERT(INT,T.HRFIMTURNO) - CONVERT(INT,T.HRINITURNO)) THEN
            CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) ELSE
            CASE CONVERT(INT,T.HRINITURNO) - CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) WHEN
                 ABS(CONVERT(INT,T.HRINITURNO) - CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2)))) THEN
                 CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) + 2400 ELSE
                 CONVERT(INT,T.HRINITURNO) END END BETWEEN T.HRINITURNO AND T.HRFIMTURNO));


   /* se no possuir, verifica o turno anterior */
   IF @V_VEXISHORATUR IS NULL BEGIN
      SELECT
         @V_TURNOFIMANT = MAX(T.HRFIMTURNO), @V_NRTURNO=MAX(T.NRTURNO)
      FROM
         (SELECT
             MAX(HRFIMTURNO) AS HRFIMTURNO
          FROM
             TURNO_PRODUCAO
          WHERE
             (CDFILIAL   = @P_CDFILIAL) AND
             (HRFIMTURNO < CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))))
         ) A,
         TURNO_PRODUCAO T
      WHERE
         (T.CDFILIAL   = @P_CDFILIAL)   AND
         (T.HRFIMTURNO = A.HRFIMTURNO)
      GROUP BY
         NRTURNO;


      IF @V_TURNOFIMANT IS NULL BEGIN
         SET @V_DTSOMA = @V_DTAPRODUZIR - @V_QTDEMINEQUIP;

         SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO( @P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO, @V_DTSOMA, @P_NRTOTLOTEDIA, @P_CDPERIPRODU,
                                                            @P_QTDEMINUTOSUTIL, @P_CDEQUIPPRO, @P_DTATUAL);
      END
      ELSE BEGIN
         SET @V_DTAPRODUZIR = CONVERT( DATETIME, CONVERT( VARCHAR, @V_DTAPRODUZIR, 103)+' '+  SUBSTRING(@V_TURNOFIMANT, 1, 2) + ':'+SUBSTRING(@V_TURNOFIMANT, 3, 2)) - @P_QTDEMINUTOSUTIL;
      END;
   END;

   /* Verifica se todos os lotes possveis do dia j foram gerados */
   SET @V_LOTEDISPON = 'N';

   WHILE @V_LOTEDISPON = 'N' BEGIN

      /* VERIFICA SE A DATA SUGERIDA A PRODUZIR PERTENCE AO CALENDARIO DE PRODUCAO */
      SELECT
         @V_DTPRODUCAO = MAX(DTPRODUCAO)
      FROM
         CALEPRODUCAO
      WHERE
         (CDFILIAL             = @P_CDFILIAL)             AND
         (CDPERIPRODU          = @P_CDPERIPRODU)  AND
         ( CONVERT( DATETIME, DTPRODUCAO, 103) <= CONVERT( DATETIME, @V_DTAPRODUZIR, 103));

      IF NOT @V_DTPRODUCAO IS NULL BEGIN
         SET @V_DTAPRODUZIR = (@V_DTPRODUCAO + (@V_DTAPRODUZIR - CONVERT( DATETIME, @V_DTAPRODUZIR, 103)));

         SELECT
            @V_NRLOTESDIAS = COUNT(*)
         FROM
            CALEPRODMRP
         WHERE
            (CDFILIAL              = @P_CDFILIAL)          AND
            (DTPROGPRODCP          = @P_DTMRP)             AND
            (CDPRODUTO             = @P_CDPRODUTO) AND
            (CONVERT(DATETIME, DTCONCPROMRP, 103) = CONVERT(DATETIME, @V_DTAPRODUZIR, 103));

         IF (@V_NRLOTESDIAS = @P_NRTOTLOTEDIA) BEGIN
            SET @V_DTONTEM = @V_DTAPRODUZIR -1;

            SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO( @P_CDFILIAL,
                                                               @P_DTMRP,
                                                               @P_CDPRODUTO,
                                                               @V_DTONTEM,
                                                               @P_NRTOTLOTEDIA,
                                                               @P_CDPERIPRODU,
                                                               @P_QTDEMINUTOSUTIL,
                                                               @P_CDEQUIPPRO, @P_DTATUAL);
         END
         ELSE BEGIN
            SET @V_LOTEDISPON = 'S';
         END;
      END
      ELSE BEGIN
         SET @V_DTONTEM = @V_DTAPRODUZIR -1;

         SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO( @P_CDFILIAL,
                                                            @P_DTMRP,
                                                            @P_CDPRODUTO,
                                                            @V_DTONTEM,
                                                            @P_NRTOTLOTEDIA,
                                                            @P_CDPERIPRODU,
                                                            @P_QTDEMINUTOSUTIL,
                                                            @P_CDEQUIPPRO, @P_DTATUAL);

         IF @V_DTAPRODUZIR <= @P_DTATUAL BEGIN
/*            RAISERROR( 'NO EXISTE CALENDARIO PARA OS DIAS DA PRODUO', 16,1);*/
            RETURN(NULL);
         END;
      END;
   END;

/* VERIFICA SE A DATA FINAL ESTA DENTRO DO TURNO*/
/* H- HOJE
   A- AMANHA */

   SELECT @V_DTAUXI = @V_DTAPRODUZIR, @V_QTHRTURNO = CONVERT(DOUBLE PRECISION, W.QTHRTURNO)
   FROM
   (
    SELECT T.HRINITURNO, T.HRFIMTURNO,
           (FIM - INICIO)AS QTHRTURNO,
            INICIO, FIM, 'H' AS IDDIA
    FROM TURNO_PRODUCAO T,
        (SELECT
            CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTATUAL, 103)+ ' '+ SUBSTRING(HRINITURNO, 1, 2) + ':'+SUBSTRING(HRINITURNO, 3, 2)) AS INICIO,
            CONVERT(DATETIME, CONVERT( VARCHAR, @P_DTATUAL,103) + ' ' + SUBSTRING(HRFIMTURNO, 1, 2) + ':'+SUBSTRING(HRFIMTURNO, 3, 2))  AS FIM,
            CDFILIAL, NRTURNO
          FROM
             TURNO_PRODUCAO
          WHERE
             NRTURNO = @V_NRTURNO AND
             CDFILIAL = @P_CDFILIAL )X
    WHERE
       T.CDFILIAL = @P_CDFILIAL AND
       T.CDFILIAL = X.CDFILIAL AND
       T.NRTURNO = X.NRTURNO AND
       FIM > INICIO
    UNION

    SELECT T.HRINITURNO, T.HRFIMTURNO,
           ((FIM +1) - INICIO) AS QTHRTURNO,
            INICIO, FIM + 1, 'A' AS IDDIA
    FROM TURNO_PRODUCAO T,
        (SELECT
            CONVERT(DATETIME,CONVERT( VARCHAR, @P_DTATUAL, 103) + ' '+ SUBSTRING(HRINITURNO, 1, 2) + ':'+SUBSTRING(HRINITURNO, 3, 2)) AS INICIO,
            CONVERT(DATETIME, CONVERT( VARCHAR, @P_DTATUAL,103) + ' ' + SUBSTRING(HRFIMTURNO, 1, 2) + ':'+SUBSTRING(HRFIMTURNO, 3, 2)) AS FIM,
            CDFILIAL, NRTURNO
          FROM
             TURNO_PRODUCAO
          WHERE
             NRTURNO = @V_NRTURNO AND
             CDFILIAL = @P_CDFILIAL)X
    WHERE
       T.CDFILIAL = @P_CDFILIAL AND
       T.CDFILIAL = X.CDFILIAL AND
       T.NRTURNO = X.NRTURNO AND
       INICIO > FIM
   )W
   WHERE
      (CONVERT( DATETIME, ( CONVERT( VARCHAR ,(CASE W.IDDIA WHEN 'H' THEN @P_DTATUAL ELSE @P_DTATUAL+1 END) ,103) + ' ' + CONVERT(VARCHAR, @V_DTAPRODUZIR + @P_QTDEMINUTOSUTIL, 108))) BETWEEN W.INICIO AND W.FIM)
      AND(W.QTHRTURNO > @P_QTDEMINUTOSUTIL);


/* SE A QUANTIDADE DE TEMPO NECESSARIA FOR MAIOR QUE O TEMPO DO TURNO
RETORNA NULLO PARA SER TRATADO COMO ERRO*/
   IF @V_QTHRTURNO IS NULL BEGIN

      SELECT @V_QTHRTURNO = CONVERT(DOUBLE PRECISION, W.QTHRTURNO)
      FROM
        (SELECT (FIM - INICIO)AS QTHRTURNO
         FROM TURNO_PRODUCAO T,
             (SELECT
                 CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTATUAL, 103) + ' '+  SUBSTRING(HRINITURNO, 1, 2) + ':'+SUBSTRING(HRINITURNO, 3, 2)) AS INICIO,
                 CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTATUAL, 103) + ' '+  SUBSTRING(HRFIMTURNO, 1, 2) + ':'+SUBSTRING(HRFIMTURNO, 3, 2)) AS FIM,
                 CDFILIAL, NRTURNO
               FROM
                  TURNO_PRODUCAO
               WHERE
                  NRTURNO = @V_NRTURNO AND
                  CDFILIAL = @P_CDFILIAL )X
         WHERE
            T.CDFILIAL = @P_CDFILIAL AND
            T.CDFILIAL = X.CDFILIAL AND
            T.NRTURNO = X.NRTURNO AND
            FIM > INICIO
         UNION

         SELECT((FIM +1)  - INICIO) AS QTHRTURNO
         FROM TURNO_PRODUCAO T,
             (SELECT
                 CONVERT( DATETIME, CONVERT( VARCHAR, @P_DTATUAL, 103) + ' '+  SUBSTRING(HRINITURNO, 1, 2) + ':'+SUBSTRING(HRINITURNO, 3, 2)) AS INICIO,
                 CONVERT( DATETIME, CONVERT( VARCHAR, @P_DTATUAL, 103) + ' '+  SUBSTRING(HRFIMTURNO, 1, 2) + ':'+SUBSTRING(HRFIMTURNO, 3, 2)) AS FIM,
                 CDFILIAL, NRTURNO
               FROM
                  TURNO_PRODUCAO
               WHERE
                  NRTURNO = @V_NRTURNO AND
                  CDFILIAL = @P_CDFILIAL)X
         WHERE
            T.CDFILIAL = @P_CDFILIAL AND
            T.CDFILIAL = X.CDFILIAL AND
            T.NRTURNO = X.NRTURNO AND
            INICIO > FIM
        )W;

      IF @V_QTHRTURNO < @P_QTDEMINUTOSUTIL BEGIN
         RETURN(NULL);
      END
      ELSE BEGIN
/*SE NO TIVER SE ENCAIXADO EM NENHUM TURNO*/
         SET @V_DTSOMA  = @V_DTAPRODUZIR - @V_QTDEMINEQUIP;
         SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO (@P_CDFILIAL, @P_DTMRP, @P_CDPRODUTO,
                                                            @V_DTSOMA, @P_NRTOTLOTEDIA, @P_CDPERIPRODU,
                                                            @P_QTDEMINUTOSUTIL, @P_CDEQUIPPRO, @P_DTATUAL);
      END
   END;

   /*VERIFICA SE EXISTE SOLICITAO ABERTA PARA O EQUIPAMENTO NOS DIAS DA PRODUO*/

   SELECT  @V_DTRESEREQUIP = MAX(P.DTINPATIVTAR)
   FROM SOLISERV S,
        TAREFA T,
        PLANATIVTARE P
   WHERE
      S.CDFILIAL = @P_CDFILIAL AND
      S.CDEQUIPPRO = @P_CDEQUIPPRO AND
      (T.IDORIGTARE   = '1') AND
      ((IDSTATUSSOLI   = 'P') OR(IDSTATUSSOLI   = 'A')) AND
      (P.DTINPATIVTAR BETWEEN @V_DTAPRODUZIR AND (@V_DTAPRODUZIR + @V_QTDEMINEQUIP)) AND
      P.DTCONATIVTAR IS NULL AND
      S.CDFILIAL = T.CDFILIAL AND
      S.NRSOLISERV = T.NRSOLISERV AND
      P.CDFILIAL = T.CDFILIAL AND
      P.NRTAREFA =T.NRTAREFA;


   IF @V_DTRESEREQUIP IS NULL  BEGIN
      SELECT @V_DTRESEREQUIP = MAX(DTHRINIPROD)
      FROM RESERVEQUIPAPRO
      WHERE
         (CDFILIAL   = @P_CDFILIAL) AND
         (CDEQUIPPRO = @P_CDEQUIPPRO) AND
         (@V_DTAPRODUZIR BETWEEN DTHRINIPROD AND DTHRFINPROD)AND
         ((@V_DTAPRODUZIR + @P_QTDEMINUTOSUTIL)BETWEEN DTHRINIPROD AND DTHRFINPROD);
   END;

   IF NOT @V_DTRESEREQUIP IS NULL BEGIN
      SET @V_DTSOMA  = @V_DTAPRODUZIR - @V_QTDEMINEQUIP;

      SET @V_DTAPRODUZIR = TEKNISA.VALIDA_DATA_PRODUCAO(@P_CDFILIAL,
                                                        @P_DTMRP,
                                                        @P_CDPRODUTO,
                                                        @V_DTSOMA,
                                                        @P_NRTOTLOTEDIA,
                                                        @P_CDPERIPRODU,
                                                        @P_QTDEMINUTOSUTIL, @P_CDEQUIPPRO, @P_DTATUAL);
   END;
   RETURN(@V_DTAPRODUZIR);
END
GO


-- VERSAO --
EXEC ATUVEROBJ 'VALIDA_DATA_PRODUCAO','5.05.016';
GO

