<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 26/08/2016
 * Time: 11:14
 */

namespace HCM\VAB\Services;

use HCM\Util\TkDI;
use HCM\Util\Repositories;
use Doctrine\ORM\EntityManager;
use Folha\Entities\FpaFaixatabela;
use Folha\Entities\FpaItecalcfolha;
use Folha\Entities\FpaTipoassoceve;
use Folha\Entities\FpaValorreferenciam;
use Folha\Entities\GpeAlteescala;
use Folha\Entities\GpeAltesitufunc;
use Folha\Entities\GpeEscalatrabh;
use Folha\Entities\GpePessoa;
use Folha\Entities\GpeVinculom;
use Folha\Entities\VabBeneficiom;
use Folha\Entities\VabBeneficiario;
use Folha\Entities\VabHistbenefvinc;
use Folha\Entities\FpaTipomoviment;
use Folha\Repositories\FpaCalculofolha;
use Folha\Repositories\FpaFerias;
use Folha\Repositories\GpeSitufunch;
use Folha\Repositories\GpeEscalatrabm;
use \Folha\Entities\GpeHorarioturno;
use HCM\Geral\Entity\GpealtesitufuncEntity;
use HCM\Geral\Entity\GpesitufuncmEntity;
use HCM\Util\DateUtil;
use Geral\Util\NovoCodigo;
use HCM\Util\HCMParameters;
use HCM\Util\FPA;
use HCM\Util\Messages;
use Setforms2\Shared\ORM\DateTime;
use HCM\VAB\Repository\CalculoBeneficioRepository;
use HCM\Geral\Services\PessoaService;
use HCM\FPA\Services\ValorReferenciaService;
use HCM\Geral\Services\AlteSalarioService;
use HCM\Geral\Entity\GpepessoaEntity;
use HCM\Geral\Entity\GpemovimentacaoEntity;
use HCM\Util\MsgCalculo;
use HCM\Util\Valor;
use HCM\FPA\Controllers\LogRetrocessoCalculoController;
use HCM\FPA\Services\ItensCalculoService;

class CalculoBeneficioService {

    //CONSTANTES
    const SABADO = 6;
    const DOMINGO = 7;
    const SABDOM = 67;
    const SEGUNDA = 1;
    const TERCA = 2;
    const QUARTA = 3;
    const QUINTA = 4;
    const SEXTA = 5;

    protected $entityManager;
    protected $hcmParameters;
    protected $histVinc;

    private $beneficios = array();

    private $nrtpbeneficio;
    private $nrestruturam;

    private $dtiniperiodobenef;
    private $dtfimperiodobenef;
    private $dtiniperiodocalculo;
    private $dtfimperiodocalculo;
    private $dtPagamentoBenef;
    private $idcalccomplementar;
    
    //Luan 23/06
    private $dtfimperiodobenefmod;
    private $dtiniperiodobenefmod;

    /** @var GpeVinculom $vinculo */
    private $vinculo;

    private $dsdiadescansosemanal;

    private $nrafastamento;
    private $nrfalta;
    private $nrdiasaviso;
    private $nrdiasproxmes;
    private $nrdiasdsr;
    private $nrdiasferias;
    
    private $nrtpjornada;
    private $nrturno;
    private $nrHorarioTurno;
    
    private $geraBenefFeriado;

    private $diaInicialAupr;
    private $diaFinalAupr;

    private $diastotaisconsideracao;
    private $idMemoria;
    private $_movimentosVinculo;
    private $dtpagamento;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, CalculoBeneficioRepository $calculoBeneficioRepository, PessoaService $pessoaService, ValorReferenciaService $valorReferenciaService, AlteSalarioService $alteSalarioService, LogRetrocessoCalculoController $logRetrocessoCalculoController, ItensCalculoService $itensCalculoService) {
        $this->entityManager               = $entityManager;
        $this->hcmParameters               = $hcmParameters;
        $this->calculoBeneficioRepository  = $calculoBeneficioRepository;
        $this->pessoaService               = $pessoaService;
        $this->valorReferenciaService      = $valorReferenciaService;
        $this->alteSalarioService          = $alteSalarioService;
        $this->logRetrocessoCalculoController = $logRetrocessoCalculoController;
        $this->_movimentosVinculo = new GpemovimentacaoEntity($entityManager, $hcmParameters);
        $this->itensCalculoService = $itensCalculoService;
    }
    
    
    public function calcular($tpperiodo, $dsordem, $dsinicio, $dsfim, $dtinicio, $dtfinal, $dtpagamento, $nrtpbeneficio, $nrestruturam, $dtmescompetenc, $nrorg, $formulario, &$response, $qtdiasbenef = null, $dsinicio1 = null, $dsfim1 = null) {
        try {
            $this->dtPagamentoBenef = $dtpagamento;
            $this->idcalccomplementar = $formulario['IDCALCCOMPLEMENTAR'];
            $this->response = $response;
            $foiCalculado = false;
            $nrcalculobenef = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_BENEFICIO);
            $vinculos = $this->calculoBeneficioRepository->buscaVinculos_Mensal($nrorg, $dtmescompetenc, $dsordem, $dsinicio, $dsfim, $nrestruturam, $nrtpbeneficio, $formulario, $dsinicio1, $dsfim1);
            $this->idMemoria = $formulario['IDMEMORIACALCULO'];
            $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoProcesso(
                $nrcalculobenef, 
                $this->hcmParameters->getNrorgTrabalho(), 
                'CALCULOBENEFICIO',
                $this->hcmParameters->getCdoperador() 
            );
            $this->dtiniperiodobenefmod = $dtinicio;
            $this->dtfimperiodobenefmod = $dtfinal;
        
            foreach ($vinculos as $vinculo) {
                
                MemoriaBeneficio::getInstance()->inicializarDados($vinculo, $this->hcmParameters, $formulario['DTPGTOCALCBENEF']);
                
                $eventos = $qtdBeneficiariosPerEvento = $eventoEparcelas = [];
                $beneficiarios = null;

                // Variável a ser comparada, caso não seja para considerar vínculos com rescisão no mês anterior
                $dtRescisaoVinc = substr($vinculo->getDtrescisaovinc(), 0, 10);
                $dtRescisaoVinc = $dtRescisaoVinc ? DateUtil::getDataDeString($dtRescisaoVinc, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   
                $diaRescisao    = isset($dtRescisaoVinc) ? (int)substr($dtRescisaoVinc, 8, 2): null;

                // Variável a ser comparada, caso não seja para considerar vínculos com rescisão no mês anterior
                $competenciaPosterior  = DateUtil::getDataDeString(substr($this->hcmParameters->getDtCompetencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO);
                $competenciaPosterior  = $competenciaPosterior->add(new \DateInterval('P1M'));
                $competenciaPosterior  = $competenciaPosterior->format('Y-m-d');   

                // Seta dados em MsgCalculo para o uso de mensagens de log
                $instancia = MsgCalculo::getInstance();
                $instancia->setDados($nrcalculobenef, $vinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), "CALCULOBENEFICIO");

                // Variável a ser utilizada juntamente com a $dtRescisaoVinc para calcular dias proporcionalizados                
                $dtAdmissaoVinc = substr($vinculo->getDtadmissaovinc(), 0, 10);
                $dtAdmissaoVinc = $dtAdmissaoVinc ? DateUtil::getDataDeString($dtAdmissaoVinc, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   

                // Variável String com o valor competência que poderá ser comparada com outras variáveis String, todas no Ano/Mês/Dia
                $competenciaAtual  = DateUtil::getDataDeString(substr($this->hcmParameters->getDtCompetencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO);
                $competenciaAtual  = $competenciaAtual->format('Y-m-d'); 

                // Variavael booleana em que caso seja verdadeira, a empresa pagara o valor total do benefício para o beneficiário.
                $subsidio100PorAfastamentoOuDemissao = false;
                    
                // Histórico do vínculo é carregado a fim de se ter acesso ao valor IDASSOCSINDICATO 
                $histVinc = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->_retornaHistórico($vinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), $this->hcmParameters->getDtCompetencia());
                // Caso o vínculo seja de um sindicato é para considerar o campo 'percentual/valor associado' se e somente se este tiver valor
                $idAssocSind = isset($histVinc['IDASSOCSINDICATO']) ? $histVinc['IDASSOCSINDICATO'] : 'N' ; 
               
                if ($histVinc['NRESCALATRABM'] == null) {
                    MsgCalculo::getInstance()->adicionaMensagem("Histórico do vínculo '".$vinculo->getNmvinculom()." não possuí escala", MsgCalculo::ALERTA);
                    $instancia->salvaMensagens();
                    $instancia->clear();
                    
                    continue;
                }
                $escalaTrabalho = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->_retornaUltimoHistorico(
                    $histVinc['NRESCALATRABM'], 
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getDtCompetencia()
                );

                
                if ($escalaTrabalho == null) {
                    MsgCalculo::getInstance()->adicionaMensagem("Não foi encontrado escala para o vínculo ".$vinculo->getNmvinculom(), MsgCalculo::ALERTA);
                    $instancia->salvaMensagens();
                    $instancia->clear();
                    
                    continue;
                }
                // Verificar se período de apuração é definido na escala de trabalho do vínculo
                if($escalaTrabalho->getIdutapuratestbenef()  && ($escalaTrabalho->getIdutapuratestbenef() == 'S' || $escalaTrabalho->getIdutapuratestbenef() == 'Y')){ 
                    $this->diaInicialAupr = $escalaTrabalho->getNrdiainiapur();
                    $this->diaFinalAupr = $escalaTrabalho->getNrdiafinapur();
                }
                
                /*
                if($idAssocSind == 'S' && intval($histVinc['NRESTRUTSIND'])) {
                    MsgCalculo::getInstance()->adicionaMensagem("Vínculo '".$vinculo->getNmvinculom()."' associado a e com sind. cadastrato, mas desconto calculado a partir do beneficio original.", MsgCalculo::ALERTA);                                
                }else if($idAssocSind == 'S' && !intval($histVinc['NRESTRUTSIND'])) {
                    MsgCalculo::getInstance()->adicionaMensagem("Vínculo '".$vinculo->getNmvinculom()."' associado a sindicato, mas não está cadastrado para ele.", MsgCalculo::ALERTA);                                
                }   
                */
                
                switch ($tpperiodo) {
                    case 'MENSAL':
                        $nrlotevinc = null;
                        if($dsordem == 'LISTA_LOTE'){
                            foreach($dsinicio as $nrlotevinc){
                                $vinculoEncontrado = $this->entityManager->getRepository(Repositories::FPA_ITEMLOTEVINC)->findOneBy(array('nrorg' => $this->hcmParameters->getNrorgTrabalho(), 'nrlotevinc' =>  $nrlotevinc, 'nrvinculom' => $vinculo->getNrvinculom()));
                
                                if(!empty($vinculoEncontrado)){
                                    $nrlotevinc = $nrlotevinc;
                                    continue;
                                }
                            }
                        }
                        
                        $motivos = [];    
                        $this->obterMotivosParaNaoCalcular_verificarIsencao100Afastamento($vinculo, $subsidio100PorAfastamentoOuDemissao, $motivos);
                        
                        $beneficiarios = $this->calculoBeneficioRepository->getBeneficiarioPorVinculo($nrorg, $vinculo->getNrvinculom(), $dtmescompetenc, $tpperiodo, $nrtpbeneficio, $nrestruturam);

                        // Variavel utilizada para identificar se é a última iteração de um benefício do vínculo (!Necessidade do retorno ordenado por benefício na função getBeneficiarioPorVinculo!)
                        $isLast = false;
        
                        foreach($beneficiarios as $key => $beneficiario){
            
                            $ehParaCalcular_minimizadorBeneficioOriginal = $ehParaCalcular_minimizadorBeneficioCCT = true;

                            $beneficio = $this->calculoBeneficioRepository->getBeneficioPorVinculo($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficiario->getNrbeneficiom());
                            
                            if($this->hcmParameters->getOcorrenciaCalculo() == 1){

                                $verificaLiquidoOcorr1 = $this->calculoBeneficioRepository->validaLiquidoBeneficioOcorrencia1(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $beneficio['NREVETITULARVINC'], $dtpagamento, 1);
                                
                                if(empty($verificaLiquidoOcorr1)){
                                    $verificaLiquidoOcorr1 = $this->calculoBeneficioRepository->validaLiquidoBeneficioOcorrencia1(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $beneficio['NREVENTOMENSA'], $dtpagamento, 1);
                                }
                                
                                if(!empty($verificaLiquidoOcorr1)){
                                    MsgCalculo::getInstance()->adicionaMensagem("Vinculo ".$vinculo->getNmvinculom().". Liquido com mesma data de pagamento existente na ocorrência 1, em caso de cálculo complementar favor calcular na ocorrência 2 o benefício MENSAL do colaborador", MsgCalculo::ALERTA);
                                    $instancia->salvaMensagens();
                                    $instancia->clear();
            
                                    continue;
                                }
                            }
                            
                            //Variável a ser comparada caso o vinculo possua liquido
                            $verificaLiquido = $this->itensCalculoService->validaLiquidoBeneficio(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $beneficio['NREVETITULARVINC'], $dtpagamento);
                            
                            if(empty($verificaLiquido)){
                                $verificaLiquido = $this->itensCalculoService->validaLiquidoBeneficio(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $beneficio['NREVENTOMENSA'], $dtpagamento);
                            }
                            
                            // Verifica se algum Vinculo ja possui calculo de beneficio
                            if($verificaLiquido){
                                MsgCalculo::getInstance()->adicionaMensagem("Vinculo ".$vinculo->getNmvinculom()." possui o evento ". $beneficio['NREVETITULARVINC']." com a data de pagamento ".$dtpagamento, MsgCalculo::ALERTA);
                                $instancia->salvaMensagens();
                                $instancia->clear();
        
                                continue;
                            }

                            // No último beneficiario da iteração do mesmo benfício calcula o valor de acréscimo no desconto
                            if($key == count($beneficiarios)-1 || (isset($beneficiarios[$key+1]) && $beneficio['NRBENEFICIOM'] != $beneficiarios[$key+1]->getNrbeneficiom())){
                                $isLast = true;
                            }
                            
                            // Verifica conforme o parâmetro do cadastro do benefício se ele deve ser calculado no mês corrente
                            if(substr($beneficio['PERIODICIDADEMES'],DateUtil::getDataDeString($dtmescompetenc,DateUtil::FORMATO_BRASILEIRO,true)->format('m')-1,1) == 'N'){
                                continue;
                            }
                            // Caso o benefício esteja marcado para não gerar na admissão e a data de admissão do vínculo for na competência atual não gera o benefício
                            if($beneficio['IDGERBENEFADMISSAO'] == 'N' && (DateUtil::getDataDeString($vinculo->getDtadmissaovinc())->format('Ym') == DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia())->format('Ym'))){
                                $msgVinculoPossuiAdmissao = "Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Vínculo admitido no mês.";
                                MsgCalculo::getInstance()->adicionaMensagem($msgVinculoPossuiAdmissao, MsgCalculo::ALERTA);
                                continue;
                            }
                            // Caso o benefício esteja marcado para não gerar na rescisão e a data de rescisão do vínculo for na competência atual não gera o benefício
                            if($beneficio['IDGERBENEFRESCISAO'] == 'N' && $vinculo->getDtrescisaovinc() && (DateUtil::getDataDeString($vinculo->getDtrescisaovinc())->format('Ym') == DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia())->format('Ym'))){
                                $msgVinculoPossuiRescisao = "Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Vínculo rescindido no mês.";
                                MsgCalculo::getInstance()->adicionaMensagem($msgVinculoPossuiRescisao, MsgCalculo::ALERTA);
                                continue;
                            }
                            
                            //SO CONCEDE O SUBSIDIO DE AFASTAMENTO SE A OPCAO Gera desconto para afastado ESTIVER DESMARCADA NO BENEFICIO
                            if($subsidio100PorAfastamentoOuDemissao && $beneficio['IDGERADESCAFAST'] == 'S'){
                                $subsidio100PorAfastamentoOuDemissao = false;
                            }
                            
                            // Caso vínculo tenha sindicato no histórico e tal sindicato tenha beneficio correspondente, os dados de desconto do vínculo serão a partir do benefício do sindicato.
                            // Caso vínculo tenha sindicato no histórico e tal sindicato não tenha benefício, os dados de desconto do vínculo serão a partir do benefício original.
                            if(intval($histVinc['NRESTRUTSIND'])) {
                                $benefDescontoSind = $this->calculoBeneficioRepository->getBeneficioDescontoSind($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficio['NRTPBENEFICIO'], intval($histVinc['NRESTRUTSIND']));
                                if(isset($benefDescontoSind) && !empty($benefDescontoSind)) $this->mergeBeneficioComBeneficioSind($beneficio, $benefDescontoSind);
                            }

                            $tpBeneficio = $this->entityManager->getRepository(Repositories::TPBENEFICIO)->findBy(array('nrtpbeneficio'=>$beneficio['NRTPBENEFICIO'], 'nrorg'=>[$this->hcmParameters->getNrorgPadrao(), $this->hcmParameters->getNrorgTrabalho()]));
                            if(is_array($tpBeneficio))$tpBeneficio = $tpBeneficio[0];

                            $this->verificarIsencao100Demissao($subsidio100PorAfastamentoOuDemissao, $beneficio['CONSVINCRESMESANT'], $vinculo, $dtRescisaoVinc, $competenciaAtual);

                            $dtReferenciaRescisao = null; // Caso tenha valor, seu valor será a data da competência anterior referente ao dia informado no campo 'Rescindidos a partir do dia'
                            if( isset($beneficio['NRDIARESCISAO']) && !empty($beneficio['NRDIARESCISAO']) ){
                                $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
                                $dtReferenciaRescisao = clone $objCompetenc; 
                                $dtReferenciaRescisao->sub(new \DateInterval('P1M'));
                                $dtReferenciaRescisao->add(new \DateInterval('P'.( intval($beneficio['NRDIARESCISAO']) -1 ).'D'));
                                $dtReferenciaRescisao = $dtReferenciaRescisao->format('Y-m-d');   
                            }
                            
                            if(     
                                    ( 
                                        $beneficio['CONSVINCRESMESANT'] == 'S' // Calcula apenas se é para considerar vinculos com rescisão do mês anterior.
                                        && (
                                              !isset($dtReferenciaRescisao) // Se for considerar vínculos com rescisão do mês anterior, qualquer vínculo será calculado caso o campo 'Rescindidos até o dia' esteja vazio
                                              || $dtRescisaoVinc >= $dtReferenciaRescisao // Ou caso este esteja preenchido, considerará apenas os vínculos com data de rescisão a partir do dia informado no campo
                                           )
                                    )    
                                || !$dtRescisaoVinc                           // Se não for para considerar vinculos com rescisão do mês anterior, calculará o benefício se não houver data de rescisão do vínculo
                                || ($dtRescisaoVinc >= $competenciaAtual) // ou se a data de rescisão for maior que a competencia atual
                            ) {
                        
                                $MOTIVO = "Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Ele(a) teve no período: ";
                                
                                $minimizadores = $this->obterMinimizadoresMensal($beneficio);
                                
                                $this->validarMinimizadoresBeneficioCCT($beneficio, $tpBeneficio, $vinculo, $beneficiario, $minimizadores, $ehParaCalcular_minimizadorBeneficioCCT, $subsidio100PorAfastamentoOuDemissao);

                                $proporcao = $this->proporcionalizarOuDuplicarDiasTrabalhadosNaCompetencia($dtAdmissaoVinc, $dtRescisaoVinc, $beneficio, $beneficiario, $competenciaAtual, $competenciaPosterior);
                                
                                foreach($motivos as $motivo){
                                    if($motivo === 'FALTA' && $minimizadores['IDGERABENEFFALTA'] === 'N'){
                                        $MOTIVO .= $motivo.', ';
                                        $ehParaCalcular_minimizadorBeneficioOriginal = false;
                                    }else if($motivo === 'ATESTADO' && $minimizadores['IDGERABENEFATEST'] === 'N'){
                                        $MOTIVO .= $motivo.', ';
                                        $ehParaCalcular_minimizadorBeneficioOriginal = false;
                                    }else if($motivo === 'AFASTAMENTO' && $minimizadores['IDGERABENEFAFAST'] === 'N'){
                                        $MOTIVO .= $motivo.', ';
                                        $ehParaCalcular_minimizadorBeneficioOriginal = false; 
                                    }else if($motivo === 'FERIAS' && $minimizadores['IDGERABENEFFERIAS'] === 'N'){
                                        $MOTIVO .= $motivo.', ';
                                        $ehParaCalcular_minimizadorBeneficioOriginal = false;
                                    }
                                }
                                
                                if($ehParaCalcular_minimizadorBeneficioOriginal && $ehParaCalcular_minimizadorBeneficioCCT)
                                    $this->calcularBeneficio($nrcalculobenef, $subsidio100PorAfastamentoOuDemissao, $beneficio, $eventos, $beneficiario, $vinculo, $vinculo->getNrvinculom(), $qtdBeneficiariosPerEvento, $proporcao, $tpperiodo, $isLast, null, $foiCalculado, null, $eventoEparcelas);
                                else if($beneficiario->getIdtpbeneficiario() == 'T' && !$ehParaCalcular_minimizadorBeneficioOriginal){
                                    $MOTIVO = substr($MOTIVO, 0, -2);
                                    $MOTIVO .= '.';
                                    MsgCalculo::getInstance()->adicionaMensagem($MOTIVO, MsgCalculo::ALERTA);                                
                                }
                                
                            }else if($beneficiario->getIdtpbeneficiario() == 'T' && isset($dtReferenciaRescisao) && $dtReferenciaRescisao > $dtRescisaoVinc){
                                MsgCalculo::getInstance()->adicionaMensagem("Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Data de rescisão anterior ao dia ".intval($beneficio['NRDIARESCISAO'])." da competência anterior.", MsgCalculo::ALERTA);
                            }
                            
                            $isLast = false;

                        }
                        
                        $this->persistirCalculo_Mensal($foiCalculado, $nrcalculobenef, $vinculo->getNrvinculom(), $proporcao, $eventos, $qtdBeneficiariosPerEvento, $dtpagamento, $nrlotevinc, $eventoEparcelas);  // Persiste o array retornado pela função da chamada na linha anterior
                        
                        break;
                    
                    case 'DIARIO':
                        
                        $this->obterMotivosParaNaoCalcular_verificarIsencao100Afastamento($vinculo, $subsidio100PorAfastamentoOuDemissao);

                        $beneficiarios = $this->calculoBeneficioRepository->getBeneficiarioPorVinculo($nrorg, $vinculo->getNrvinculom(), $dtmescompetenc, $tpperiodo, $nrtpbeneficio, $nrestruturam);

                        foreach($beneficiarios as $beneficiario){

                            $ehParaCalcular_minimizadorBeneficioCCT = true;
                        
                            $beneficio = $this->calculoBeneficioRepository->getBeneficioPorVinculo($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficiario->getNrbeneficiom());
                            
                            $histBenefPagto = $this->retornaHistoricoBenefPagto($formulario['DTPGTOCALCBENEF'], $vinculo->getNrvinculom(), $beneficiario->getNrbeneficiom(), $dtmescompetenc, $nrorg);

                            $historicosBenef = $this->retornaHistoricoBenefEntrePeriodo($dtinicio, $dtfinal, $vinculo->getNrvinculom(), $beneficiario->getNrbeneficiom(), $dtmescompetenc, $nrorg);
                            
                            if($this->idcalccomplementar == "N"){
                                // Verifica se algum Vinculo ja possui historicos de beneficio com intersecao entre o periodo inicial e final do formulario do benef
                                if($historicosBenef){
                                    MsgCalculo::getInstance()->adicionaMensagem("Vínculo ".$vinculo->getNmvinculom()." possui o benefício ". $beneficiario->getNrbeneficiom()." já calculado no período Inicial: ".$historicosBenef[0]->getDtiniapurbenef()->format('d/m/Y')." e período final: ".$historicosBenef[0]->getDtfinapurbenef()->format('d/m/Y')." que possui data de pagamento em ".$historicosBenef[0]->getDtpgtobenef()->format('d/m/Y'), MsgCalculo::ALERTA);
                                    $instancia->salvaMensagens();
                                    $instancia->clear();
            
                                    continue;
                                }
                            }
                            
                            //Verifica data de pagamento iguais
                            if($histBenefPagto){
                                MsgCalculo::getInstance()->adicionaMensagem("Vínculo ".$vinculo->getNmvinculom()." possui o benefício ". $beneficiario->getNrbeneficiom()." já calculado com data de pagamento em ".$historicosBenef[0]->getDtpgtobenef()->format('d/m/Y'), MsgCalculo::ALERTA);
                                $instancia->salvaMensagens();
                                $instancia->clear();
        
                                continue;
                            }
                            
                            //Variável a ser comparada caso o vinculo possua liquido
                            $verificaLiquido = $this->itensCalculoService->validaLiquidoBeneficio(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $beneficio['NREVETITULARVINC'], $dtpagamento);
                            
                            // Verifica se algum Vinculo ja possui calculo de beneficio
                            if($verificaLiquido){
                                MsgCalculo::getInstance()->adicionaMensagem("Vinculo ".$vinculo->getNmvinculom()." possui o evento ". $beneficio['NREVETITULARVINC']." com a data de pagamento ".$dtpagamento, MsgCalculo::ALERTA);
                                $instancia->salvaMensagens();
                                $instancia->clear();
        
                                continue;
                            }
                            

                            // Verifica conforme o parâmetro do cadastro do benefício se ele deve ser calculado no mês corrente
                            if(substr($beneficio['PERIODICIDADEMES'],DateUtil::getDataDeString($dtmescompetenc,DateUtil::FORMATO_BRASILEIRO,true)->format('m')-1,1) == 'N'){
                                continue;
                            }
                            
                            // Caso o benefício esteja marcado para não gerar na admissão e a data de admissão do vínculo for na competência atual não gera o benefício
                            if($beneficio['IDGERBENEFADMISSAO'] == 'N' && (DateUtil::getDataDeString($vinculo->getDtadmissaovinc())->format('Ym') == DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia())->format('Ym'))){
                                $msgVinculoPossuiAdmissao = "Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Vínculo admitido no mês.";
                                MsgCalculo::getInstance()->adicionaMensagem($msgVinculoPossuiAdmissao, MsgCalculo::ALERTA);
                                continue;
                            }
                            // Caso o benefício esteja marcado para não gerar na rescisão e a data de rescisão do vínculo for na competência atual não gera o benefício
                            if($beneficio['IDGERBENEFRESCISAO'] == 'N' && $vinculo->getDtrescisaovinc() && (DateUtil::getDataDeString($vinculo->getDtrescisaovinc())->format('Ym') == DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia())->format('Ym'))){
                                $msgVinculoPossuiRescisao = "Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Vínculo rescindido no mês.";
                                MsgCalculo::getInstance()->adicionaMensagem($msgVinculoPossuiRescisao, MsgCalculo::ALERTA);
                                continue;
                            }
                            
                            // Caso vínculo tenha sindicato no histórico e tal sindicato tenha beneficio correspondente, os dados de desconto do vínculo serão a partir do benefício do sindicato.
                            // Caso vínculo tenha sindicato no histórico e tal sindicato não tenha benefício, os dados de desconto do vínculo serão a partir do benefício original.
                            if(intval($histVinc['NRESTRUTSIND'])) {
                                $benefDescontoSind = $this->calculoBeneficioRepository->getBeneficioDescontoSind($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficio['NRTPBENEFICIO'], intval($histVinc['NRESTRUTSIND']));
                                if(isset($benefDescontoSind) && !empty($benefDescontoSind)) $this->mergeBeneficioComBeneficioSind($beneficio, $benefDescontoSind);
                            }   

                            $tpBeneficio = $this->entityManager->getRepository(Repositories::TPBENEFICIO)->findBy(array('nrtpbeneficio'=>$beneficio['NRTPBENEFICIO'], 'nrorg'=>[$this->hcmParameters->getNrorgPadrao(), $this->hcmParameters->getNrorgTrabalho()]));
                            if(is_array($tpBeneficio))$tpBeneficio = $tpBeneficio[0];

                            $this->verificarIsencao100Demissao($subsidio100PorAfastamentoOuDemissao, $beneficio['CONSVINCRESMESANT'], $vinculo, $dtRescisaoVinc, $competenciaAtual);

                            $dtReferenciaRescisao = null; // Caso tenha valor, seu valor será a data da competência anterior referente ao dia informado no campo 'Rescindidos a partir do dia'
                            if( isset($beneficio['NRDIARESCISAO']) && !empty($beneficio['NRDIARESCISAO']) ){
                                $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
                                $dtReferenciaRescisao = clone $objCompetenc; 
                                $dtReferenciaRescisao->sub(new \DateInterval('P1M'));
                                $dtReferenciaRescisao->add(new \DateInterval('P'.( intval($beneficio['NRDIARESCISAO']) -1 ).'D'));
                                $dtReferenciaRescisao = $dtReferenciaRescisao->format('Y-m-d');   
                            }

                            if(     
                                    ( 
                                        $beneficio['CONSVINCRESMESANT'] == 'S' // Calcula apenas se é para considerar vinculos com rescisão do mês anterior.
                                        && (
                                              !isset($dtReferenciaRescisao) // Se for considerar vínculos com rescisão do mês anterior, qualquer vínculo será calculado caso o campo 'Rescindidos até o dia' esteja vazio
                                              || $dtRescisaoVinc >= $dtReferenciaRescisao // Ou caso este esteja preenchido, considerará apenas os vínculos com data de rescisão a partir do dia informado no campo
                                           )
                                    )    
                                || !$dtRescisaoVinc                           // Se não for para considerar vinculos com rescisão do mês anterior, calculará o benefício se não houver data de rescisão do vínculo
                                || ($dtRescisaoVinc >= $competenciaAtual) // ou se a data de rescisão for maior que a competencia atual
                            ) {
                                
                                $minimizadores = $this->obterMinimizadoresDiario($beneficio);

                                $arrayDiasCalculados = $this->calcularDias($vinculo, $beneficiario, $minimizadores, $dtinicio, $dtfinal, $dtpagamento, $qtdiasbenef); // Retorna array com o cálculo dos dias pertinentes para o Cálculo de Benefício Diário
                                
                                $this->validarMinimizadoresBeneficioCCT($beneficio, $tpBeneficio, $vinculo, $beneficiario, $minimizadores, $ehParaCalcular_minimizadorBeneficioCCT, $subsidio100PorAfastamentoOuDemissao);

                                //$arrayDiasCalculados['DIASCONSIDERACAO'] = !empty($qtdiasbenef) ? $qtdiasbenef : $arrayDiasCalculados['DIASCONSIDERACAO'];//Caso os dias estejam preenchidos no formulário do cálculo, o dado do formulário prevalece
                                
                                if($arrayDiasCalculados['DIASCONSIDERACAO'] > 0 && $ehParaCalcular_minimizadorBeneficioCCT)
                                    // Calcula o Benefício e o Persiste, apenas se a quantidades de dias de consideração for maior que 0.
                                    $this->calcularBeneficio($nrcalculobenef, $subsidio100PorAfastamentoOuDemissao, $beneficio, $eventos, $beneficiario, $vinculo, $vinculo->getNrvinculom(), $qtdBeneficiariosPerEvento, 1/*proporcao=1*/, $tpperiodo, false, $arrayDiasCalculados, $foiCalculado); // Dentro desta função é que se persiste o histórico diário
                                else if($arrayDiasCalculados['DIASCONSIDERACAO'] <= 0)
                                    MsgCalculo::getInstance()->adicionaMensagem('Nenhum Benefício calculado para o vínculo '.$vinculo->getNmvinculom().'. Ele(a) não possui dias de consideração.', MsgCalculo::ALERTA);
                                
                                // Para não acumular os valores dos eventos, o array de eventos é resetado para vazio. 
                                // Já que no histórico é persistido também por benefício. E não há dependentes do Titular.
                                $eventos = [];
    
                            }else if($beneficiario->getIdtpbeneficiario() == 'T' && isset($dtReferenciaRescisao) && $dtReferenciaRescisao > $dtRescisaoVinc){
                                MsgCalculo::getInstance()->adicionaMensagem("Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Data de rescisão anterior ao dia ".intval($beneficio['NRDIARESCISAO'])." da competência anterior.", MsgCalculo::ALERTA);
                                // else if($dtRescisaoVinc < $competenciaAtual)
                                //     MsgCalculo::getInstance()->adicionaMensagem("Benefício ".$beneficio['NRBENEFICIOM']." não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Data de rescisão anterior à competência vigente.", MsgCalculo::ALERTA);
                            }    

                        }

                        break;
                }
                
                MemoriaBeneficio::getInstance()->concatenarMensagemVinc();
                $instancia->salvaMensagens();
                $instancia->clear();
            }
            
            MemoriaBeneficio::getInstance()->salvarMsgArquivo();
            
            if($this->idMemoria == 'S') 
            $this->response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('memoriaCalculo', array(MemoriaBeneficio::getInstance()->getCaminhoArquivo())));

            return $foiCalculado;
            
        } catch (\Exception $e) {
            throw $e; 
        }
    }
    
    private function retornaHistoricoBenefPagto($dtpgtobenef, $vinculo, $nrbeneficiom, $dtmescompetenc, $nrorg){
        try{
            $param = array(
                'P_NRORG'          => $nrorg,
                'P_NRBENEFICOM'     => $nrbeneficiom,
                'P_DTMESCOMPETENC'  => $dtmescompetenc,
                'P_DTPGTOBENEF'     => "$dtpgtobenef"
            );
            
            $historicos = VabHistbenefvinc::getObjectsByWhere(
                "NRORG = :P_NRORG AND
                DTMESCOMPETENC = :P_DTMESCOMPETENC AND 
                DTPGTOBENEF = :P_DTPGTOBENEF AND
                (NRBENEFICIOM = :P_NRBENEFICOM) AND
                NRVINCULOM IN ($vinculo)", $param
            );

            if($historicos){
                return $historicos;
            } else {
                return array();
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function retornaHistoricoBenefEntrePeriodo($dtinicio, $dtfinal, $vinculo, $nrbeneficiom, $dtmescompetenc, $nrorg){
        try{
            $param = array(
                'P_NRORG'          => $nrorg,
                'P_NRBENEFICOM'     => $nrbeneficiom,
                'P_DTMESCOMPETENC'  => $dtmescompetenc,
                'P_DTINIAPURBENEFFORM' => $dtinicio,
                'P_DTFIMAPURBENEFFORM' => $dtfinal
            );
            
            $historicos = VabHistbenefvinc::getObjectsByWhere(
                "NRORG = :P_NRORG AND
                DTMESCOMPETENC = :P_DTMESCOMPETENC AND 
                DTINIAPURBENEF <= :P_DTFIMAPURBENEFFORM AND 
                DTFINAPURBENEF >= :P_DTINIAPURBENEFFORM AND
                (NRBENEFICIOM = :P_NRBENEFICOM) AND
                NRVINCULOM IN ($vinculo)", $param
            );
            
            if($historicos){
                return $historicos;
            } else {
                return array();
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function validarMinimizadoresBeneficioCCT($beneficio, $tpBeneficio, $vinculo, $beneficiario, $minimizadores, &$ehParaCalcular_minimizadorBeneficioCCT, &$subsidio100PorAfastamentoOuDemissao){
        
        // ===== CAMPO(S): "Gera Benefício somente para vínculos com mais de x dias trabalhados no mês"    
        // - Função responsável por calcular a quantidade de dias trabalhados no mês para validar minimizador do Benefício CCT. 
        // - '$diasTrabalhadosAdmissaoRescisao' terá valor apenas se a competência corrente é da admissão, rescisão ou ambos.
        $tpCompetencia = null;
        $diasTrabalhadosAdmissaoRescisao = $this->calcularDiasTrabalhadosMesAdmissaoRescisao($beneficio, $vinculo, $tpCompetencia);
        $diasFaltas = $this->calcularDiasFaltas($minimizadores, $beneficio, $vinculo);
        $diasAtestados = $this->calcularDiasAtestados($minimizadores, $beneficio, $vinculo);
        $diasAfastamentosMemoria = $this->calcularDiasAfastamentos($minimizadores, $beneficio, $vinculo);
        $diasAfastamentos = 0;
        $diasTrabalhados = ( $diasTrabalhadosAdmissaoRescisao - $diasFaltas - $diasAfastamentos );

        $beneficio['DIASTRABALHADOSTOTAL'] = $diasTrabalhadosAdmissaoRescisao;
        $beneficio['DIASAFASTAMENTOS'] = $diasAfastamentosMemoria;
        $beneficio['DIASATESTADO'] = $diasAtestados;
        $beneficio['DIASFALTAS'] = $diasFaltas;
        $beneficio['DIASTRABALHADOS'] = $diasTrabalhados;
        
        MemoriaBeneficio::getInstance()->setInfoBenefVinc($beneficio);
        
        // ===== CAMPO(S): "Gera Benefício somente para vínculos com mais de x dias trabalhados no mês:" e "Retroceder quantos meses para apurar os dias trabalhados (frente ao período)?"    
        // - Responsavel por verificar a quantidade de dias trabalhados se esta maior do que a quantidade minima para o beneficio
        if( isset($beneficio['QTDIASMINMES']) && intval($beneficio['QTDIASMINMES'])>0 && isset($diasTrabalhados) && $diasTrabalhados <= intval($beneficio['QTDIASMINMES']) ){
            $ehParaCalcular_minimizadorBeneficioCCT = false;
            if($beneficiario->getIdtpbeneficiario() == 'T'){
                $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Na atual competencia que é de sua $tpCompetencia ele trabalhou ".$diasTrabalhados." dias quando precisaria trabalhar mais que ".$beneficio['QTDIASMINMES']." dias." ;
                MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
            }    
        }
        
        // ===== CAMPO(S): "Não gerar benefícios para vínculos com mais de x faltas:" e "Retroceder quantos meses para apurar as faltas (frente ao período)?"    
        // - Função responsável por calcular a quantidade de faltas na competência informada pelo minimizador diário para validar minimizador do Benefício CCT
        //$diasFaltas = $this->calcularDiasFaltas($minimizadores, $beneficio, $vinculo);
        
        if( isset($beneficio['QTDIASMAXFALTAS']) && intval($beneficio['QTDIASMAXFALTAS'])>0 && $diasFaltas > intval($beneficio['QTDIASMAXFALTAS']) ){
            $ehParaCalcular_minimizadorBeneficioCCT = false;
            if($beneficiario->getIdtpbeneficiario() == 'T'){
                $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
                $dtmescomp_falta = DateUtil::getPrimeiroDiaDoMes( $objCompetenc->sub(new \DateInterval('P'.$minimizadores['QTMESESFALTABENEF'].'M')) )->format('d/m/Y');
                $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Ele faltou ".$diasFaltas." dias na competência ".$dtmescomp_falta.", quando não poderia faltar mais que ".$beneficio['QTDIASMAXFALTAS']." dias." ;
                MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
            }    
        }
        
        // ===== CAMPO(S): "Não gerar benefícios para vínculos com mais de x atestados:" e "Retroceder quantos meses para apurar os atestados (frente ao período)?"
        // - Função responsável por calcular a quantidade de faltas na competência informada pelo minimizador diário para validar minimizador do Benefício CCT
        //$diasAtestados = $this->calcularDiasAtestados($minimizadores, $beneficio, $vinculo);
        
        if( isset($beneficio['QTDIASMAXATEST']) && intval($beneficio['QTDIASMAXATEST'])>0 && $diasAtestados > intval($beneficio['QTDIASMAXATEST']) ){
            $ehParaCalcular_minimizadorBeneficioCCT = false;
            if($beneficiario->getIdtpbeneficiario() == 'T'){
                $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
                $dtmescomp_atest = DateUtil::getPrimeiroDiaDoMes( $objCompetenc->sub(new \DateInterval('P'.(string)$minimizadores['QTMESESATESTBENEF'].'M')) )->format('d/m/Y');
                $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Ele teve
                ".$diasAtestados." atestados na competência ".$dtmescomp_atest.", quando não poderia ter mais que ".$beneficio['QTDIASMAXATEST']." atestados." ;
                MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
            }
        }
        
        
        // ===== CAMPO(S): "Situação Funcional Afastamento 1", "Até Quantos Meses de Afastamento 1" e "Gera Desconto 1"    
        // - Escopo responsável por validar os minimizadores relativos a afastamentos 1 do beneficio CCT 
        $dadosRetornoAfast = array();
        if(isset($beneficio['DSAFASTAMENTO1']) && !empty($beneficio['DSAFASTAMENTO1'])) $dadosRetornoAfast = $this->obterDadosAfastValidarCalc($beneficio['DSAFASTAMENTO1'], $beneficio['QTMESMAXAFAST'], $beneficio['IDGERADESCAFAST1'], $beneficio, $vinculo); // Função responsável por obter dados de afastamento do vínculo a fim de validar minimizador do Benefício CCT
        $this->validarMinimizadorCCTAfastamento($dadosRetornoAfast, $beneficio, $tpBeneficio, $vinculo,$beneficiario,  $ehParaCalcular_minimizadorBeneficioCCT, $subsidio100PorAfastamentoOuDemissao);
        
        // ===== CAMPO(S): "Situação Funcional Afastamento 2", "Até Quantos Meses de Afastamento 2" e "Gera Desconto 2"    
        // - Escopo responsável por validar os minimizadores relativos a afastamentos 2 do beneficio CCT 
        $dadosRetornoAfast = array();
        if(isset($beneficio['DSAFASTAMENTO2']) && !empty($beneficio['DSAFASTAMENTO2'])) $dadosRetornoAfast = $this->obterDadosAfastValidarCalc($beneficio['DSAFASTAMENTO2'], $beneficio['QTMESMAXAFAST2'], $beneficio['IDGERADESCAFAST2'], $beneficio, $vinculo); // Função responsável por obter dados de afastamento do vínculo a fim de validar minimizador do Benefício CCT
        $this->validarMinimizadorCCTAfastamento($dadosRetornoAfast, $beneficio, $tpBeneficio, $vinculo,$beneficiario,  $ehParaCalcular_minimizadorBeneficioCCT, $subsidio100PorAfastamentoOuDemissao);

        // ===== CAMPO(S): "Situação Funcional Não Gera Benefício"    
        // - Escopo responsável por validar os minimizadores relativos às situações que não geram benefício
        $ultimaSituFunc = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaUltimaSituacaoPorDatainicio( $this->hcmParameters->getNrorgTrabalho(), $vinculo->getNrvinculom(), substr($this->hcmParameters->getUltimoDiaMes(), 0, 10) );
        $listSituFunc = isset($beneficio['DSAFASTAMENTO3']) && !empty($beneficio['DSAFASTAMENTO3']) ? explode(", ", $beneficio['DSAFASTAMENTO3']) : null;
        if( isset($listSituFunc) && in_array($ultimaSituFunc->getNrsitufuncm(), $listSituFunc)){
            $ehParaCalcular_minimizadorBeneficioCCT = false;
            if($beneficiario->getIdtpbeneficiario() == 'T'){
                $situFuncH = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->retornaUltimoHistoricoCompetencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getNrorgPadrao(), 
                    $ultimaSituFunc->getNrsitufuncm(), 
                    $this->hcmParameters->getDtCompetencia()
                );
                $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Sua atual situação funcional é '".$situFuncH->getNmsitufunch()."', quando não poderia ser." ;
                MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
            }    
        }
        
        // ===== CAMPO(S): "Perderão o benefício por possuírem os seguintes eventos:" e "Retroceder quantos meses para apurar os eventos (frente ao período)?"    
        // - Escopo responsável por validar os minimizadores do Beneficio CCT relativos a perda de benefícios por existências de determinados eventos
        $dadosRetornoValidEventos = array();
        if(isset($beneficio['DSINCIDEVENPERDER']) && !empty($beneficio['DSINCIDEVENPERDER'])){
            $dadosRetornoValidEventos = $this->retornaEventosFolhaMensal($vinculo, $beneficio['DSINCIDEVENPERDER'], $beneficio['QTMESRETROCSEMBEN']);
        }

        if(isset($dadosRetornoValidEventos) && !empty($dadosRetornoValidEventos) && $dadosRetornoValidEventos['geraBeneficio'] == false){
            $listaEventos = implode(", ", $dadosRetornoValidEventos['listaEventos']);
            $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Ele teve na folha da competência '".$dadosRetornoValidEventos['competenciaRef']."' o(s) seguinte(s) evento(s) '".$listaEventos."'." ;   
            if($beneficiario->getIdtpbeneficiario() == 'T') MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
            $ehParaCalcular_minimizadorBeneficioCCT = false;
        }
        
        // ===== CAMPO(S): "Não gera benefício para vínculos em período de experiência"
        // - Escopo responsável por validar os minimizadores do Beneficio CCT relativos a perda de benefícios por existências de determinados eventos
        if($beneficio['IDNAOGERBENVINCEXP'] == 'S'){
            $histVinc = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->_retornaHistórico($vinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), $this->hcmParameters->getDtCompetencia());
            
            $dtAtual = $dtFimContratExpe = null;

            $dtAtual = DateUtil::getDataDeString( substr(DateUtil::getDataAtual(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if(isset($histVinc['DTFIMCONTRDETERMIN']) && !empty($histVinc['DTFIMCONTRDETERMIN']))
                $dtFimContratExpe = DateUtil::getDataDeString(substr($histVinc['DTFIMCONTRDETERMIN'], 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if($dtFimContratExpe && $dtAtual->format('Y/m/d') <= $dtFimContratExpe->format('Y/m/d')){
                $msg = "Benefício '".$tpBeneficio->getDstpbeneficio()."' não calculado para o vínculo '".$vinculo->getNmvinculom()."'. Ele(a) está no período de experiência.";
                MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
                $ehParaCalcular_minimizadorBeneficioCCT = false;
            }
        }
    }
    
    private function retornaEventosFolhaMensal($vinculo, $listEventos, $qtdeMesRetroc, $incluiTodosMeses=false){
        
        if(!isset($qtdeMesRetroc) || empty($qtdeMesRetroc)) $qtdeMesRetroc = 0;
        
        if($incluiTodosMeses){
            $dadosRetorno = array(
                                "listaEventos" => [],
                                "geraBeneficio" => true,
                                "consideraMultiplicador" => true,
                                "competenciaRef" => [],
                            );
            
            for($i = 0; $i <= $qtdeMesRetroc; $i++){
                $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
                $objCompReferencia = DateUtil::getPrimeiroDiaDoMes( $objCompetenc->sub(new \DateInterval('P'.(string)$i.'M')) );
                
                $nrCalculoFolha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getNrCalculo($this->hcmParameters->getNrorgTrabalho(), $objCompReferencia->format('d/m/Y'), 1);
                    
                if(isset($nrCalculoFolha)) $itensCalc = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->retornaItemPeriodo($this->hcmParameters->getNrorgTrabalho(), $vinculo->getNrvinculom(), $nrCalculoFolha, $listEventos);
                
                if($itensCalc){
                    foreach($itensCalc as $item){
                        if($item->getVreventofolha() && $item->getVreventofolha() > 0){
                            $dadosRetorno['geraBeneficio'] = false;
                            $dadosRetorno['consideraMultiplicador'] = false;
                            if(!in_array($item->getNreventom(),$dadosRetorno['listaEventos'])){
                                $dadosRetorno['listaEventos'][] = $item->getNreventom();
                            }
                            $dadosRetorno['competenciaRef'][] = $objCompReferencia->format('d/m/Y');
                        }
                    }
                }
            }
        }else{
            $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
            $objCompReferencia = DateUtil::getPrimeiroDiaDoMes( $objCompetenc->sub(new \DateInterval('P'.(string)$qtdeMesRetroc.'M')) );
    
            $dadosRetorno = array(
                                "listaEventos" => [],
                                "geraBeneficio" => true,
                                "consideraMultiplicador" => true,
                                "competenciaRef" => $objCompReferencia->format('d/m/Y'),
                            );
            
            $nrCalculoFolha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getNrCalculo($this->hcmParameters->getNrorgTrabalho(), $objCompReferencia->format('d/m/Y'), 1);
                
            if(isset($nrCalculoFolha)) $itensCalc = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->retornaItemPeriodo($this->hcmParameters->getNrorgTrabalho(), $vinculo->getNrvinculom(), $nrCalculoFolha, $listEventos);
            
            if($itensCalc){
                foreach($itensCalc as $item){
                    if($item->getVreventofolha() && $item->getVreventofolha() > 0){
                        $dadosRetorno['geraBeneficio'] = false;
                        $dadosRetorno['consideraMultiplicador'] = false;
                        $dadosRetorno['listaEventos'][] = $item->getNreventom();
                    }
                }
            }
        }
        
        return $dadosRetorno;
    }
    
    private function calcularDiasTrabalhadosMesAdmissaoRescisao($beneficio, $vinculo, &$tpCompetencia){
        $dtAdmissaoVinc = DateUtil::getDataDeString( substr($vinculo->getDtadmissaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $dtRescisaoVinc = DateUtil::getDataDeString( substr($vinculo->getDtrescisaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        
        // ===== CAMPO(S): "Gera Benefício somente para vínculos com mais de x dias trabalhados no mês:" e "Retroceder quantos meses para apurar os dias trabalhados (frente ao período)?"    
        // - Função responsável por calcular a quantidade de dias trabalhados na competência informada pelo minimizador diário para validar minimizador do Benefício CCT
        $objRetrocedido = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        if(!empty($beneficio['QTDIASMINMES'] && (!empty($beneficio['QTMESRETROCDIASTRAB']) && $beneficio['QTMESRETROCDIASTRAB'] > 0) )){
            $objRetrocedido = $objRetrocedido->sub(new \DateInterval('P'.$beneficio['QTMESRETROCDIASTRAB'].'M'));
        }
        
        $diasTrabalhados = null;
        
        if( $dtAdmissaoVinc->format('Y/m') == $objCompetenc->format('Y/m') || (isset($dtRescisaoVinc) && $dtRescisaoVinc->format('Y/m') == $objCompetenc->format('Y/m')) ) {

            // Calculará a quatidade de dias trabalhados nos seguintes casos:
            if( $dtAdmissaoVinc->format('Y/m') == $objCompetenc->format('Y/m') && ( isset($dtRescisaoVinc) && $dtRescisaoVinc->format('Y/m') == $objCompetenc->format('Y/m')) ){ // Caso admissão e rescisão estejam na competência
                $diasTrabalhados = intval( $dtRescisaoVinc->format('d') ) - intval($dtAdmissaoVinc->format('d')) + 1;                                         
                $tpCompetencia = "'Admissão/Rescisão'";
            }elseif( $dtAdmissaoVinc->format('Y/m') == $objCompetenc->format('Y/m') ){ // Caso apenas admissão esteja na competência
                // Caso o mês seja fevereiro considera 30 dias da mesma forma que a base da folha de pagamento
                if( $objCompetenc->format('m') == '02' ){
                    $ultimoDiaComp = 30;
                }else{
                    $ultimoDiaComp = intval( $objCompetenc->format('t') );
                }
                $diasTrabalhados = $ultimoDiaComp - intval($dtAdmissaoVinc->format('d')) + 1; 
                $tpCompetencia = "'Admissão'";
            }elseif ( isset($dtRescisaoVinc) && $dtRescisaoVinc->format('Y/m') == $objCompetenc->format('Y/m') ){ // Caso apenas rescisão esteja na competência
                $diasTrabalhados = intval( $dtRescisaoVinc->format('d') ) - intval($objCompetenc->format('d')) + 1;
                $tpCompetencia = "'Rescisão'";
            }    
        }else{
            $diasTrabalhados = $objRetrocedido->format('m') == '02' ? 30 : intval( $objRetrocedido->format('t') ); // Caso o mês seja fevereiro considera 30 dias da mesma forma que a base da folha de pagamento
        }
        
        return $diasTrabalhados;
    }
    
    private function calcularDiasFaltas($minimizadores, $beneficio, $vinculo){
        $diasFaltas = 0;
        $this->dtiniperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);

        if($minimizadores['IDCONSFALTABENEF'] == 'S' && isset($minimizadores['QTMESESFALTABENEF']))
            $this->calcularQtdeFaltas($diasFaltas, $minimizadores['QTMESESFALTABENEF'], $vinculo->getNrvinculom(), $vinculo);
        else
            $this->calcularQtdeFaltas($diasFaltas, 0, $vinculo->getNrvinculom(), $vinculo);
            
        return $diasFaltas;
    }
    
    private function calcularDiasAtestados($minimizadores, $beneficio, $vinculo){
        $diasAtestado= 0;
        $this->dtiniperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        $this->dtfimperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getUltimoDiaMes(), DateUtil::FORMATO_BRASILEIRO, true);
        
        if($minimizadores['IDCONSATESTBENEF'] == 'S' && isset($minimizadores['QTMESESATESTBENEF']))
            $this->calcularQtdeDias_AtesOuAfast( $diasAtestado, 'ATESTADO', $minimizadores['QTMESESATESTBENEF'], $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);
        else
            $this->calcularQtdeDias_AtesOuAfast( $diasAtestado, 'ATESTADO', 0, $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);
        
        // Caso não encontre atestados nas situações funcionais do vínculo verifica a referência dos eventos de atestado nos lançamentos de folha 
        if($diasAtestado == 0){
            $this->dtiniperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
            $this->calcularQtdeAtestados($diasAtestado, $minimizadores['QTMESESATESTBENEF'], $vinculo->getNrvinculom());
        }
            
        return $diasAtestado;
    }
    
    private function calcularDiasAfastamentos($minimizadores, $beneficio, $vinculo){
        $diasAfastamento= 0;
        $this->dtiniperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        $this->dtfimperiodobenef = DateUtil::getDataDeString($this->hcmParameters->getUltimoDiaMes(), DateUtil::FORMATO_BRASILEIRO, true);
        
        //Passa o $id_tpCalc = null para considerar todas situações funcionais que não geram vale/benefício (calcularQtdeDias_AtesOuAfast)
        if($minimizadores['IDCONSATESTBENEF'] == 'S' && isset($minimizadores['QTMESESATESTBENEF']))
            $this->calcularQtdeDias_AtesOuAfast( $diasAfastamento, null, $minimizadores['QTMESESATESTBENEF'], $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);
        else
            $this->calcularQtdeDias_AtesOuAfast( $diasAfastamento, null, 0, $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);
            
        return $diasAfastamento;
    }
    
    private function obterDadosAfastValidarCalc($listSituFunc, $refQtdeMes, $geraDesconto, $beneficio, $vinculo){

        //$ultAfastamento = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaUltimoAfastamento($this->hcmParameters->getNrorgTrabalho(), $this->hcmParameters->getNrorgPadrao(), $vinculo->getNrvinculom(), $this->hcmParameters->getDtCompetencia());
        $listSituFunc = explode(", ", $listSituFunc);
        $dadosRetorno = array();

        $ultimaSituFunc = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaUltimaSituacaoPorDatainicio( $this->hcmParameters->getNrorgTrabalho(), $vinculo->getNrvinculom(), substr($this->hcmParameters->getUltimoDiaMes(), 0, 10) );

        foreach($listSituFunc as $nrSituFunc){
            
            if($ultimaSituFunc->getNrsitufuncm() == $nrSituFunc){
                $qtdeMesPosAfast = $this->obterQtdeMesesPosAfastamento($ultimaSituFunc);
                $situFuncH = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->retornaUltimoHistoricoCompetencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getNrorgPadrao(), 
                    $ultimaSituFunc->getNrsitufuncm(), 
                    $this->hcmParameters->getDtCompetencia()
                );
    
                // Quando a quantidade de meses do afastamento for menor ou igual a quantidade de meses a se considerar                
                if(!is_null($qtdeMesPosAfast) && $qtdeMesPosAfast <= $refQtdeMes && $refQtdeMes != 0){ 
                    
                    $dadosRetorno[] = array(
                                            "qtdeMesesPosAfast" => $qtdeMesPosAfast,
                                            "qtdeMesesRef" => $refQtdeMes,
                                            "nomeSituFunc" => $situFuncH->getNmsitufunch(),
                                            "geraDesconto" => $geraDesconto,
                                            "geraBeneficio" => 'S',
                                            "dtIniSituFunc" => $ultimaSituFunc->getDtinisitufunc()->format('d/m/Y'),
                                      );
                }else{
                    $dadosRetorno[] = array(
                                            "qtdeMesesPosAfast" => $qtdeMesPosAfast,
                                            "qtdeMesesRef" => $refQtdeMes,
                                            "nomeSituFunc" => $situFuncH->getNmsitufunch(),
                                            "geraDesconto" => $geraDesconto,
                                            "geraBeneficio" => 'N',
                                            "dtIniSituFunc" => $ultimaSituFunc->getDtinisitufunc()->format('d/m/Y'),
                                      );
                }
            }
        }
        
        return $dadosRetorno;
    }

    private function validarMinimizadorCCTAfastamento($dadosRetornoAfast, $beneficio, $tpBeneficio, $vinculo, $beneficiario, &$ehParaCalcular_minimizadorBeneficioCCT, &$subsidio100PorAfastamentoOuDemissao){
        if(count($dadosRetornoAfast) > 0){
            $geraBeneficio = true;

            //Verifica se é ou não é para gerar beneficio
            foreach($dadosRetornoAfast as $dado){
                if($dado['geraBeneficio'] == 'N'){
                    $msg = "Benefício DO SINDICADO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO GERADO para o vínculo '".$vinculo->getNmvinculom()."'. Passou-se ".$dado['qtdeMesesPosAfast']." mes(es) após o início do(a) '".$dado["nomeSituFunc"]."' iniciado(a) em '".$dado['dtIniSituFunc']."', quando não poderia ter passado mais de ".$dado['qtdeMesesRef']." mes(es)." ;
                    if($beneficiario->getIdtpbeneficiario() == 'T') MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
                    $ehParaCalcular_minimizadorBeneficioCCT = $geraBeneficio  = false;
                }
            }
            
            //Verifica se é ou não é para descontar ou não o beneficio
            if($geraBeneficio){
                foreach($dadosRetornoAfast as $dado){
                    if($dado['geraBeneficio'] == 'S' && $dado['geraDesconto'] == 'N'){
                        $msg = "Benefício DO SINDICATO do tipo '".$tpBeneficio->getDstpbeneficio()."' NÃO DESCONTADO do vínculo '".$vinculo->getNmvinculom()."'. Passou-se ".$dado['qtdeMesesPosAfast']." mes(es) após o início do(a) '".$dado["nomeSituFunc"]."', quando o limite para isso é ".$dado['qtdeMesesRef']." mes(es)." ;
                        if($beneficiario->getIdtpbeneficiario() == 'T') MsgCalculo::getInstance()->adicionaMensagem($msg, MsgCalculo::ALERTA);
                        // caso não seja para descontar, a variável abaixo é atualizado com o valor verdadeiro
                        $subsidio100PorAfastamentoOuDemissao = true;
                    }
                }                  
            }
        }
    }
   
    private function obterQtdeMesesPosAfastamento($alteSituacaoFunc){
        $qtdeMesesPosUltAfast = null;
        
        $objCompetenc = DateUtil::getDataDeString($this->hcmParameters->getUltimoDiaMes(), DateUtil::FORMATO_BRASILEIRO, true);
        $objDtIniAfast = DateUtil::getDataDeString( substr($alteSituacaoFunc->getDtinisitufunc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        //$mesUltAfast = $objDtIniAfast->format('d/m/Y'); // Variável cujo únivo fim é agregar valor à mensagem de feedBack ao usuário do sistema.
        
        if($objDtIniAfast && $objDtIniAfast->format('Y/m/d') <= $objCompetenc->format('Y/m/d')){
            $objDtIniAfast = DateUtil::getDataDeString(DateUtil::getPrimeiroDiaDoMes($objDtIniAfast)->format('d/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
            $diff = $objCompetenc->diff($objDtIniAfast, true);   
            $qtdeMesesPosUltAfast = ($diff->m + $diff->y*12);
            $qtdeMesesPosUltAfast ++; //Considerar o próprio mês que é tirado na subtração
        }

        return $qtdeMesesPosUltAfast;
    }
    
    private function mergeBeneficioComBeneficioSind(&$beneficio, &$benefDescontoSind){
        // Campos específicos existentes apenas no Benefício do CCT
        $beneficio['QTDIASMINMES']          = isset($benefDescontoSind['QTDIASMINMES'])       && !empty($benefDescontoSind['QTDIASMINMES'])       ? $benefDescontoSind['QTDIASMINMES']        : null;     
        $beneficio['QTDIASMAXFALTAS']       = isset($benefDescontoSind['QTDIASMAXFALTAS'])    && !empty($benefDescontoSind['QTDIASMAXFALTAS'])    ? $benefDescontoSind['QTDIASMAXFALTAS']     : null;
        $beneficio['QTDIASMAXATEST']        = isset($benefDescontoSind['QTDIASMAXATEST'])     && !empty($benefDescontoSind['QTDIASMAXATEST'])     ? $benefDescontoSind['QTDIASMAXATEST']      : null;     
        $beneficio['QTMESMAXAFAST']         = isset($benefDescontoSind['QTMESMAXAFAST'])      && !empty($benefDescontoSind['QTMESMAXAFAST'])      ? $benefDescontoSind['QTMESMAXAFAST']       : null;     
        $beneficio['VRMULTIPLICADOR']       = isset($benefDescontoSind['VRMULTIPLICADOR'])    && !empty($benefDescontoSind['VRMULTIPLICADOR'])    ? $benefDescontoSind['VRMULTIPLICADOR']     : null;     
        $beneficio['DSVINCULOEMPREG']       = isset($benefDescontoSind['DSVINCULOEMPREG'])    && !empty($benefDescontoSind['DSVINCULOEMPREG'])    ? $benefDescontoSind['DSVINCULOEMPREG']     : null;     
        $beneficio['DSINCIDEVENTO']         = isset($benefDescontoSind['DSINCIDEVENTO'])      && !empty($benefDescontoSind['DSINCIDEVENTO'])      ? $benefDescontoSind['DSINCIDEVENTO']       : null;
        $beneficio['VRFIXACRESDESC']        = isset($benefDescontoSind['VRFIXACRESDESC'])     && !empty($benefDescontoSind['VRFIXACRESDESC'])     ? $benefDescontoSind['VRFIXACRESDESC']      : null;     
        $beneficio['VRPERACRESCDESC']       = isset($benefDescontoSind['VRPERACRESCDESC'])    && !empty($benefDescontoSind['VRPERACRESCDESC'])    ? $benefDescontoSind['VRPERACRESCDESC']     : null;     
        $beneficio['IDNAOGERBENVINCEXP']    = isset($benefDescontoSind['IDNAOGERBENVINCEXP']) && !empty($benefDescontoSind['IDNAOGERBENVINCEXP']) ? $benefDescontoSind['IDNAOGERBENVINCEXP']  : 'N';     
        $beneficio['IDNAOGERABENPEREXP']    = isset($benefDescontoSind['IDNAOGERABENPEREXP']) && !empty($benefDescontoSind['IDNAOGERABENPEREXP']) ? $benefDescontoSind['IDNAOGERABENPEREXP']  : null;     
        $beneficio['IDNAOGERABENRESC']      = isset($benefDescontoSind['IDNAOGERABENRESC'])   && !empty($benefDescontoSind['IDNAOGERABENRESC'])   ? $benefDescontoSind['IDNAOGERABENRESC']    : null;     
        $beneficio['NRBENEFICIOCCT']        = isset($benefDescontoSind['NRBENEFICIOCCT'])     && !empty($benefDescontoSind['NRBENEFICIOCCT'])     ? $benefDescontoSind['NRBENEFICIOCCT']      : null;     

        $beneficio['QTMAXHSREDUZIDA']       = isset($benefDescontoSind['QTMAXHSREDUZIDA'])    && !empty($benefDescontoSind['QTMAXHSREDUZIDA'])    ? intval($benefDescontoSind['QTMAXHSREDUZIDA'])    : null;
        $beneficio['VRHSREDUZIDA']          = isset($benefDescontoSind['VRHSREDUZIDA'])       && !empty($benefDescontoSind['VRHSREDUZIDA'])       ? floatval($benefDescontoSind['VRHSREDUZIDA'])     : null;
        $beneficio['DSINCIDEVENPERDER']     = isset($benefDescontoSind['DSINCIDEVENPERDER'])  && !empty($benefDescontoSind['DSINCIDEVENPERDER'])  ? $benefDescontoSind['DSINCIDEVENPERDER']          : null;
        $beneficio['QTMESRETROCMULT']       = isset($benefDescontoSind['QTMESRETROCMULT'])    && !empty($benefDescontoSind['QTMESRETROCMULT'])    ? intval($benefDescontoSind['QTMESRETROCMULT'])    : null;
        $beneficio['QTMESRETROCSEMBEN']     = isset($benefDescontoSind['QTMESRETROCSEMBEN'])  && !empty($benefDescontoSind['QTMESRETROCSEMBEN'])  ? intval($benefDescontoSind['QTMESRETROCSEMBEN'])  : null;
        $beneficio['QTMESRETROCDIASTRAB']   = isset($benefDescontoSind['QTMESRETROCDIASTRAB'])  && !empty($benefDescontoSind['QTMESRETROCDIASTRAB'])  ? intval($benefDescontoSind['QTMESRETROCDIASTRAB'])  : null;
        $beneficio['DSAFASTAMENTO1']        = isset($benefDescontoSind['DSAFASTAMENTO1'])     && !empty($benefDescontoSind['DSAFASTAMENTO1'])     ? $benefDescontoSind['DSAFASTAMENTO1']             : null;
        $beneficio['IDGERADESCAFAST1']      = isset($benefDescontoSind['IDGERADESCAFAST1'])   && !empty($benefDescontoSind['IDGERADESCAFAST1'])   ? $benefDescontoSind['IDGERADESCAFAST1']           : null;
        $beneficio['DSAFASTAMENTO2']        = isset($benefDescontoSind['DSAFASTAMENTO2'])     && !empty($benefDescontoSind['DSAFASTAMENTO2'])     ? $benefDescontoSind['DSAFASTAMENTO2']             : null;
        $beneficio['QTMESMAXAFAST2']        = isset($benefDescontoSind['QTMESMAXAFAST2'])     && !empty($benefDescontoSind['QTMESMAXAFAST2'])     ? intval($benefDescontoSind['QTMESMAXAFAST2'])     : null;
        $beneficio['IDGERADESCAFAST2']      = isset($benefDescontoSind['IDGERADESCAFAST2'])   && !empty($benefDescontoSind['IDGERADESCAFAST2'])   ? $benefDescontoSind['IDGERADESCAFAST2']           : null;
        $beneficio['DSAFASTAMENTO3']        = isset($benefDescontoSind['DSAFASTAMENTO3'])     && !empty($benefDescontoSind['DSAFASTAMENTO3'])     ? $benefDescontoSind['DSAFASTAMENTO3']             : null;

        // Campos integrais comuns para as duas tabelas
        $beneficio['NREVENTOMENSA']        = isset($benefDescontoSind['NREVENTOMENSA'])        && !empty($benefDescontoSind['NREVENTOMENSA'])        ? $benefDescontoSind['NREVENTOMENSA']        : $beneficio['NREVENTOMENSA'];     
        $beneficio['NREVENTOMENSADEP']     = isset($benefDescontoSind['NREVENTOMENSADEP'])     && !empty($benefDescontoSind['NREVENTOMENSADEP'])     ? $benefDescontoSind['NREVENTOMENSADEP']     : $beneficio['NREVENTOMENSADEP'];     
        $beneficio['VRTETOTITULARMENS']    = isset($benefDescontoSind['VRTETOTITULARMENS'])    && !empty($benefDescontoSind['VRTETOTITULARMENS'])    ? $benefDescontoSind['VRTETOTITULARMENS']    : $beneficio['VRTETOTITULARMENS'];     
        $beneficio['VRPISOTITULARMENS']    = isset($benefDescontoSind['VRPISOTITULARMENS'])    && !empty($benefDescontoSind['VRPISOTITULARMENS'])    ? $benefDescontoSind['VRPISOTITULARMENS']    : $beneficio['VRPISOTITULARMENS'];     
        $beneficio['VRLINEARBENEFICIO']    = isset($benefDescontoSind['VRLINEARBENEFICIO'])    && !empty($benefDescontoSind['VRLINEARBENEFICIO'])    ? $benefDescontoSind['VRLINEARBENEFICIO']    : $beneficio['VRLINEARBENEFICIO'];     
        $beneficio['VRLINEARBENEFICIODEP'] = isset($benefDescontoSind['VRLINEARBENEFICIODEP']) && !empty($benefDescontoSind['VRLINEARBENEFICIODEP']) ? $benefDescontoSind['VRLINEARBENEFICIODEP'] : $beneficio['VRLINEARBENEFICIODEP'];     

        $beneficio['VRPARTICIPATITULAR']   = isset($benefDescontoSind['VRPARTICIPATITULAR'])   && !empty($benefDescontoSind['VRPARTICIPATITULAR'])   ? floatval($benefDescontoSind['VRPARTICIPATITULAR'])  : $beneficio['VRPARTICIPATITULAR'];
        $beneficio['VRPISOTITULAR']        = isset($benefDescontoSind['VRPISOTITULAR'])        && !empty($benefDescontoSind['VRPISOTITULAR'])        ? floatval($benefDescontoSind['VRPISOTITULAR'])       : $beneficio['VRPISOTITULAR'];
        $beneficio['VRTETOTITULAR']        = isset($benefDescontoSind['VRTETOTITULAR'])        && !empty($benefDescontoSind['VRTETOTITULAR'])        ? floatval($benefDescontoSind['VRTETOTITULAR'])       : $beneficio['VRTETOTITULAR'];
        $beneficio['VRPARTICIPADEPE']      = isset($benefDescontoSind['VRPARTICIPADEPE'])      && !empty($benefDescontoSind['VRPARTICIPADEPE'])      ? floatval($benefDescontoSind['VRPARTICIPADEPE'])     : $beneficio['VRPARTICIPADEPE'];
        $beneficio['VRPISODEP']            = isset($benefDescontoSind['VRPISODEP'])            && !empty($benefDescontoSind['VRPISODEP'])            ? floatval($benefDescontoSind['VRPISODEP'])           : $beneficio['VRPISODEP'];
        $beneficio['VRTETODEP']            = isset($benefDescontoSind['VRTETODEP'])            && !empty($benefDescontoSind['VRTETODEP'])            ? floatval($benefDescontoSind['VRTETODEP'])           : $beneficio['VRTETODEP'];

        $beneficio['IDPROPADMIS']          = isset($benefDescontoSind['IDPROPADMIS'])          && !empty($benefDescontoSind['IDPROPADMIS'])          ? $benefDescontoSind['IDPROPADMIS']          : $beneficio['IDPROPADMIS'];     
        $beneficio['IDPROPRESC']           = isset($benefDescontoSind['IDPROPRESC'])           && !empty($benefDescontoSind['IDPROPRESC'])           ? $benefDescontoSind['IDPROPRESC']           : $beneficio['IDPROPRESC'];     

        // Campos para desconto de benefício comuns para as duas tabelas
        $beneficio['NRIDADEMAXSUBFILHOS']    = isset($benefDescontoSind['NRIDADEMAXSUBFILHOS'])    && !empty($benefDescontoSind['NRIDADEMAXSUBFILHOS'])    ? $benefDescontoSind['NRIDADEMAXSUBFILHOS']    : $beneficio['NRIDADEMAXSUBFILHOS'];     
        $beneficio['NRIDADEMAXSUBDEP']       = isset($benefDescontoSind['NRIDADEMAXSUBDEP'])       && !empty($benefDescontoSind['NRIDADEMAXSUBDEP'])       ? $benefDescontoSind['NRIDADEMAXSUBDEP']       : $beneficio['NRIDADEMAXSUBDEP'];     
        $beneficio['SEXOSUBSIDIOFILHO']      = isset($benefDescontoSind['SEXOSUBSIDIOFILHO'])      && !empty($benefDescontoSind['SEXOSUBSIDIOFILHO'])      ? $benefDescontoSind['SEXOSUBSIDIOFILHO']      : $beneficio['SEXOSUBSIDIOFILHO'];       
        $beneficio['SEXOSUBSIDIODEP']        = isset($benefDescontoSind['SEXOSUBSIDIODEP'])        && !empty($benefDescontoSind['SEXOSUBSIDIODEP'])        ? $benefDescontoSind['SEXOSUBSIDIODEP']        : $beneficio['SEXOSUBSIDIODEP'];         
        $beneficio['NREVETITULARVINC']       = isset($benefDescontoSind['NREVETITULARVINC'])       && !empty($benefDescontoSind['NREVETITULARVINC'])       ? $benefDescontoSind['NREVETITULARVINC']       : $beneficio['NREVETITULARVINC'];     
        $beneficio['NRTIPOPARTICIPATITULAR'] = isset($benefDescontoSind['NRTIPOPARTICIPATITULAR']) && !empty($benefDescontoSind['NRTIPOPARTICIPATITULAR']) ? $benefDescontoSind['NRTIPOPARTICIPATITULAR'] : $beneficio['NRTIPOPARTICIPATITULAR'];  
        $beneficio['NRTABFAIXASALTIT']       = isset($benefDescontoSind['NRTABFAIXASALTIT'])       && !empty($benefDescontoSind['NRTABFAIXASALTIT'])       ? $benefDescontoSind['NRTABFAIXASALTIT']       : $beneficio['NRTABFAIXASALTIT'];     
        $beneficio['VRTITULARSIND']          = isset($benefDescontoSind['VRTITULARSIND'])          && !empty($benefDescontoSind['VRTITULARSIND'])          ? $benefDescontoSind['VRTITULARSIND']          : $beneficio['VRTITULARSIND'];           
        $beneficio['VRPISOTITULARSIND']      = isset($benefDescontoSind['VRPISOTITULARSIND'])      && !empty($benefDescontoSind['VRPISOTITULARSIND'])      ? $benefDescontoSind['VRPISOTITULARSIND']      : $beneficio['VRPISOTITULARSIND'];       
        $beneficio['VRTETOTITULARSIND']      = isset($benefDescontoSind['VRTETOTITULARSIND'])      && !empty($benefDescontoSind['VRTETOTITULARSIND'])      ? $benefDescontoSind['VRTETOTITULARSIND']      : $beneficio['VRTETOTITULARSIND'];       
        $beneficio['NREVEDEPEVINC']          = isset($benefDescontoSind['NREVEDEPEVINC'])          && !empty($benefDescontoSind['NREVEDEPEVINC'])          ? $benefDescontoSind['NREVEDEPEVINC']          : $beneficio['NREVEDEPEVINC'];           
        $beneficio['NRTIPOPARTICIPADEP']     = isset($benefDescontoSind['NRTIPOPARTICIPADEP'])     && !empty($benefDescontoSind['NRTIPOPARTICIPADEP'])     ? $benefDescontoSind['NRTIPOPARTICIPADEP']     : $beneficio['NRTIPOPARTICIPADEP'];      
        $beneficio['NRTABFAIXASALDEP']       = isset($benefDescontoSind['NRTABFAIXASALDEP'])       && !empty($benefDescontoSind['NRTABFAIXASALDEP'])       ? $benefDescontoSind['NRTABFAIXASALDEP']       : $beneficio['NRTABFAIXASALDEP'];     
        $beneficio['VRDEPSIND']              = isset($benefDescontoSind['VRDEPSIND'])              && !empty($benefDescontoSind['VRDEPSIND'])              ? $benefDescontoSind['VRDEPSIND']              : $beneficio['VRDEPSIND'];          
        $beneficio['VRPISODEPSIND']          = isset($benefDescontoSind['VRPISODEPSIND'])          && !empty($benefDescontoSind['VRPISODEPSIND'])          ? $benefDescontoSind['VRPISODEPSIND']          : $beneficio['VRPISODEPSIND'];           
        $beneficio['VRTETODEPSIND']          = isset($benefDescontoSind['VRTETODEPSIND'])          && !empty($benefDescontoSind['VRTETODEPSIND'])          ? $benefDescontoSind['VRTETODEPSIND']          : $beneficio['VRTETODEPSIND'];
    }

    public function retroceder($tpperiodo, $dsordem, $dsinicio, $dsfim, $dtmescompetenc, $nrorg, $nrestruturam, $nrtpbeneficio, $formulario, $dsinicio1 = null, $dsfim1 = null){
        try {
            $this->dtPagamentoBenef = substr($formulario['DTPGTOCALCBENEF'], 0, 10);
            $qtdeDeletados = null;
            $foiRetrocedido = false;
            $nrcalculobenef = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_BENEFICIO);
            $vinculos = $this->calculoBeneficioRepository->buscaVinculos_Mensal($nrorg, $dtmescompetenc, $dsordem, $dsinicio, $dsfim, $nrestruturam, $nrtpbeneficio, $formulario, $dsinicio1, $dsfim1);

            //conta a quantidade de vinculos a serem retrocedidos
            if(empty($formulario['RETROCESSO_CONFIRMADO'])){    
                $qtdVinculos = count($vinculos);
                return array('CONFIRMACAO' => true, 'QTDVINCULO'  => $qtdVinculos);
            }

            $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoProcesso(
                $nrcalculobenef, 
                $this->hcmParameters->getNrorgTrabalho(), 
                'RETROCESSOBENEFICIO',
                $this->hcmParameters->getCdoperador() 
            );
            
            foreach ($vinculos as $vinculo) {
                $instancia = MsgCalculo::getInstance();
                $instancia->setDados($nrcalculobenef, $vinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), "RETROCESSOBENEFICIO");
    
                $eventos = [];
                $beneficiarios = $this->calculoBeneficioRepository->getBeneficiarioPorVinculo($nrorg, $vinculo->getNrvinculom(), $dtmescompetenc, $tpperiodo, $nrtpbeneficio, $nrestruturam);

                // Histórico do vínculo é carregado a fim de se ter acesso ao valor IDASSOCSINDICATO 
                $histVinc = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->_retornaHistórico($vinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), $this->hcmParameters->getDtCompetencia());
                // Caso o vínculo seja de um sindicato é para considerar o campo 'percentual/valor associado' se e somente se este tiver valor
                $idAssocSind = isset($histVinc['IDASSOCSINDICATO']) ? $histVinc['IDASSOCSINDICATO'] : 'N' ; 

                foreach($beneficiarios as $beneficiario){
                    $beneficio = $this->calculoBeneficioRepository->getBeneficioPorVinculo($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficiario->getNrbeneficiom());

                    // Caso vínculo tenha sindicato no histórico e tal sindicato tenha beneficio correspondente, os dados de desconto do vínculo serão a partir do benefício do sindicato.
                    // Caso vínculo tenha sindicato no histórico e tal sindicato não tenha benefício, os dados de desconto do vínculo serão a partir do benefício original.
                    if(intval($histVinc['NRESTRUTSIND'])) {
                        $benefDescontoSind = $this->calculoBeneficioRepository->getBeneficioDescontoSind($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficio['NRTPBENEFICIO'], intval($histVinc['NRESTRUTSIND']));
                        if(isset($benefDescontoSind) && !empty($benefDescontoSind)) $this->mergeBeneficioComBeneficioSind($beneficio, $benefDescontoSind);
                    }   

                    $eventosBeneficioBeneficiario = $this->getEventosParaRetroceder($beneficio, $beneficiario);
                    $eventos = array_merge( $eventos, $eventosBeneficioBeneficiario );
                }
                
                if($tpperiodo == 'MENSAL')
                    $qtdeDeletados = $this->calculoBeneficioRepository->retrocederCalculos_Mensal($nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $eventos, $this->dtPagamentoBenef);
                else if($tpperiodo == 'DIARIO'){

                    $listaEventos = NULL;
                    foreach($eventos as $evento){
                        
                        $listaEventos .= $evento.',';
                    }

                    $virgula = strripos($listaEventos, ',');
        
                    if($virgula){ 
                        $listaEventos = substr($listaEventos, 0, -2);
                    }else
                        $listaEventos .= 'null';

                    $verificaLiquido = $this->itensCalculoService->validaLiquidoBeneficio(FpaTipomoviment::TP_MOV_BENEFICIO, $nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $evento, $this->dtPagamentoBenef);
                          
                    // Verifica se algum Vinculo ja possui calculo de beneficio
                    if($verificaLiquido){
                        MsgCalculo::getInstance()->adicionaMensagem("Vinculo ".$vinculo->getNmvinculom()." possui itens calculados", MsgCalculo::ALERTA);
                        $instancia->salvaMensagens();
                        $instancia->clear();

                        continue;
                    }

                    $qtdeDeletados = $this->calculoBeneficioRepository->retrocederCalculos_Diario($nrcalculobenef, $vinculo->getNrvinculom(), $dtmescompetenc, $nrorg, $eventos, $this->dtPagamentoBenef);
                }
                if($foiRetrocedido != $qtdeDeletados)
                    $foiRetrocedido = true;
                
                $instancia->salvaMensagens();
                $instancia->clear();
            }
            
            return $foiRetrocedido;
            
        } catch (\Exception $e) {
            throw $e; 
        }
        
    }
    
    public function persistirLogRetrocesso($row){
        $row['DSORDEM'] = $row['DSORDEMCALCBENEF'];
        $row['DSINICIO'] = $row['DSINICIOCALCBENEF'];
        $row['DSFIM'] = $row['DSFIMCALCBENEF'];
        $this->logRetrocessoCalculoController->persistirLogRetrocesso('CALC_BENEFICIO', $row);
    }

    

    /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    -=                                     -=
    -= ABAIXO, REFERENTE AO CÁLCULO MENSAL -=
    -=                                     -=
    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

    private function obterMinimizadoresMensal($beneficio){
        $array = [];
        
        $array['IDGERABENEFFALTA']  = isset($beneficio['IDGERABENEFFALTA'])  && !empty($beneficio['IDGERABENEFFALTA'])   ? $beneficio['IDGERABENEFFALTA']  : null;
        $array['IDGERABENEFATEST']  = isset($beneficio['IDGERABENEFATEST'])  && !empty($beneficio['IDGERABENEFATEST'])   ? $beneficio['IDGERABENEFATEST']  : null;
        $array['IDGERABENEFAFAST']  = isset($beneficio['IDGERABENEFAFAST'])  && !empty($beneficio['IDGERABENEFAFAST'])   ? $beneficio['IDGERABENEFAFAST']  : null;
        $array['IDGERABENEFFERIAS'] = isset($beneficio['IDGERABENEFFERIAS']) && !empty($beneficio['IDGERABENEFFERIAS'])  ? $beneficio['IDGERABENEFFERIAS'] : null;
        
        // Abaixo para minimizadores informados no Benefício do Sindicato
        $array['IDCONSFALTABENEF']    = isset($beneficio['IDCONSFALTABENEF'])    && !empty($beneficio['IDCONSFALTABENEF'])    ? $beneficio['IDCONSFALTABENEF']    : null;
        $array['QTMESESFALTABENEF']   = isset($beneficio['QTMESESFALTABENEF'])   && !empty($beneficio['QTMESESFALTABENEF'])   ? $beneficio['QTMESESFALTABENEF']   : 0;
        $array['IDCONSAFASTBENEF']    = isset($beneficio['IDCONSAFASTBENEF'])    && !empty($beneficio['IDCONSAFASTBENEF'])    ? $beneficio['IDCONSAFASTBENEF']    : null;
        $array['QTMESESAFASTBENEF']   = isset($beneficio['QTMESESAFASTBENEF'])   && !empty($beneficio['QTMESESAFASTBENEF'])   ? $beneficio['QTMESESAFASTBENEF']   : 0;
        $array['IDCONSATESTBENEF']    = isset($beneficio['IDCONSATESTBENEF'])    && !empty($beneficio['IDCONSATESTBENEF'])    ? $beneficio['IDCONSATESTBENEF']    : null;
        $array['QTMESESATESTBENEF']   = isset($beneficio['QTMESESATESTBENEF'])   && !empty($beneficio['QTMESESATESTBENEF'])   ? $beneficio['QTMESESATESTBENEF']   : 0;
        
        return $array;
    }

    public function proporcionalizarOuDuplicarDiasTrabalhadosNaCompetencia($dtAdmissaoVinc, $dtRescisaoVinc, $beneficio, $beneficiario, $competenciaAtual, $competenciaPosterior){
        
        /*
            Parte-se da premissa que um vínculo admitido numa competência, não será rescindido ou terá benefício cancelado ainda nesta.
            Parte-se da premissa que um vínculo rescindido numa competência, não terá sido admitido ou ter benefício inscrito ainda nesta.
        */
        
        
        $qtdDiasTrabalhados = null;
        $proporcao = 1;
        
        $ultimoDiaMes = (int)substr($this->hcmParameters->getUltimoDiaMes(), 0, 2);
        $diaAdmissao  = (int)substr($dtAdmissaoVinc, 8, 2);
        $diaRescisao  = isset($dtRescisaoVinc) ? (int)substr($dtRescisaoVinc, 8, 2): null;


        $dtinscrbeneficiario = substr($beneficiario->getDtinscbeneficiario(), 0, 10);
        $dtinscrbeneficiario  = $dtinscrbeneficiario ? DateUtil::getDataDeString($dtinscrbeneficiario, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   
        $diaInscrBeneficiario = (int)substr($dtinscrbeneficiario, 8, 2);

        $dtcancbeneficiario = null != $beneficiario->getDtcancbeneficiario() ? substr($beneficiario->getDtcancbeneficiario(), 0, 10) : null;
        $dtcancbeneficiario  = $dtcancbeneficiario ? DateUtil::getDataDeString($dtcancbeneficiario, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   
        $diaCancBeneficiario = $dtcancbeneficiario ? (int)substr($dtcancbeneficiario, 8, 2) : null;

        $competAnterior = DateUtil::getDataDeString($this->hcmParameters->getDtCompAnterior())->format('Y-m-d');
        
        // Caso seja para duplicar a mensalidade e também para proporcionalizar ou na admissão ou na inscrição, na competência corrente a mensalidade será proporcionalizada e apenas na seguinte será duplicada.
        // Em outras palavras, apenas quando a data de inscrição do beneficiário estiver na competencia anterior, é que a mensalidade será duplicada.
        if($beneficio['IDDUPLICMENS'] == 'S' && ($beneficio['IDPROPADMIS'] == 'S' || $beneficio['IDPROPDTINSCR'] == 'S') && ($competAnterior <= $dtinscrbeneficiario && $dtinscrbeneficiario < $competenciaAtual))
            $proporcao = 2;
        // Caso seja para duplicar a mensalidade mas não para proporcionalizar nem na admissão nem na inscriçao, apenas duplicará se a data de inscrição estiver na competência corrent
        else if($beneficio['IDDUPLICMENS'] == 'S' && $beneficio['IDPROPADMIS'] == 'N' && $beneficio['IDPROPDTINSCR'] == 'N' && ($competenciaAtual <= $dtinscrbeneficiario && $dtinscrbeneficiario < $competenciaPosterior))
            $proporcao = 2;
        // Caso não seja para duplicar a mensalidade, mas seja para para proporcionalizar, proporcionalizará normalmente na competência corrente
        else{

            /*
                - Caso as ambas opções 'Proporcionaliza na Admissão?' e 'Proporciona conforme data de inscrição ?' estiverem marcadas, 
                    e data de admissão e inscrição estiverem na competênca corrente, será considerada a data mais avançada para proporcionalizar.
                - Caso apenas a opção 'Proporcionaliza na Admissão?' esteja marcada e estiver na competência vigente, 
                    será considerada esta data para proporcionalizar.
                - Caso apenas a opção 'Proporciona conforme data de inscrição ?' esteja marcada e estiver na competência vigente,  
                    será considerada esta data para proporcionalizar.
            */
            if($beneficio['IDPROPADMIS'] == 'S' || $beneficio['IDPROPDTINSCR'] == 'S'){
                $diffAdmissao = $diffDtIniVig = null;
                if( $beneficio['IDPROPADMIS'] == 'S' && $competenciaAtual < $dtAdmissaoVinc && $dtAdmissaoVinc < $competenciaPosterior )  $diffAdmissao = $ultimoDiaMes - $diaAdmissao + 1;
                if( $beneficio['IDPROPDTINSCR'] == 'S' && $competenciaAtual < $dtinscrbeneficiario && $dtinscrbeneficiario < $competenciaPosterior ) $diffDtIniVig = $ultimoDiaMes - $diaInscrBeneficiario + 1;
                
                if(isset($diffAdmissao) && isset($diffDtIniVig)) $qtdDiasTrabalhados = min($diffAdmissao, $diffDtIniVig); // dias trabalhados será a menor diferença entre (admissão e última dia) e (inscrição e último dia)
                else if(isset($diffAdmissao)) $qtdDiasTrabalhados = $diffAdmissao;
                else if(isset($diffDtIniVig)) $qtdDiasTrabalhados = $diffDtIniVig;
            }
            /*
                - Caso as ambas opções 'Proporcionaliza na Rescisão?' e 'Proporciona conforme data de cancelamento ?' estiverem marcadas, 
                    e data de rescisão e cancelamento estiverem na competênca corrente, será considerada a data menos avançada para proporcionalizar.
                - Caso apenas a opção 'Proporcionaliza na Rescisão?' esteja marcada e estiver na competência vigente, 
                    será considerada esta data para proporcionalizar.
                - Caso apenas a opção 'Proporciona conforme data de cancelamento ?' esteja marcada e estiver na competência vigente,  
                    será considerada esta data para proporcionalizar.
            */
    
            if($beneficio['IDPROPRESC'] == 'S' || $beneficio['IDPROPDTCANC'] == 'S'){
                $diffRescisao = $diffCancBeneficiario = null;
                if( isset($dtRescisaoVinc) && $beneficio['IDPROPRESC'] == 'S' && $competenciaAtual < $dtRescisaoVinc && $dtRescisaoVinc < $competenciaPosterior )  $diffRescisao = $diaRescisao;
                if( isset($dtcancbeneficiario) && $beneficio['IDPROPDTINSCR'] == 'S' && $competenciaAtual < $dtcancbeneficiario && $dtcancbeneficiario < $competenciaPosterior ) $diffCancBeneficiario = $diaCancBeneficiario;
                
                if(isset($diffRescisao) && isset($diffCancBeneficiario)) $qtdDiasTrabalhados = min($diffRescisao, $diffCancBeneficiario); // dias trabalhados será a menor data entre rescisão e cancelamento
                else if(isset($diffRescisao)) $qtdDiasTrabalhados = $diffRescisao;
                else if(isset($diffCancBeneficiario)) $qtdDiasTrabalhados = $diffCancBeneficiario;
            }
            if(isset($qtdDiasTrabalhados)) $proporcao = $qtdDiasTrabalhados/30;

        }

        return $proporcao;
    }
    
    private function obterMotivosParaNaoCalcular_verificarIsencao100Afastamento($vinculo, &$subsidio100PorAfastamentoOuDemissao, &$motivos = null){

        if(!$motivos) $motivos = [];

        // ----- Verifica se o vínculo FALTOU no período da competência
        $nrtpmovimento = '1';
        $nreventom = "490, 495, 1040, 1043";
    
        $faltas = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getSomaItemCalculo(
            $vinculo->getNrvinculom(), 
            $this->hcmParameters->getNrorgTrabalho(), 
            DateUtil::getDataDeString( $this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true),
            DateUtil::getDataDeString( $this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true),
            $nreventom, 
            $nrtpmovimento, 
            DateUtil::getDataDeString( $this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true)
        );
        
        if( $faltas && (int)$faltas['VALOR'] > 0){
                $motivos[] = "FALTA";
                $temFalta = true;
        }    

        // ----- Verifica se o vínculo ficou de ATESTADO no período da competência
        $competencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        
        $listNrsitufuncm = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCH)->getAfastamentoIncideVale($this->hcmParameters->getDtCompetencia());
        $listNrsitufuncm = implode(', ', $listNrsitufuncm);

        $altesitfuncs = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaSituacaoFuncional_AtesOuAfast(
            $this->hcmParameters->getNrorgTrabalho(), 
            $vinculo->getNrvinculom(), 
            $listNrsitufuncm, 
            DateUtil::getDataDeString($competencia->format('d/m/Y'), DateUtil::FORMATO_BRASILEIRO, true),
            DateUtil::getDataDeString($competencia->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true), 
            "ATESTADO"
        );
        
        if($altesitfuncs){
            $motivos[] = "ATESTADO";
            $temAtestado = true;
        }



        // ----- Verifica se o vínculo ficou de AFASTAMENTO no perído da competência
        $competencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
        
        $listNrsitufuncm = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCH)->getAfastamentoIncideVale($this->hcmParameters->getDtCompetencia());
        $listNrsitufuncm = implode(', ', $listNrsitufuncm);

        $altesitfuncs = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaSituacaoFuncional_AtesOuAfast(
            $this->hcmParameters->getNrorgTrabalho(), 
            $vinculo->getNrvinculom(), 
            $listNrsitufuncm, 
            DateUtil::getDataDeString( $competencia->format('d/m/Y'), DateUtil::FORMATO_BRASILEIRO, true),
            DateUtil::getDataDeString( $competencia->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true), 
            "AFASTAMENTO"
        );
        
        if($altesitfuncs){
            $motivos[] = "AFASTAMENTO";
            $temAfastamento = true;
            
            $competenciaBase = substr($this->hcmParameters->getDtCompetencia(), 0, 10);
            $primeiroDiaComp = $competenciaBase ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $competenciaBase)->format('Y-m-d') : null;   
            $ultimoDiaComp   = $competenciaBase ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $competenciaBase)->format('Y-m-t') : null;   

            foreach($altesitfuncs as $altesitfunc ){
                                
                $altesitfunc->getDtinisitufunc();
                $altesitfunc->getDtinisitufunc();
                
                $dtIniSituFunc = $altesitfunc->getDtinisitufunc() ? DateTime::createFromFormat( DateUtil::FORMATO_BRASILEIRO, $altesitfunc->getDtinisitufunc()->format('d/m/Y') )->format('Y-m-d') : null;   
                $dtFimSituFunc = $altesitfunc->getDtfimsitufunc() ? DateTime::createFromFormat( DateUtil::FORMATO_BRASILEIRO, $altesitfunc->getDtfimsitufunc()->format('d/m/Y') )->format('Y-m-d') : null;   

                $situFuncH = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->retornaUltimoHistoricoCompetencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getNrorgPadrao(), 
                    $altesitfunc->getNrsitufuncm(), 
                    $this->hcmParameters->getDtCompetencia()
                );

                // Se vínculo estiver afastado, que não seja licensa gestante nem demissão, possivelmente a empresa pagará o benefício total
                if( 
                       $altesitfunc->getNrsitufuncm() != 5     // 5 = licensa gestante
                    && $altesitfunc->getNrsitufuncm() != 11    // 11 = prolongação licensa gestante
                    && $altesitfunc->getNrsitufuncm() != 13    // 13 = demissão
                    && $situFuncH->getIdgervaletransp() == 'N' // “Gera Vale-Transporte Benefícios“ deve estar como Não
                    && $dtIniSituFunc < $primeiroDiaComp       // Afastamento deve ter se iniciando antes do início da competência
                    
                    && (    !$dtFimSituFunc 
                         || (
                                !($primeiroDiaComp <= $dtFimSituFunc && $dtFimSituFunc <= $ultimoDiaComp) // Não pode ter retorno durante competencia
                                && $dtFimSituFunc > $ultimoDiaComp // A data final de afastamento deve ser maior que o último dia da competência
                            )
                       )    
                )
                    $subsidio100PorAfastamentoOuDemissao = true;

            }
        
            
        }


        
        // ----- Verifica se o vínculo teve FÉRIAS no perído da competência
        $competencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);
        
        $ferias = $this->entityManager->getRepository(Repositories::FPA_FERIAS)->getPeriodoGozoFerias(
            $vinculo->getNrvinculom(),
            DateUtil::getDataDeString( $competencia->format('d/m/Y'), DateUtil::FORMATO_BRASILEIRO, true ), 
            DateUtil::getDataDeString( $competencia->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true ),
            $this->hcmParameters->getNrorgTrabalho()
        );            

        if($ferias){
            $motivos[] = "FERIAS";
            $temFerias = true;
        }
        

    }
    
    private function verificarIsencao100Demissao(&$subsidio100PorAfastamentoOuDemissao, $consvincresmesant, $vinculo, $dtRescisaoVinc, $competenciaAtual){
        if($consvincresmesant == 'S' && isset($dtRescisaoVinc) && $dtRescisaoVinc < $competenciaAtual){
            $subsidio100PorAfastamentoOuDemissao = true;
        }
    }
    
    public function persistirCalculo_Mensal(&$foiCalculado, $nrcalculobenef, $nrvinculom, $proporcao, $eventos, $qtdBeneficiariosPerEvento, $dtpagamento = null, $nrlotevinc = null, $eventoEparcelas = []){
        $dtpagamento = $dtpagamento ? $dtpagamento : $this->hcmParameters->getDtCompetencia();
        foreach($eventos as $nrEvento => $valorEvento){
            if($valorEvento >= 0){
                $qtdParc = null;
                $row = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findOneBy( 
                    [ 
                     'nrcalculofolha' => $nrcalculobenef,
                     'nrvinculom'     => $nrvinculom,
                     'nreventom'      => $nrEvento,
                     'nrorg'          => $this->hcmParameters->getNrorgTrabalho(),
                     'dtocorrencia'   => Dateutil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true),
                    ]
                );

                if($row && $row->getNrlotelancevento())
                    MsgCalculo::getInstance()->adicionaMensagem('Evento '.$nrEvento.' para o vínculo '.$nrvinculom.' já exportado para folha. ', MsgCalculo::ALERTA);

                else{
                    $foiCalculado = true;

                    if($row){
                        $this->entityManager->remove($row);
                        $this->entityManager->flush();
                    }
                    
                    $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                        $nrEvento,
                        $this->hcmParameters->getNrorgTrabalho(), 
                        $this->hcmParameters->getNrorgPadrao(), 
                        $this->hcmParameters->getDtCompetencia() 
                    );

                    //Checa se o evento tem valor de parcela. Se tiver faz a divisão do valor pela parcela e seta a qtde de parcela.
                    if($eventoEparcelas[$nrEvento]) {
                        $valorEvento = $valorEvento / $eventoEparcelas[$nrEvento]; 
                        $qtdParc = $eventoEparcelas[$nrEvento];
                    }
                    
                    $valorEvento = Valor::arredonda(
                        $valorEvento, 
                        $eventoh->historico->getIdtipoarredonda(), 
                        $eventoh->historico->getNrdigarredonda(),
                        $eventoh->historico->getVrlimitearred()
                    );

                    try {

                        $event = new FpaItecalcfolha();
                        $event->setNritemcalcfolha(NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITECALCFOLHA', 1, 22, true));
                        $event->setNrcalculofolha($nrcalculobenef);
                        $event->setNrvinculom($nrvinculom);
                        $event->setNreventom($nrEvento);
                        $event->setVreventofolha($valorEvento);
                        $event->setVrreffolha($qtdBeneficiariosPerEvento[$nrEvento]['qtde']);
                        $event->setNrlotevinc($nrlotevinc);
                        $event->setDtocorrencia(Dateutil::getDataDeString($dtpagamento, DateUtil::FORMATO_BRASILEIRO, true));
                        $event->setNrorg($this->hcmParameters->getNrorgTrabalho());
                        $event->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                        $event->setDtinclusao(DateUtil::getDataAtual());
                        $event->setCdoperinclusao($this->hcmParameters->getCdoperador());
                        $event->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                        $event->setDtultatu(DateUtil::getDataAtual());
                        $event->setCdoperultatu($this->hcmParameters->getCdoperador());
                        $event->setQtocorproxperi($qtdParc);
                        
                        $this->entityManager->persist($event);
                        $this->entityManager->flush();
                    } catch (Exception $e) {
                        throw $e;    
                    }

                }
            }
            
        }
    }    
    
    public function persistirHistoricoCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $vincBenefiarioEvento, $vincBenefiarioEvento_mens, $vincBenefiarioEvento_vinc, $vincBenefiarioEvento_empresa){
        
        // Persiste o cálculo para a relação Benefício/Vínculo/Beneficiario/EventoDoBeneficiario
        $this->calculoBeneficioRepository->persistirCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $vincBenefiarioEvento, 'B');

        // Persiste o cálculo para a relação Benefício/Vínculo/Beneficiario/EventoMensalidade
        $this->calculoBeneficioRepository->persistirCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $vincBenefiarioEvento_mens, 'M');

        // Persiste o cálculo para a relação Benefício/Vínculo/Beneficiario/EventoVínculo
        $this->calculoBeneficioRepository->persistirCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $vincBenefiarioEvento_vinc, 'V');

        // Persiste o cálculo para a relação Benefício/Vínculo/Beneficiario/EventoEmpresa
        $this->calculoBeneficioRepository->persistirCalculoDIRF_Mensal($nrcalculobenef, $nrbeneficiom, $nrvinculom, $nrPessoaBeneficiario, $proporcao, $vincBenefiarioEvento_empresa, 'E');
    }


    /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    -=                                       -=
    -= ABAIXO, REFERENTE AO CÁLCULO DIÁRIO   -=
    -=                                       -=
    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

    public function calcularDias($vinculo, $beneficiario, $minimizadores, $dtinicio, $dtfinal, $dtpagamento, $qtdiasbenef){

        $diasConsideracao = $diasAviso = $diasDeTrabalhoNoPeriodo = $diasFaltas = $diasAtestado = $diasAfastamento = $diasFerias = $diasDSR = $diasFeriado = 0;
        
        $this->definirPeriodoBeneficio($vinculo, $beneficiario, $dtinicio, $dtfinal, $dtpagamento, $minimizadores);
        
        $dsDiasDescanso = $this->getDsDescansoSemanal( $vinculo->getNrvinculom() );
        
        $this->calcularQtdeDiasNoPeriodo($diasDeTrabalhoNoPeriodo, $diasDSR, $diasFeriado, $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['QTMESESFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF'], $minimizadores['QTMESESDSRBENEF'] );
        
        $this->calcularQtdeDiasEmAviso($diasAviso, $vinculo, $dsDiasDescanso, $minimizadores['IDCONSDSRBENEF']);
        
        // Se considerar falta, calcula quantidade de faltas
        if($minimizadores['IDCONSFALTABENEF'] === 'S') $this->calcularQtdeFaltas( $diasFaltas, $minimizadores['QTMESESFALTABENEF'], $vinculo->getNrvinculom(), $vinculo );

        // Se considerar atestado, calcula quantidade de dias de atestado
        if($minimizadores['IDCONSATESTBENEF'] === 'S') $this->calcularQtdeDias_AtesOuAfast( $diasAtestado, 'ATESTADO', $minimizadores['QTMESESATESTBENEF'], $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);

        // Se considerar afastamento, calcula quantidade de dias afastado
        if($minimizadores['IDCONSAFASTBENEF'] === 'S') $this->calcularQtdeDias_AtesOuAfast( $diasAfastamento, 'AFASTAMENTO', $minimizadores['QTMESESAFASTBENEF'], $vinculo, $dsDiasDescanso, $minimizadores['IDCONSFERIADOBENEF'], $minimizadores['IDCONSDSRBENEF']);

        // Se considerar ferias, calcula quantidade de dias de férias
        if($minimizadores['IDCONSFERIASBENEF'] === 'S') $this->calcularQtdeDiasFerias($diasFerias, $vinculo, $minimizadores['QTMESESFERIASBENEF'], $minimizadores['IDCONSDSRBENEF'], $minimizadores['IDCONSFERIADOBENEF'], $dsDiasDescanso);
        
        if($qtdiasbenef > 0){
            $diasDeTrabalhoNoPeriodo = $qtdiasbenef;
        }
        
        if($this->idcalccomplementar == 'S'){
            $diasConsideracao = $qtdiasbenef;
        }elseif( $diasAviso > 0 ){
            $diasConsideracao = $diasAviso - $diasFaltas - $diasAtestado - $diasAfastamento - $diasFerias;
        } else{
            $diasConsideracao = $diasDeTrabalhoNoPeriodo - $diasFaltas - $diasAtestado - $diasAfastamento - $diasFerias;
        }
        
        return $this->montarArrayDiasCalculados($diasConsideracao, $diasAviso, $diasDeTrabalhoNoPeriodo, $diasFaltas, $diasAtestado, $diasAfastamento, $diasFerias, $diasDSR, $diasFeriado);
    }
    
    private function definirPeriodoBeneficio($vinculo, $beneficiario, $dtinicio, $dtfinal, $dtpagamento, $minimizadores){

        $this->dtPagamentoBenef  = DateUtil::getDataDeString($dtpagamento, DateUtil::FORMATO_BRASILEIRO);

        $dtRescisaoVinc = substr($vinculo->getDtrescisaovinc(), 0, 10);
        $dtRescisaoVinc = $dtRescisaoVinc ? DateUtil::getDataDeString($dtRescisaoVinc, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   

        $competenciaPosterior  = DateUtil::getDataDeString(substr($this->hcmParameters->getDtCompetencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO);
        $competenciaPosterior  = $competenciaPosterior->add(new \DateInterval('P1M'));
        $competenciaPosterior  = $competenciaPosterior->format('Y-m-d');   

        $dtAdmissaoVinc = substr($vinculo->getDtadmissaovinc(), 0, 10);
        $dtAdmissaoVinc = $dtAdmissaoVinc ? DateUtil::getDataDeString($dtAdmissaoVinc, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   

        $competenciaAtual  = DateUtil::getDataDeString(substr($this->hcmParameters->getDtCompetencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO);
        $competenciaAtual  = $competenciaAtual->format('Y-m-d');   
        
        $dtinscrbeneficiario = substr($beneficiario->getDtinscbeneficiario(), 0, 10);
        $dtinscrbeneficiario = $dtinscrbeneficiario ? DateUtil::getDataDeString($dtinscrbeneficiario, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   

        $dtcancbeneficiario  = null != $beneficiario->getDtcancbeneficiario() ? substr($beneficiario->getDtcancbeneficiario(), 0, 10) : null;
        $dtcancbeneficiario  = $dtcancbeneficiario ? DateUtil::getDataDeString($dtcancbeneficiario, DateUtil::FORMATO_BRASILEIRO)->format('Y-m-d') : null;   
        $diaCancBeneficiario = $dtcancbeneficiario ? (int)substr($dtcancbeneficiario, 8, 2) : null;

        /*
            - Caso as ambas opções 'Proporcionaliza na Admissão?' e 'Proporciona conforme data de inscrição ?' estiverem marcadas, 
                e data de admissão e inscrição estiverem na competênca corrente, será considerada a data mais avançada para proporcionalizar.
            - Caso apenas a opção 'Proporcionaliza na Admissão?' esteja marcada e estiver na competência vigente, 
                será considerada esta data para proporcionalizar.
            - Caso apenas a opção 'Proporciona conforme data de inscrição ?' esteja marcada e estiver na competência vigente,  
                será considerada esta data para proporcionalizar.
            - Caso nenhuma das opções estejam marcadas ou nem a data de inscrição nem a data de admissão estejam na competência,
                será considerada a data final informada no período de cálculo.
        */
        if($minimizadores['IDPROPADMIS'] == 'S' || $minimizadores['IDPROPDTINSCR'] == 'S'){
            $consideraAdmissao = $consideraInscri = null;
            if( $minimizadores['IDPROPADMIS'] == 'S' && $competenciaAtual < $dtAdmissaoVinc && $dtAdmissaoVinc < $competenciaPosterior )  $consideraAdmissao = true;
            if( $minimizadores['IDPROPDTINSCR'] == 'S' && $competenciaAtual < $dtinscrbeneficiario && $dtinscrbeneficiario < $competenciaPosterior ) $consideraInscri = true;
            
            if(isset($consideraAdmissao) && isset($consideraInscri)) {
                $maior = max($dtAdmissaoVinc, $dtinscrbeneficiario); 
                $this->dtiniperiodobenef = DateUtil::getDataDeString(substr($maior, 0, 10), 'Y-m-d', true);
            }
            else if(isset($consideraAdmissao)) $this->dtiniperiodobenef = DateUtil::getDataDeString(substr($vinculo->getDtadmissaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            else if(isset($consideraInscri)) $this->dtiniperiodobenef = DateUtil::getDataDeString(substr($beneficiario->getDtinscbeneficiario(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            else $this->dtiniperiodobenef = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true);
        }else
            $this->dtiniperiodobenef = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true);

        /*
            - Caso as ambas opções 'Proporcionaliza na Rescisão?' e 'Proporciona conforme data de cancelamento ?' estiverem marcadas, 
                e data de rescisão e cancelamento estiverem na competênca corrente, será considerada a data menos avançada para proporcionalizar.
            - Caso apenas a opção 'Proporcionaliza na Rescisão?' esteja marcada e estiver na competência vigente, 
                será considerada esta data para proporcionalizar.
            - Caso apenas a opção 'Proporciona conforme data de cancelamento ?' esteja marcada e estiver na competência vigente,  
                será considerada esta data para proporcionalizar.
            - Caso nenhuma das opções estejam marcadas ou nem a data de cancelamento nem a data de rescisão estejam na competência,
                será considerada a data inicial informada no período de cálculo.
        */

        if($minimizadores['IDPROPRESC'] == 'S' || $minimizadores['IDPROPDTCANC'] == 'S'){
            $consideraRescisao = $considerarCancel = null;
            if( isset($dtRescisaoVinc) && $minimizadores['IDPROPRESC'] == 'S' && $competenciaAtual < $dtRescisaoVinc && $dtRescisaoVinc < $competenciaPosterior )  $consideraRescisao = true;
            if( isset($dtcancbeneficiario) && $minimizadores['IDPROPDTINSCR'] == 'S' && $competenciaAtual < $dtcancbeneficiario && $dtcancbeneficiario < $competenciaPosterior ) $considerarCancel = true;
            
            if(isset($consideraRescisao) && isset($considerarCancel)){ 
                $menor = min($dtRescisaoVinc, $dtcancbeneficiario); 
                $this->dtfimperiodobenef = DateUtil::getDataDeString(substr($menor, 0, 10), 'Y-m-d', true);
            }    
            else if(isset($consideraRescisao)){ 
                $this->dtfimperiodobenef = DateUtil::getDataDeString(substr($vinculo->getDtrescisaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            } else if(isset($considerarCancel)){ 
                $this->dtfimperiodobenef = DateUtil::getDataDeString(substr($beneficiario->getDtcancbeneficiario(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            } else {
                $this->dtfimperiodobenef = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
            }
        }else{
            $this->dtfimperiodobenef = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
        }

    }
    
    private function montarArrayDiasCalculados($diasConsideracao, $diasAviso, $diasDeTrabalhoNoPeriodo, $diasFaltas, $diasAtestado, $diasAfastamento, $diasFerias, $diasDSR, $diasFeriado){

            $diasCalculados = [];

            $diasCalculados['DIASCONSIDERACAO']        = $diasConsideracao;
            $diasCalculados['DIASAVISO']               = $diasAviso;
            $diasCalculados['DIASDETRABALHONOPERIODO'] = $diasDeTrabalhoNoPeriodo;
            $diasCalculados['DIASFALTAS']              = $diasFaltas;
            $diasCalculados['DIASATESTADO']            = $diasAtestado;
            $diasCalculados['DIASAFASTAMENTO']         = $diasAfastamento;
            $diasCalculados['DIASFERIAS']              = $diasFerias;
            $diasCalculados['DIASDSR']                 = $diasDSR;
            $diasCalculados['DIASFERIADO']             = $diasFeriado;

            return $diasCalculados;
    }

    public function obterMinimizadoresDiario($beneficio){
        $array = [];
        
        $array['IDCONSFALTABENEF']    = isset($beneficio['IDCONSFALTABENEF'])    && !empty($beneficio['IDCONSFALTABENEF'])    ? $beneficio['IDCONSFALTABENEF']    : null;
        $array['QTMESESFALTABENEF']   = isset($beneficio['QTMESESFALTABENEF'])   && !empty($beneficio['QTMESESFALTABENEF'])   ? $beneficio['QTMESESFALTABENEF']   : 0;
        $array['IDCONSATESTBENEF']    = isset($beneficio['IDCONSATESTBENEF'])    && !empty($beneficio['IDCONSATESTBENEF'])    ? $beneficio['IDCONSATESTBENEF']    : null;
        $array['QTMESESATESTBENEF']   = isset($beneficio['QTMESESATESTBENEF'])   && !empty($beneficio['QTMESESATESTBENEF'])   ? $beneficio['QTMESESATESTBENEF']   : 0;
        $array['IDCONSAFASTBENEF']    = isset($beneficio['IDCONSAFASTBENEF'])    && !empty($beneficio['IDCONSAFASTBENEF'])    ? $beneficio['IDCONSAFASTBENEF']    : null;
        $array['QTMESESAFASTBENEF']   = isset($beneficio['QTMESESAFASTBENEF'])   && !empty($beneficio['QTMESESAFASTBENEF'])   ? $beneficio['QTMESESAFASTBENEF']   : 0;
        $array['IDCONSFERIASBENEF']   = isset($beneficio['IDCONSFERIASBENEF'])   && !empty($beneficio['IDCONSFERIASBENEF'])   ? $beneficio['IDCONSFERIASBENEF']   : null;
        $array['QTMESESFERIASBENEF']  = isset($beneficio['QTMESESFERIASBENEF'])  && !empty($beneficio['QTMESESFERIASBENEF'])  ? $beneficio['QTMESESFERIASBENEF']  : 0;
        $array['IDCONSFERIADOBENEF']  = isset($beneficio['IDCONSFERIADOBENEF'])  && !empty($beneficio['IDCONSFERIADOBENEF'])  ? $beneficio['IDCONSFERIADOBENEF']  : null;
        $array['QTMESESFERIADOBENEF'] = isset($beneficio['QTMESESFERIADOBENEF']) && !empty($beneficio['QTMESESFERIADOBENEF']) ? $beneficio['QTMESESFERIADOBENEF'] : 0;
        $array['IDCONSDSRBENEF']      = isset($beneficio['IDCONSDSRBENEF'])      && !empty($beneficio['IDCONSDSRBENEF'])      ? $beneficio['IDCONSDSRBENEF']      : null;
        $array['QTMESESDSRBENEF']     = isset($beneficio['QTMESESDSRBENEF'])     && !empty($beneficio['QTMESESDSRBENEF'])     ? $beneficio['QTMESESDSRBENEF']     : 0;
        $array['IDPROPADMIS']         = isset($beneficio['IDPROPADMIS'])         && !empty($beneficio['IDPROPADMIS'])         ? $beneficio['IDPROPADMIS']         : 'N';
        $array['IDPROPRESC']          = isset($beneficio['IDPROPRESC'])          && !empty($beneficio['IDPROPRESC'])          ? $beneficio['IDPROPRESC']          : 'N';
        $array['IDPROPDTINSCR']       = isset($beneficio['IDPROPDTINSCR'])       && !empty($beneficio['IDPROPDTINSCR'])       ? $beneficio['IDPROPDTINSCR']       : 'N';
        $array['IDPROPDTCANC']        = isset($beneficio['IDPROPDTCANC'])        && !empty($beneficio['IDPROPDTCANC'])        ? $beneficio['IDPROPDTCANC']        : 'N';
        
        return $array;
    }
    
    private function getDsDescansoSemanal($nrvinculom){
        try {
            
            $dsDiasDescanso = self::SABDOM;
            
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $competencia = $this->hcmParameters->getDtCompetencia();
            $iniperiodo = clone $this->dtiniperiodobenef;
            $fimperiodo = clone $this->dtfimperiodobenef;

            /*$params = array('P_NRORG' => $nrorg,
                'P_NRVINCULOM' => $nrvinculom);
            $where = "NRVINCULOM = :P_NRVINCULOM AND NRORG = :P_NRORG AND '{$iniperiodo->format('d/m/Y')}' BETWEEN DTINIESCALA AND NVL(DTFIMESCALA, '{$fimperiodo->format('d/m/Y')}') AND DTINIESCALA = (SELECT MAX(DTINIESCALA) DTINIESCALA FROM GPE_ALTEESCALA MAX_ALTEESCALA WHERE MAX_ALTEESCALA.NRORG = e.NRORG AND MAX_ALTEESCALA.NRVINCULOM = e.NRVINCULOM)";
            $escalaTrabVinc = GpeAlteescala::getObjectByWhere($where, $params);*/

            $escalaTrabVinc = $this->entityManager->getRepository(Repositories::GPE_ALTEESCALA)->obterEscalaEntrePeriodo($iniperiodo, $fimperiodo, $this->hcmParameters->getDtCompetencia(), $nrvinculom, $this->hcmParameters->getNrorgTrabalho());

            // Caso haja turno e o turno tenha horários cadastrados, a contagem de dias deverá olhar apenas para o turno. Senão calculará da forma antiga.
            $this->nrturno = isset($escalaTrabVinc[0]) && isset($escalaTrabVinc[0]['NRTURNO']) && !empty($escalaTrabVinc[0]['NRTURNO']) ? $escalaTrabVinc[0]['NRTURNO'] : null; 
            if($this->nrturno) $this->nrHorarioTurno = GpeHorarioturno::getObjectByWhere("e.NRORG = :P_NRORG AND e.NRTURNO = :P_NRTURNO", ['P_NRORG' => $this->hcmParameters->getNrorgTrabalho(), "P_NRTURNO" => $this->nrturno]);

            if ($escalaTrabVinc) {
                 /*$where = "(NRORG = :P_NRORG OR NRORG = 0 OR NRORG IS NULL) AND NRESCALATRABM = :P_NRESCALATRABM AND NRESCALATRABH IN (SELECT NRESCALATRABH FROM GPE_ESCALATRABH WHERE (NRORG = :P_NRORG OR NRORG = 0 OR NRORG IS NULL) AND NRESCALATRABM = :P_NRESCALATRABM AND DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC) FROM GPE_ESCALATRABH MAX_ESCALATRABH WHERE MAX_ESCALATRABH.DTMESCOMPETENC <= '$competencia' AND MAX_ESCALATRABH.NRESCALATRABM = GPE_ESCALATRABH.NRESCALATRABM AND MAX_ESCALATRABH.NRORG = GPE_ESCALATRABH.NRORG))";
                $escalatrabalho = GpeEscalatrabh::getObjectByWhere($where, array('P_NRESCALATRABM' => $escalaTrabVinc->getNrescalatrabm(), 'P_NRORG' => $nrorg));*/
                $escalaTrabalho = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->_retornaUltimoHistorico(
                    $escalaTrabVinc[0]['NRESCALATRABM'], 
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getDtCompetencia()
                );

                // Verificar se período de apuração é definido na escala de trabalho do vínculo
                if($escalaTrabalho->getIdutapuratestbenef()  && ($escalaTrabalho->getIdutapuratestbenef() == 'S' || $escalaTrabalho->getIdutapuratestbenef() == 'Y')){ 
                    $this->diaInicialAupr = $escalaTrabalho->getNrdiainiapur();
                    $this->diaFinalAupr = $escalaTrabalho->getNrdiafinapur();
                }                 
                
                // $this->nrtpjornada = isset($escalaTrabalho) && !empty($escalaTrabalho) ? $escalaTrabalho->getNrtpjornada() : null;

                $this->geraBenefFeriado = isset($escalaTrabalho) && $escalaTrabalho->getIdgerbenfer() ? $escalaTrabalho->getIdgerbenfer() : null; // Parâmetro caso tenha valor 'S' não haverá subtração por feriado.

                $dsdescansosemanal = isset($escalaTrabalho) && !empty($escalaTrabalho) ? $escalaTrabalho->getDescansosemanal() : null;
                switch ($dsdescansosemanal) {
                    case('SABADO'): 
                        $dsDiasDescanso = self::SABADO;
                        break;
                    
                    case('SAB/DOM'): 
                        $dsDiasDescanso = self::SABDOM;
                        break;
                    
                    case('DOMINGO'): 
                        $dsDiasDescanso = self::DOMINGO;
                        break;
                    
                    case('SEGUNDA'): 
                        $dsDiasDescanso = self::SEGUNDA;
                        break;
                    
                    case('TERCA'): 
                        $dsDiasDescanso = self::TERCA;
                        break;
                    
                    case('QUARTA'): 
                        $dsDiasDescanso = self::QUARTA;
                        break;
                    
                    case('QUINTA'): 
                        $dsDiasDescanso = self::QUINTA;
                        break;
                    
                    case('SEXTA'): 
                        $dsDiasDescanso = self::SEXTA;
                        break;

                    case('6 X 1'): 
                        $dsDiasDescanso = self::DOMINGO;
                        break;

                    case('ESCALA'): 
                        $dsDiasDescanso = self::DOMINGO;
                        break;
                }
            }else {
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo '.$nrvinculom.' não possui escala.', MsgCalculo::ALERTA);
                //throw new \Exception('Vínculo '.$vinculo->getNrvinculom().' - '.$vinculo->getNmvinculom().' não possui escala.');
            }

            return $dsDiasDescanso;
            
        }catch (\Exception $e){
            throw $e;
        }
    }
    
    private function calcularQtdeDiasNoPeriodo(&$diasDeTrabalhoNoPeriodo, &$diasDSR, &$diasFeriado, $vinculo, $dsDiasDescanso, $id_minimizadorFeriado, $qtdeMesesRetrocederFeriado, $id_minimizadorDSR, $qtdeMesesRetrocederDSR){
        $arFeriados = $arDsr = $arrayDiasFolgaVinc = [];
        $diasFeriado = 0;
        
        if(!($dtinicio instanceof \DateTime))
            $dtinicio = DateUtil::getDataDeString($this->dtiniperiodobenef, DateUtil::FORMATO_BRASILEIRO, true);
        
        if(!($dtfinal instanceof \DateTime))
            $dtfinal = DateUtil::getDataDeString($this->dtfimperiodobenef, DateUtil::FORMATO_BRASILEIRO, true);
        
        $dias = $dtfinal->diff($dtinicio, true);
        
        if($id_minimizadorFeriado == 'S'){
            $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
            $dtPeriodoInicioCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetrocederFeriado.'M') );

            $dtPeriodoFimCalc    = clone $this->dtfimperiodobenef;
            $dtPeriodoFimCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetrocederFeriado.'M') );
            $arFeriados = $this->calcularQtdeFeriados($dtPeriodoInicioCalc, $dtPeriodoFimCalc, $vinculo);
        }
        
        $diasFeriado = count($arFeriados);
        
        // if( isset($this->nrtpjornada) && ($this->nrtpjornada == 2 || $this->nrtpjornada == 3 || $this->nrtpjornada == 4 || $this->nrtpjornada == 7) ){
        
        $diasDeTrabalhoNoPeriodo = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorVinc( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
            $this->hcmParameters->getDtCompetencia(), 
            $this->dtiniperiodobenef->format('d/m/Y'), 
            $dias->d, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $vinculo->getNrvinculom()
        );
        
        if( isset($this->nrturno) && $this->nrHorarioTurno && $diasDeTrabalhoNoPeriodo > 0){ // Deverá olhar para o turno apenas caso esteja na alteração de escala do vínculo e possua horários cadastrados
            $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc($this->dtiniperiodobenef, $dias, $vinculo->getNrvinculom()); 
            $diasFolga = count($arrayDiasFolgaVinc);
            $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
            $diasDeTrabalhoNoPeriodo = $diasDeTrabalhoNoPeriodo - ($diasFeriado - $intersecaoFolgaFeriado); // subtrair apenas feriados que não sejam em dias de folga
        }else{
            if($id_minimizadorDSR == 'S'){
                $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
                $dtPeriodoInicioCalc->sub( new \DateInterval('P'.$qtdeMesesRetrocederDSR.'M') );
    
                $dtPeriodoFimCalc    = clone $this->dtfimperiodobenef;
                $dtPeriodoFimCalc->sub( new \DateInterval('P'.$qtdeMesesRetrocederDSR.'M') );
                
                $arDsr = $this->calcularQtdeDiasDSR($dtPeriodoInicioCalc, $dtPeriodoFimCalc, $dsDiasDescanso);
            }
            
            $dias->d++;
            $intersecaoDsrFeriado  = count(array_intersect($arDsr, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
            $diasDSR     = count($arDsr);
            $diasDeTrabalhoNoPeriodo = $dias->d - $diasDSR - $diasFeriado + $intersecaoDsrFeriado;
        }
    }
  
    private function calcularQtdeDiasEmAviso(&$diasAviso, $vinculo, $dsDiasDescanso, $id_minimizadorDSR){
        
        $dtrescisao = null;

        if ($vinculo->getDtrescisaovinc()) 
            $dtrescisao = DateUtil::getDataDeString(substr($vinculo->getDtrescisaovinc(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);

        //if ($this->vinculo->getDtavisoprevio() and $dtrescisao->isBetween($iniperiodo, $fimperiodo)) {
        if( $dtrescisao
            && $vinculo->getDtavisoprevio()
            && DateUtil::comparaDatas($this->dtiniperiodobenef, $dtrescisao) 
            && DateUtil::comparaDatas($dtrescisao, $this->dtfimperiodobenef)
        ){
            $arrayDsr = [];
            
            $diasAviso = DateUtil::getQtdeDiasEntre($this->dtiniperiodobenef, $dtrescisao) + 1;
            
            if($id_minimizadorDSR == 'S') $arrayDsr = $this->calcularQtdeDiasDSR($this->dtiniperiodobenef, $dtrescisao, $dsDiasDescanso);
            
            $diasAviso -=  count($arrayDsr);

        }

    }

    private function calcularQtdeFaltas(&$diasFaltas, $qtdeMesesRetroceder, $nrvinculom, $vinculo){
       
        $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
        
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrtpmovimento = '1';
        $nreventom = "490, 495, 1040, 1043";
        $dtmescomp_falta = DateUtil::getPrimeiroDiaDoMes( $dtPeriodoInicioCalc->sub(new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M')) );

        /*$faltas = FpaCalculofolha::getSomaItemCalculo($nrvinculom, $nrorg, $dtmescomp_falta, $dtmescomp_falta, $nreventom, $nrtpmovimento, $dtmescomp_falta);*/

        $faltas = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getSomaItemCalculo(
            $nrvinculom, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $dtmescomp_falta, 
            $dtmescomp_falta, 
            $nreventom, 
            $nrtpmovimento, 
            $dtmescomp_falta
        );
        
        if(isset($faltas["VALOR"])){
            $diasFaltas = (int)$faltas['VALOR'];
        }
    }
    
    private function calcularQtdeDias_AtesOuAfast(&$dias_AtesOuAfast, $id_tpCalc, $qtdeMesesRetroceder, $vinculo, $dsDiasDescanso, $id_minimizadorFeriado, $id_minimizadorDSR){

        $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
        $dtPeriodoInicioCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M') );
        
        $dtPeriodoFimCalc    = clone $this->dtfimperiodobenef;
        $dtPeriodoFimCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M') );

        // Caso seja para contar dias de Atestado e na escala do vínculo tenha período pré-definido e id 'Utiliza para Atestados' preenchido,
        // função abaixo adequará perído de consideração de atestado segundo o informado no histórico da Escala do vínculo
        if($id_tpCalc == 'ATESTADO' && $this->diaInicialAupr && $this->diaFinalAupr) $this->setPeriodoApuracaoPelaEscala($dtPeriodoInicioCalc, $dtPeriodoFimCalc, $qtdeMesesRetroceder);

        $dtmescompetencia = $this->hcmParameters->getDtCompetencia();
        $nrorg = $this->hcmParameters->getNrorgTrabalho();

        //$nrestrutlegal = $this->vinculo->retornaUltimoHistoricoCompetencia($dtmescompetencia)->getNrestrutlegal();
        
        /*$listNrsitufuncm = GpeSitufunch::getAfastamentoIncideVale($dtmescompetencia);
        $listNrsitufuncm = implode(', ', $listNrsitufuncm);*/

        $listNrsitufuncm = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCH)->getAfastamentoIncideVale($dtmescompetencia);
        $listNrsitufuncm = implode(', ', $listNrsitufuncm);

        /*$where = "NRORG = :P_NRORG 
                    AND NRVINCULOM = :P_NRVINCULOM 
                    AND (
                               (DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) 
                            OR (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) 
                            OR (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) 
                            OR (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) 
                            OR (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) 
                            OR (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) 
                            OR (DTFIMSITUFUNC IS NULL) 
                            OR (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                    FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                    WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                                    AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM
                                                ) 
                                    AND NRSITUFUNCM NOT IN (12, 15, 16)
                                )
                        ) 
                    AND NRSITUFUNCM IN ($listNrsitufuncm)";
                  
        $param = array(
            'P_NRORG' => $nrorg,
            'P_NRVINCULOM' => $vinculo->getNrvinculom());

        //$altesitfuncs = GpeAltesitufunc::getObjectsByWhere("NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND ((DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo') OR (DTFIMSITUFUNC IS NULL OR DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo')) AND NRSITUFUNCM IN ($nrsitufuncm)",$param);
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);*/
        $altesitfuncs = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaSituacaoFuncional_AtesOuAfast(
            $this->hcmParameters->getNrorgTrabalho(), 
            $vinculo->getNrvinculom(), 
            $listNrsitufuncm, 
            $dtPeriodoInicioCalc, 
            $dtPeriodoFimCalc,
            $id_tpCalc
        );
        foreach($altesitfuncs as $altesitfunc){
        
            $dtInic = $dtFim = null;
            
            if ( $altesitfunc->getDtinisitufunc() < $dtPeriodoInicioCalc ) 
                $dtInic = $dtPeriodoInicioCalc;
            else 
                $dtInic = $altesitfunc->getDtinisitufunc();
            
    
            //Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
            if (!$altesitfunc->getDtfimsitufunc()) {
                
                $dtinisitufunc = $altesitfunc->getDtinisitufunc();
                
                /*$where = "NRORG = :P_NRORG AND
						  NRVINCULOM = :P_NRVINCULOM AND
						  DTINISITUFUNC > '$dtinisitufunc' AND
						  DTINISITUFUNC <= '$dtPeriodoInicioCalc' AND
						  NRSITUFUNCM NOT IN ($listNrsitufuncm)";
                $param = array(
                    'P_NRORG' => $nrorg,
                    'P_NRVINCULOM' => $vinculo->getNrvinculom());
                $prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);*/
                
                $prox_altesitufunc = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaProximaSituFuncional(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $vinculo->getNrvinculom(),
                    $dtinisitufunc,
                    $dtPeriodoFimCalc,
                    $listNrsitufuncm
                );
                

                if ($prox_altesitufunc) 
                    //Dia anterior da próxima situação geradora de vale
                    $dtFim = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
                else 
                    //Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
                    $dtFim = clone $dtPeriodoFimCalc;
                

            }else {
                
                if ($altesitfunc->getDtfimsitufunc() > $dtPeriodoFimCalc) 
                    $dtFim = $dtPeriodoFimCalc;
                else 
                    $dtFim = $altesitfunc->getDtfimsitufunc();
            }
    
            
            if ($dtFim >= $dtInic) {
                
                $arFeriados = $arDsr = $arrayDiasFolgaVinc = $arrayDiasAtestado = [];

                $qnt = $dtFim->diff($dtInic, true);
                
                $diasTotaisAtestOuAfast = ($qnt->d + $qnt->m*30 + $qnt->y*365 + 1);
                
                if($id_minimizadorFeriado == 'S') $arFeriados = $this->calcularQtdeFeriados($dtInic, $dtFim, $vinculo);
                $feriados = count($arFeriados);

                if( isset($this->nrturno)  && $this->nrHorarioTurno){ // Deverá olhar para o turno apenas caso esteja na alteração de escala do vínculo e possua horários cadastrados
                    $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc($dtInic, $qnt, $vinculo->getNrvinculom()); 
                    $diasFolga = count($arrayDiasFolgaVinc);
                    $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Atestado/Afastamento e Feriados
                    $dias_AtesOuAfast += $diasTotaisAtestOuAfast - $feriados - $diasFolga + $intersecaoFolgaFeriado;
                }else{
                    $intersecaoDsrFeriado = count(array_intersect($arDsr, $arFeriados)); // quantidade de dias que coincidem DSR e Feriados
                
                    if($id_minimizadorDSR == 'S') $arDsr = $this->calcularQtdeDiasDSR($dtInic, $dtFim, $dsDiasDescanso);
                    $dsr = count($arDsr);
                    
                    $dias_AtesOuAfast += $diasTotaisAtestOuAfast - $feriados - $dsr + $intersecaoDsrFeriado;
                }
            }
            
        }
        
    }

    private function calcularQtdeAtestados(&$diasAtestado, $qtdeMesesRetroceder, $nrvinculom){
       
        $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
        
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrorgpadrao = $this->hcmParameters->getNrorgPadrao();
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $nrtpmovimento = '1';
        $nreventom = "";
        $eventos = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaListaEventosRefAtestado($nrorg, $nrorgpadrao, $dtmescompetenc);
        foreach($eventos as $evento){
            $nreventom = ($nreventom == "" ? $evento->getNreventom() : $nreventom . ", " . $evento->getNreventom());
        }
        
        $dtmescomp_atestado = DateUtil::getPrimeiroDiaDoMes( $dtPeriodoInicioCalc->sub(new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M')) );

        $atestados = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getSomaItemCalculo(
            $nrvinculom, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $dtmescomp_atestado, 
            $dtmescomp_atestado, 
            $nreventom, 
            $nrtpmovimento, 
            $dtmescomp_atestado
        );
        
        if(isset($atestados["VALOR"])){
            $diasAtestado = (int)$atestados['VALOR'];
        }
    }
    
    private function setPeriodoApuracaoPelaEscala(&$dtiniperiodoAnt, &$dtfimperiodoAnt, $qtdeMesesRetroceder){
        $competenciaReferencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);

        // Subtrai (x-1) meses da competência para operar de acordo com a data final evidente na tela de escala
        if($qtdeMesesRetroceder>0){
            $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P'.($qtdeMesesRetroceder-1).'M'));
        }
        $dtfimperiodoAnt = clone $competenciaReferencia;
        $dtfimperiodoAnt = $dtfimperiodoAnt->add(new \DateInterval('P'. ($this->diaFinalAupr-1).'D'));
        
        // Subtrai mais um mes para operar de acordo com a data inicial evidente na tela de escala
        $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P1M')); 
        $dtiniperiodoAnt = clone $competenciaReferencia;
        $dtiniperiodoAnt = $dtiniperiodoAnt->add(new \DateInterval('P'. ($this->diaInicialAupr-1).'D'));
    }    
    
    private function calcularQtdeDiasFerias(&$diasFerias, $vinculo, $qtdeMesesRetroceder, $id_minimizadorDSR, $id_minimizadorFeriado, $dsDiasDescanso){
  
        $dtPeriodoInicioCalc = clone $this->dtiniperiodobenef;
        $dtPeriodoInicioCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M') );
        
        $dtPeriodoFimCalc    = clone $this->dtfimperiodobenef;
        $dtPeriodoFimCalc->sub( new \DateInterval('P'.(string)$qtdeMesesRetroceder.'M') );
        
        /*$ferias = FpaFerias::getPeriodoGozoFerias($vinculo->getNrvinculom(), $dtPeriodoInicioCalc, $dtPeriodoFimCalc, $this->hcmParameters->getNrorgTrabalho());*/
        $ferias = $this->entityManager->getRepository(Repositories::FPA_FERIAS)->getPeriodoGozoFerias(
            $vinculo->getNrvinculom(), 
            $dtPeriodoInicioCalc, 
            $dtPeriodoFimCalc, 
            $this->hcmParameters->getNrorgTrabalho()
        );

        if ($ferias) {
            $arDsr = $arFeriados = [];
            //$inicio = substr($ferias['DTINIGOZOFERIAS'], 0, 10);
            $inicio = DateUtil::retornaMaiorData( substr($ferias['DTINIGOZOFERIAS'], 0, 10), $dtPeriodoInicioCalc->format('d/m/Y') );
            //$final = substr($ferias['DTFIMGOZOFERIAS'], 0, 10);
            $final = DateUtil::retornaMenorData( substr($ferias['DTFIMGOZOFERIAS'], 0, 10), $dtPeriodoFimCalc->format('d/m/Y') );

            $totalFerias = DateUtil::getDataDeString($inicio)->diff(DateUtil::getDataDeString($final));

            if($id_minimizadorFeriado == 'S') $arFeriados = $this->calcularQtdeFeriados(DateUtil::getDataDeString($inicio), DateUtil::getDataDeString($final), $vinculo);
            $feriados = count($arFeriados);

            if( isset($this->nrturno) && $this->nrHorarioTurno ){ // Deverá olhar para o turno apenas caso esteja na alteração de escala do vínculo e possua horários cadastrados
                $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc(DateUtil::getDataDeString($inicio), $totalFerias, $vinculo->getNrvinculom()); 
                $diasFolga = count($arrayDiasFolgaVinc);
                $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
                $diasFerias = ($totalFerias->d+1) - $feriados - $diasFolga + $intersecaoFolgaFeriado;
            }else{
                if($id_minimizadorDSR == 'S') $arDsr = $this->calcularQtdeDiasDSR( DateUtil::getDataDeString($inicio), DateUtil::getDataDeString($final), $dsDiasDescanso);
                $intersecaoDsrFeriado = count(array_intersect($arDsr, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
                $diasFerias = ($totalFerias->d+1) - $feriados - count($arDsr) + $intersecaoDsrFeriado;
            }

        }
        
    }    

    private function calcularQtdeFeriados($dtiniperiodoapur, $dtfimperiodoapur, $vinculo){
        $result = array();
        $vinculoh = $vinculo->retornaUltimoHistoricoCompetencia($this->hcmParameters->getDtCompetencia());
        
        if(is_object($vinculoh)){
            $nrestrutlegal = $vinculoh->getNrestrutlegal();
        }
        
        $paramOrg = FPA::getGpeParametrosOrganizacao();
        
        //Busca calendario da estrutra de movimentacao.
        if($paramOrg->getNrtpestrutcalend()){
            
            $movimentacoes = $this->_movimentosVinculo->carregaMovimentacoesPorTipoEstrutura($vinculo->getNrorg(), $vinculo->getNrvinculom(), $this->hcmParameters->getUltimoDiaMes(), $paramOrg->getNrtpestrutcalend());
            
            if($movimentacoes){
                
                foreach ($movimentacoes as $movimentacao){
                    $nrestrutlegal = $movimentacao->getNrestruturam();
                }
            }
        }
        
        if($this->geraBenefFeriado == 'N'){
            /*$feriados = \Geral\Repositories\Estruturah::getFeriados($dtiniperiodoapur->format('d/m/Y'), $dtfimperiodoapur->format('d/m/Y'), $nrestrutlegal, $this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho());*/
            $feriados = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->getFeriados(
                $dtiniperiodoapur->format('d/m/Y'), 
                $dtfimperiodoapur->format('d/m/Y'), 
                $nrestrutlegal, 
                $this->hcmParameters->getDtCompetencia(),
                $this->hcmParameters->getNrorgTrabalho()
            );
            foreach($feriados as $feriado){
                $result[] = substr($feriado['DTCALENDARIO'], 0, 10);
            }
        }
        
        return $result;
    }
    
    private function calcularQtdeDiasDSR($dtIni, $dtFim, $dsDiasDescanso){

        $dtiniperiodoapur = clone $dtIni;
        $dtfimperiodoapur = clone $dtFim;

        $diasDsr = array();

        switch($dsDiasDescanso){
            case (self::SABADO):
                while($dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::DOMINGO):
                while($dtiniperiodoapur->format('N') != 7){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::SABDOM):
                while($dtiniperiodoapur->format('N') != 7 and $dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                if($dtiniperiodoapur->format('N') == 7){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                while($dtiniperiodoapur<$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                if(($dtfimperiodoapur->format('N') == 6 or $dtfimperiodoapur->format('N') == 7) and ($dtiniperiodoapur<=$dtfimperiodoapur)){
                    $diasDsr[] = $dtfimperiodoapur->format('d/m/Y');
                }
                break;
            
            
            case (self::SEGUNDA):
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::TERCA):
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::QUARTA):
                while($dtiniperiodoapur->format('N') != 3){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::QUINTA):
                while($dtiniperiodoapur->format('N') != 4){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
            
            case (self::SEXTA):
                while($dtiniperiodoapur->format('N') != 5){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            
        }
        return $diasDsr;
    }
    
    private function calcularQtdeDiasFolgaVinc($dtInic, $dias, $nrVinculo){
        $array = [];
        
        $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaVinc(
            $this->hcmParameters->getDtCompetencia(), 
            $dtInic->format('d/m/Y'), 
            $dias->d, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $nrVinculo
        );

        foreach($diasDeFolgaNoPeriodo as $value) $array[] = $value['DTDATA'];

        return $array;
    }

    private function calculaHistorico_Diario(&$foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $vlrPisoMens, $vlrTetoMens, $vlrPiso, $vlrTeto, $eventEmpresa, $eventVinc, $eventMensal, $eventoBeneficiarioL){
        $vlrEventMensal = null;
        $vlrEventVinc = null;
        $vlrEventEmpresa = null;
        $vlrEventBeneficiario = null;
        
        $vlrEventMensal = $qtdeBeneficio * $eventMensal['VALOR'] * $arrayDiasCalculados['DIASCONSIDERACAO'];
        
        $vlrEventVinc = $qtdeBeneficio * $eventVinc['VALOR'] * $arrayDiasCalculados['DIASCONSIDERACAO'];
        
        // Arredondar o valor do evento mensalidade depois de multiplicar pela quantidade de dias.
        $eventoMensal = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
            $eventMensal['EVENTO'], 
            $this->hcmParameters->getNrorgTrabalho(), 
            $this->hcmParameters->getNrorgPadrao(), 
            $this->hcmParameters->getDtCompetencia() 
        );
        if($eventoMensal){
            $vlrEventMensal = Valor::arredonda(
                $vlrEventMensal, 
                $eventoMensal->historico->getIdtipoarredonda(), 
                $eventoMensal->historico->getNrdigarredonda(),
                $eventoMensal->historico->getVrlimitearred()
            );
        }
    
        if( isset($vlrPisoMens) && $vlrEventMensal < $vlrPisoMens ) $vlrEventMensal = $vlrPisoMens;
        
        if( isset($vlrTetoMens) && $vlrEventMensal > $vlrTetoMens ) $vlrEventMensal = $vlrTetoMens;



        // Arredondar o valor do evento de desconto depois de multiplicar pela quantidade de dias.
        $eventoVinc = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
            $eventVinc['EVENTO'], 
            $this->hcmParameters->getNrorgTrabalho(), 
            $this->hcmParameters->getNrorgPadrao(), 
            $this->hcmParameters->getDtCompetencia() 
        );
        if($eventoVinc){
            $vlrEventVinc = Valor::arredonda(
                $vlrEventVinc, 
                $eventoVinc->historico->getIdtipoarredonda(), 
                $eventoVinc->historico->getNrdigarredonda(),
                $eventoVinc->historico->getVrlimitearred()
            );
        }


        if( isset($vlrPiso) && $vlrEventVinc < $vlrPiso ) $vlrEventVinc = $vlrPiso;
        
        if( isset($vlrTeto) && $vlrEventVinc > $vlrTeto ) $vlrEventVinc = $vlrTeto;


        
        if($eventEmpresa['EVENTO']){
            $vlrEventEmpresa = $vlrEventMensal - $vlrEventVinc;
        }
        
        if($eventoBeneficiario['VALOR']){
            $vlrEventBeneficiario = $qtdeBeneficio * $eventoBeneficiario['VALOR'] * $arrayDiasCalculados['DIASCONSIDERACAO'];

            // Arredondar o valor do evento do beneficiário depois de multiplicar pela quantidade de dias.
            $objEventBenef = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                $eventoBeneficiario['EVENTO'], 
                $this->hcmParameters->getNrorgTrabalho(), 
                $this->hcmParameters->getNrorgPadrao(), 
                $this->hcmParameters->getDtCompetencia() 
            );
            if($objEventBenef){
                $vlrEventBeneficiario = Valor::arredonda(
                    $vlrEventBeneficiario, 
                    $objEventBenef->historico->getIdtipoarredonda(), 
                    $objEventBenef->historico->getNrdigarredonda(),
                    $objEventBenef->historico->getVrlimitearred()
                );
            }
        }
        
        //Mensal
        if($vlrEventMensal){
            $this->persistirHistorico_Diario($foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $eventMensal['EVENTO'], $eventMensal['VALOR'], $vlrEventMensal);
        }
        //Vinc
        if($vlrEventVinc){
            $this->persistirHistorico_Diario($foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $eventVinc['EVENTO'], $eventVinc['VALOR'], $vlrEventVinc);
        }
        
        //Empresa  
        if($vlrEventEmpresa){
            $this->persistirHistorico_Diario($foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $eventEmpresa['EVENTO'], $eventEmpresa['VALOR'], $vlrEventEmpresa);
        }
        
        //beneficiario
        if($vlrEventBeneficiario){
            $this->persistirHistorico_Diario($foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $eventoBeneficiario['EVENTO'], $eventoBeneficiario['VALOR'], $vlrEventBeneficiario);
        }
    }    
    
    public function persistirHistorico_Diario(&$foiCalculado, $nrcalculobenef, $nrbeneficiom, $nrvinculom, $qtdeBeneficio, $arrayDiasCalculados, $nrEvento, $valorEvento, $vlrTotalBenef){
        
        if($valorEvento >= 0){
            
            $foiCalculado = true;

            $row = $this->entityManager->getRepository(Repositories::VAB_HISTBENEFVINC)->findOneBy( 
                [ 
                 'nrcalculofolha' => $nrcalculobenef,
                 'dtmescompetenc' => Dateutil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true),
                 'nrbeneficiom'   => $nrbeneficiom,
                 'nrvinculom'     => $nrvinculom,
                 'nreventom'      => $nrEvento,
                 'nrorg'          => $this->hcmParameters->getNrorgTrabalho(),
                 'dtpgtobenef'    => DateUtil::truncateData($this->dtPagamentoBenef)
                ]
            );
            
            if($row){
                $this->entityManager->remove($row);
                $this->entityManager->flush();
            }

            try {
                $this->calculoBeneficioRepository->persistirHistorico_Diario(
                    $nrcalculobenef, 
                    $nrbeneficiom, 
                    $nrvinculom,
                    $nrEvento, 
                    $valorEvento, 
                    $arrayDiasCalculados, 
                    $this->dtiniperiodobenefmod, 
                    $this->dtfimperiodobenefmod, 
                    $this->dtPagamentoBenef->format('d/m/Y h:m:s'),
                    $vlrTotalBenef,
                    $qtdeBeneficio
                );

            } catch (Exception $e) {
                throw $e;    
            }
        }
    }


    /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    -=                                           -=
    -= ABAIXO, REFERENTE AO CÁLCULO DOS EVENTOS  -=
    -=                                           -=
    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

    public function calcularBeneficio($nrcalculobenef, $subsidio100PorAfastamentoOuDemissao, $beneficio, &$eventos, $beneficiario, $vinculo, $nrvinculom, &$qtdBeneficiariosPerEvento, $proporcao, $tpperiodo, $isLast, $arrayDiasCalculados = null, &$foiCalculado = false, $qtdiasbenef = null, &$eventoEparcelas = []) {
        
        // Transforma as datas para serem comparáveis entre si
        $dtcompetencia       = substr($this->hcmParameters->getDtCompetencia(), 0, 10);
        $ultimoDiaComp       = substr($this->hcmParameters->getDtCompetencia(), 0, 10);
        $dtinivigencia       = substr($beneficio['DTINICIOVIGENCIA'], 0, 10);
        $dtfimvigencia       = substr($beneficio['DTFINALVIGENCIA'], 0, 10);
        $dtcancbeneficiario  = substr($beneficiario->getDtcancbeneficiario(), 0, 10);
        $dtinscrbeneficiario = substr($beneficiario->getDtinscbeneficiario(), 0, 10);
        $dtcompetencia       = $dtcompetencia       ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $dtcompetencia)->format('Y-m-d')       : null;   
        $ultimoDiaComp       = $ultimoDiaComp       ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $ultimoDiaComp)->format('Y-m-t')       : null;   
        $dtinivigencia       = $dtinivigencia       ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $dtinivigencia)->format('Y-m-d')       : null;   
        $dtfimvigencia       = $dtfimvigencia       ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $dtfimvigencia)->format('Y-m-d')       : null;  
        $dtcancbeneficiario  = $dtcancbeneficiario  ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $dtcancbeneficiario)->format('Y-m-d')  : null;  
        $dtinscrbeneficiario = $dtinscrbeneficiario ? DateTime::createFromFormat(DateUtil::FORMATO_BRASILEIRO, $dtinscrbeneficiario)->format('Y-m-d') : null;
        
        if( $beneficio 
            && strtotime($dtinivigencia) <= strtotime($dtcompetencia)
            && ( !isset($dtfimvigencia) || strtotime($dtcompetencia) <= strtotime($dtfimvigencia) )
            && ( !isset($dtinscrbeneficiario) || strtotime($ultimoDiaComp) >= strtotime($dtinscrbeneficiario) ) 
            && ( !isset($dtcancbeneficiario) || strtotime($dtcompetencia) < strtotime($dtcancbeneficiario) )     
          ){
            $vincBenefiarioEvento         = []; // Array para gravar em VAB_APURABENEFICIO a relação Vínculo/Beneficiário/TipoEvento/Evento
            $vincBenefiarioEvento_mens    = []; // Array para gravar em VAB_APURABENEFICIO a relação Vínculo/Beneficiário/TipoEvento/Evento
            $vincBenefiarioEvento_vinc    = []; // Array para gravar em VAB_APURABENEFICIO a relação Vínculo/Beneficiário/TipoEvento/Evento
            $vincBenefiarioEvento_empresa = []; // Array para gravar em VAB_APURABENEFICIO a relação Vínculo/Beneficiário/TipoEvento/Evento

            $tpBeneficiario     = $beneficiario->getIdtpbeneficiario() ? $beneficiario->getIdtpbeneficiario() : null;
            $eventoBeneficiario = intval($beneficiario->getNreventom());

            $vlrEventoMensal    = null; // Variaveis a serem usadas para cálculos de 
            $vlrEventoVinc      = 0;    // Evento Vínculo e Evento Empresa, respectivamente
            
            $vlrEventoEmpr      = 0;    // Esta em específico é usada apenas para o cálculo de subsidiado diferente de 100%
            
            $efetuarCalculo     = true; // Variável booleana, para verificar se é para calcular, com base nas verificações por nascimento e sexo
            
            $nreventomensa; $vlrlinearbeneficio; $eventVinc;         $tpParticipacao;   $eventEmpresa; 
            $nrtabelafolha; $nrFaixaSalarial;    $idadeBeneficiario; $idadeMaxSubsidio; $tpRelac;
            $vlrPiso;       $vlrTeto;            $isDeficiente;      $sexoBeneficiario; $sexoSubsidio;
            $nreventotaxa;  $vreventotaxa;
            
            if($tpperiodo === 'MENSAL'){
                $nreventotaxa = intval($beneficio['NREVENTOTAXA']);
                $vreventotaxa = $beneficio['VREVENTOTAXA'];
            }else{
                $nreventotaxa = null;
                $vreventotaxa = null;
            }
            
            $idSubsidiario100 = $this->entityManager->getRepository(Repositories::VAB_BENEFICIARIO)->getIdSubisido100($beneficiario->getNrorg(), $beneficiario->getNrbeneficiario());
            $percentSubsidio = $this->entityManager->getRepository(Repositories::VAB_BENEFICIARIO)->getPercentSubsidio($beneficiario->getNrorg(), $beneficiario->getNrbeneficiario());

            // Histórico do vínculo é carregado a fim de se ter acesso ao valor IDASSOCSINDICATO 
            $histVinc = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->_retornaHistórico($nrvinculom, $this->hcmParameters->getNrorgTrabalho(), $this->hcmParameters->getDtCompetencia());
            $this->histVinc = $histVinc;
            // Caso o vínculo seja de um sindicato é para considerar o campo 'percentual/valor associado' se e somente se este tiver valor
            $idAssocSind = isset($histVinc['IDASSOCSINDICATO']) ? $histVinc['IDASSOCSINDICATO'] : 'N' ; 

            $vlrPisoMens = isset($beneficio['VRPISOTITULARMENS']) && !empty($beneficio['VRPISOTITULARMENS']) ? $beneficio['VRPISOTITULARMENS'] : null;
            $vlrTetoMens = isset($beneficio['VRTETOTITULARMENS']) && !empty($beneficio['VRTETOTITULARMENS']) ? $beneficio['VRTETOTITULARMENS'] : null;
            
            if( $tpBeneficiario === 'T' ){
                $nreventomensa             = intval($beneficio['NREVENTOMENSA']);
                $vlrlinearbeneficio        = isset($beneficio['VRLINEARBENEFICIO']) && !empty($beneficio['VRLINEARBENEFICIO']) ? $beneficio['VRLINEARBENEFICIO'] : null;
                $eventVinc                 = intval($beneficio['NREVETITULARVINC']);
                $tpParticipacao            = $beneficio['NRTIPOPARTICIPATITULAR'];
                $percentOuVlrParticipacao  = $idAssocSind == 'S' && isset($beneficio['VRTITULARSIND']) ? $beneficio['VRTITULARSIND'] : $beneficio['VRPARTICIPATITULAR'];
                $eventEmpresa              = intval($beneficio['NREVETITULAREMP']);
                $nrtabelafolha             = isset($beneficio['NRTABELAFOLHAPRI']) && !empty($beneficio['NRTABELAFOLHAPRI']) ? explode(", ", $beneficio['NRTABELAFOLHAPRI']) : null;
                $nrFaixaSalarial           = isset($beneficio['NRTABFAIXASALTIT']) && !empty($beneficio['NRTABFAIXASALTIT']) ? explode(", ", $beneficio['NRTABFAIXASALTIT']) : null;
                $idadeMaxSubsidio          = null;
                $sexoSubsidio              = null;
                $vlrPiso                   = $idAssocSind == 'S' && isset($beneficio['VRPISOTITULARSIND']) ? $beneficio['VRPISOTITULARSIND'] : $beneficio['VRPISOTITULAR']; 
                $vlrTeto                   = $idAssocSind == 'S' && isset($beneficio['VRTETOTITULARSIND']) ? $beneficio['VRTETOTITULARSIND'] : $beneficio['VRTETOTITULAR'];


                $this->validaJornadaReduzida($beneficio, $nrvinculom, $vlrlinearbeneficio);

            }else if( $tpBeneficiario === 'D' ){
                $tpRelacAndDtNascAndNmpessoa = $this->pessoaService->getTipoRelacionamentoPorPessoa(
                    $beneficiario->getNrvinculom(), 
                    $beneficiario->getNrpessoa(), 
                    $this->hcmParameters->getNrorgTrabalho(),
                    $this->hcmParameters->getDtCompetencia()
                );

                $tpRelac               = $tpRelacAndDtNascAndNmpessoa['NRTIPORELACIONA'];
                $idadeBeneficiario     = isset($tpRelacAndDtNascAndNmpessoa['DTNASCPESSOA']) ? substr($tpRelacAndDtNascAndNmpessoa['DTNASCPESSOA'], 0, -9) : null;
                $sexoBeneficiario      = isset($tpRelacAndDtNascAndNmpessoa['IDSEXOPESSOA']) ? $tpRelacAndDtNascAndNmpessoa['IDSEXOPESSOA'] : null;
                
                $pessoa = new GpepessoaEntity($this->entityManager, $this->hcmParameters);
                
                $isDeficiente = $pessoa->verificaPessoaDeficiente(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $beneficiario->getNrpessoa(), 
                    $this->hcmParameters->getDtCompetencia()
                );
                
                if($idadeBeneficiario){
                    $idadeBeneficiario = $idadeBeneficiario ? DateUtil::getDataDeString($idadeBeneficiario) : null;
                    $idadeBeneficiario = $idadeBeneficiario->diff(DateUtil::getDataAtual())->format('%y');                
                }
                
                $nreventomensa             = intval($beneficio['NREVENTOMENSADEP']);
                $vlrlinearbeneficio        = isset($beneficio['VRLINEARBENEFICIODEP']) && !empty($beneficio['VRLINEARBENEFICIODEP']) ? $beneficio['VRLINEARBENEFICIODEP'] : null;
                $eventVinc                 = intval($beneficio['NREVEDEPEVINC']);
                $tpParticipacao            = $beneficio['NRTIPOPARTICIPADEP'];
                $percentOuVlrParticipacao  = $idAssocSind == 'S' && isset($beneficio['VRDEPSIND']) ? $beneficio['VRDEPSIND'] : $beneficio['VRPARTICIPADEPE'];
                $eventEmpresa              = intval($beneficio['NREVEDEPEMPRESA']);
                $nrtabelafolha             = isset($beneficio['NRTABELAFOLHASEC']) && !empty($beneficio['NRTABELAFOLHASEC']) ? explode(", ", $beneficio['NRTABELAFOLHASEC']) : null;
                $nrFaixaSalarial           = isset($beneficio['NRTABFAIXASALDEP']) && !empty($beneficio['NRTABFAIXASALDEP']) ? explode(", ", $beneficio['NRTABFAIXASALDEP']) : null;
                $idadeMaxSubsidio          = $tpRelac == 3 ? $beneficio['NRIDADEMAXSUBFILHOS'] : $beneficio['NRIDADEMAXSUBDEP'];
                $sexoSubsidio              = $tpRelac == 3 ? $beneficio['SEXOSUBSIDIOFILHO'] : $beneficio['SEXOSUBSIDIODEP'];
                $vlrPiso                   = $idAssocSind == 'S' && isset($beneficio['VRPISODEPSIND']) ? $beneficio['VRPISODEPSIND'] : $beneficio['VRPISODEP'];
                $vlrTeto                   = $idAssocSind == 'S' && isset($beneficio['VRTETODEPSIND']) ? $beneficio['VRTETODEPSIND'] : $beneficio['VRTETODEP'];
            }
            

            // Se o beneficiário for dependente, tiver idade de subsídio no benefício, e não tiver dtnascimento no BD, não será calculada a Mensalidade.
            // Se o beneficiário for dependente, a mensalidade for por faixa etária e não tiver dtnascimento no BD, não será calculada a Mensalidade.
            if( $tpBeneficiario === 'D' 
                && ( 
                        ( isset($idadeMaxSubsidio)    && !isset($idadeBeneficiario) ) 
                     || ( !isset($vlrlinearbeneficio) && !isset($idadeBeneficiario) )
                   ) 
            ){
                MsgCalculo::getInstance()->adicionaMensagem('Dependente '.$tpRelacAndDtNascAndNmpessoa['NMPESSOA'].' não possui data de nascimento.', MsgCalculo::ALERTA);
                $efetuarCalculo = false;
            }
            
            // Se o beneficiário for dependente, tiver sexo Subsídio no benefício, e não tiver sexo cadastrado no BD, não será calculada a Mensalidade.
            if( $tpBeneficiario === 'D' && isset($sexoSubsidio) && !isset($sexoBeneficiario) ){
                MsgCalculo::getInstance()->adicionaMensagem('Dependente '.$tpRelacAndDtNascAndNmpessoa['NMPESSOA'].' não possui sexo cadastrado.', MsgCalculo::ALERTA);
                $efetuarCalculo = false;
            }
            
            if($efetuarCalculo){
                // Calcula o valor para o evento setado no field "Evento", da aba "Beneficiário Por Evento"   
                if( isset($eventoBeneficiario) && !empty($eventoBeneficiario) ){

                    if( array_key_exists($eventoBeneficiario, $eventos) ){
                        $vlrAnterior                  = $eventos[$eventoBeneficiario];
                        $eventos[$eventoBeneficiario] = $this->calcularEventoBeneficiario($vincBenefiarioEvento, $eventoBeneficiario, $beneficio, $beneficiario, $nrtabelafolha, $proporcao, $tpperiodo, $eventos[$eventoBeneficiario]);
                        $vlrPosterior                 = $eventos[$eventoBeneficiario];
                        
                        $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventoBeneficiario, $vlrAnterior, $vlrPosterior);
                    
                    }else{
                        $eventos[$eventoBeneficiario] = $this->calcularEventoBeneficiario($vincBenefiarioEvento, $eventoBeneficiario, $beneficio, $beneficiario, $nrtabelafolha, $proporcao, $tpperiodo);

                        $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventoBeneficiario);
                    }
                    $eventoEparcelas[$eventoBeneficiario] = intval($beneficio['QTDPARCELAS']);
                }
                
                // Calcula o evento setado ou no field "Evento Mensalidade" ou no field "Evento Mensalidade (Dependente)"
                if( isset($nreventomensa) && !empty($nreventomensa) ){

                    // Função retorna valor a ser multiplicado a partir de outros parâmetros avaliados. Tais valores e parâmetros estão no benefício do sindicato.
                    $vlrMultiplicador = $this->getMultiplicadorMensalidade($beneficio, $vinculo, $histVinc, $nreventomensa);
                        
                    if( array_key_exists($nreventomensa, $eventos)){
                        $vlrAnterior             = $eventos[$nreventomensa];
                        $eventos[$nreventomensa] = $this->calcularEventoMensalidade($vincBenefiarioEvento_mens, $nreventomensa, $vlrMultiplicador, $beneficio, $beneficiario, $nrtabelafolha, $vlrEventoMensal, $vlrlinearbeneficio, $tpperiodo, $proporcao, $vlrPisoMens, $vlrTetoMens, $eventos[$nreventomensa]);
                        $vlrPosterior            = $eventos[$nreventomensa];

                        $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $nreventomensa, $vlrAnterior, $vlrPosterior);

                    }else{
                        $eventos[$nreventomensa] = $this->calcularEventoMensalidade($vincBenefiarioEvento_mens, $nreventomensa, $vlrMultiplicador, $beneficio, $beneficiario, $nrtabelafolha, $vlrEventoMensal, $vlrlinearbeneficio, $tpperiodo, $proporcao, $vlrPisoMens, $vlrTetoMens);

                        $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $nreventomensa);
                    }
                    $eventoEparcelas[$nreventomensa] = intval($beneficio['QTDPARCELAS']);
                    
                    // Caso seja o último beneficiário do vínculo para que já possua o valor total da mensalidade
                    if($isLast){
                        // Se não usufruiu do multiplicador por possui um dos eventos da lista
                        if($vlrMultiplicador == 1 && !empty($beneficio['DSINCIDEVENTO']) && !empty($beneficio['NREVETITULARVINC'])){
                            // Caso tenha o valor fixo ou percentual sobre o valor da mensalidade é realizado o acréscimo no desconto do vínculo
                            if(!is_null($beneficio['VRFIXACRESDESC'])){
                                 $vlrAcresDesconto = $beneficio['VRFIXACRESDESC'];
                            }elseif(!is_null($beneficio['VRPERACRESCDESC'])){
                                $vlrAcresDesconto = $eventos[$nreventomensa] * $beneficio['VRPERACRESCDESC'] / 100;
                            }else{
                                $vlrAcresDesconto = 0;
                            }
                            $eventos[$beneficio['NREVETITULARVINC']] += $vlrAcresDesconto;
                        }
                    }
                }
                
                // - Se a opção 'subsidado 100%' estiver como sim, a empresa pagará o valor total do benefício
                // - Se o funcionário estiver afastado com excessão de licensa maternidade e de demissão, com atributo 'Gera Vale-Transporte Benefícios' 
                //    da situação funcional como não, com data inicial de afastamento anterior à competencia, 
                //    e com data final maior que o último dia da competencia, a empresa pagara tudo.
                // - Se a opção para 'considerar vínculos rescindidos do mês anterior' estiver marcada e o vínculo estiver rescindido no mês anterior, 
                //    a empresa pagará tudo.
                
                if($idSubsidiario100 == 'S' || $subsidio100PorAfastamentoOuDemissao){

                    // Calcula o evento setado ou no field "Evento Titular (Empresa)" ou no field "Evento Dependente (Empresa)", apenas se houver mensalidade
                    if( $vlrEventoMensal && isset($eventEmpresa) && !empty($eventEmpresa) && ($vlrEventoMensal > $vlrEventoVinc) ){
                        if(array_key_exists($eventEmpresa, $eventos)){
                            $vlrAnterior             = $eventos[$eventEmpresa];
                            $eventos[$eventEmpresa] += $vincBenefiarioEvento_empresa[$eventEmpresa] = $vlrEventoMensal; // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizado
                            $vlrPosterior            = $eventos[$eventEmpresa];
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventEmpresa] = $vincBenefiarioEvento_empresa[$eventEmpresa] = $vlrEventoMensal; // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizado
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa);
                        }
                        $eventoEparcelas[$eventEmpresa] = intval($beneficio['QTDPARCELAS']);
                    }

                    // Calcula o evento setado ou no field "Evento Titular (Vínculo)" ou no field "Evento Dependente (Vínculo)"
                    if( isset($eventVinc) && !empty($eventVinc)){
                        if(array_key_exists($eventVinc, $eventos)){
                            
                            $vlrAnterior         = $eventos[$eventVinc];
                            $eventos[$eventVinc] += $vincBenefiarioEvento_vinc[$eventVinc] = 0;
                            $vlrPosterior        = $eventos[$eventVinc];
                            
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventVinc] = $vincBenefiarioEvento_vinc[$eventVinc] = 0;
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc);
                        }
                        $eventoEparcelas[$eventVinc] = intval($beneficio['QTDPARCELAS']);
                    }
                    
                    if($tpperiodo == 'DIARIO'){
                        $eventos[$eventEmpresa] = 0;
                    }
                }
                else
                // Se o campo '% Subsídio' estiver com valor, a Empresa pagará o percentual da Mensalidade calculado a partir deste valor. 
                if(isset($percentSubsidio) && $percentSubsidio >= 0){

                    // Calcula o evento setado ou no field "Evento Titular (Empresa)" ou no field "Evento Dependente (Empresa)", apenas se houver mensalidade
                    if( $vlrEventoMensal && isset($eventEmpresa) && !empty($eventEmpresa)){

                        $vlrEventoEmpr = $vlrEventoMensal * ($percentSubsidio/100); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizado

                        if(array_key_exists($eventEmpresa, $eventos)){
                            $vlrAnterior             = $eventos[$eventEmpresa];
                            $eventos[$eventEmpresa] += $vincBenefiarioEvento_empresa[$eventEmpresa] = $vlrEventoEmpr;
                            $vlrPosterior            = $eventos[$eventEmpresa];
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventEmpresa] = $vincBenefiarioEvento_empresa[$eventEmpresa] = $vlrEventoEmpr;
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa);
                        }
                        $eventoEparcelas[$eventEmpresa] = intval($beneficio['QTDPARCELAS']);
                    }

                    // Calcula o evento setado ou no field "Evento Titular (Vínculo)" ou no field "Evento Dependente (Vínculo)"
                    if( isset($eventVinc) && !empty($eventVinc)){
                        if(array_key_exists($eventVinc, $eventos)){
                            
                            $vlrAnterior         = $eventos[$eventVinc];
                            $eventos[$eventVinc] += $vincBenefiarioEvento_vinc[$eventVinc] = ($vlrEventoMensal - $vlrEventoEmpr); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal e $vlrEventoEmpr já estão proporcionalizados
                            $vlrPosterior        = $eventos[$eventVinc];
                            
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventVinc] = $vincBenefiarioEvento_vinc[$eventVinc] = ($vlrEventoMensal - $vlrEventoEmpr); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal e $vlrEventoEmpr já estão proporcionalizados
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc);
                        }
                        $eventoEparcelas[$eventVinc] = intval($beneficio['QTDPARCELAS']);
                    } 
                }
                else
                // Se beneficiario é titular, ou deficiente, ou dependente com idade menor que a de subsidio, ou com o sexo Subsídio igual ao sexo Cadastrado, 
                // há desconto do benefício. Senão, pagará o valor integral.
                if( 
                       ( $tpBeneficiario == 'T' )    
                    || ( $isDeficiente ) 
                    || (
                            ( !isset($idadeMaxSubsidio) || ($idadeBeneficiario <= $idadeMaxSubsidio) )
                         && ( !isset($sexoSubsidio) || ($sexoBeneficiario === $sexoSubsidio) ) 
                       )
                        
                 ){
                    
                    // Calcula o evento setado ou no field "Evento Titular (Vínculo)" ou no field "Evento Dependente (Vínculo)"
                    if( isset($eventVinc) && !empty($eventVinc)){
                        if(array_key_exists($eventVinc, $eventos)){
                            $vlrAnterior         = $eventos[$eventVinc];
                            $eventos[$eventVinc] = $this->calcularEventoVinculo($vincBenefiarioEvento_vinc, $tpperiodo, $eventVinc, $vlrPiso, $vlrTeto, $beneficio, $beneficiario, $vlrEventoVinc, $vlrEventoMensal, $tpParticipacao, $percentOuVlrParticipacao, $nrFaixaSalarial, $proporcao, $eventos[$eventVinc]);
                            $vlrPosterior        = $eventos[$eventVinc];
                            
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventVinc] = $this->calcularEventoVinculo($vincBenefiarioEvento_vinc, $tpperiodo, $eventVinc, $vlrPiso, $vlrTeto, $beneficio, $beneficiario, $vlrEventoVinc, $vlrEventoMensal, $tpParticipacao, $percentOuVlrParticipacao, $nrFaixaSalarial, $proporcao);
                            
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc);
                        }
                        $eventoEparcelas[$eventVinc] = intval($beneficio['QTDPARCELAS']);
                    }           
    
                    // Calcula o evento setado ou no field "Evento Titular (Empresa)" ou no field "Evento Dependente (Empresa)", apenas se houver mensalidade
                    if( $vlrEventoMensal && isset($eventEmpresa) && !empty($eventEmpresa) && ($vlrEventoMensal > $vlrEventoVinc)){
                        if(array_key_exists($eventEmpresa, $eventos)){
                            $vlrAnterior             = $eventos[$eventEmpresa];
                            $eventos[$eventEmpresa] += $vincBenefiarioEvento_empresa[$eventEmpresa] = ($vlrEventoMensal - $vlrEventoVinc); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal e $vlrEventoVinc já estão proporcionalizados
                            $vlrPosterior            = $eventos[$eventEmpresa];
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventEmpresa] = $vincBenefiarioEvento_empresa[$eventEmpresa] = ($vlrEventoMensal - $vlrEventoVinc); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal e $vlrEventoVinc já estão proporcionalizados
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventEmpresa);
                        }
                        $eventoEparcelas[$eventEmpresa] = intval($beneficio['QTDPARCELAS']);
                    }
                    
                }else{
                    // Calcula o evento setado ou no field "Evento Titular (Vínculo)" ou no field "Evento Dependente (Vínculo)"
                    if( isset($eventVinc) && !empty($eventVinc)){
                        if(array_key_exists($eventVinc, $eventos)){
                            $vlrAnterior          = $eventos[$eventVinc];
                            $eventos[$eventVinc] += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoMensal; // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizados
                            $vlrPosterior         = $eventos[$eventVinc];
                            
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc, $vlrAnterior, $vlrPosterior);
    
                        }else{
                            $eventos[$eventVinc] = $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoMensal; // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizados
    
                            $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $eventVinc);
                        }
                        $eventoEparcelas[$eventVinc] = intval($beneficio['QTDPARCELAS']);
                    }
                }
                
                // Caso o benefício seja do tipo Mensal, é Persistido os valores na tabela de histórico Mensal. 
                // Se for Diário, será persistido na tabela de histórico Diário
                if($tpperiodo === 'MENSAL'){
                    
                    // Caso haja evento setado no field 'Eventos Taxa de Inclusão/Implantação' e a data de inscrição do beneficiário estiver na competência vigente,
                    // deverá calcular tal evento para o beneficiário
                    if($dtcompetencia <= $dtinscrbeneficiario && $dtinscrbeneficiario <= $ultimoDiaComp){
                        if( isset($nreventotaxa) && !empty($nreventotaxa)){
                            if(array_key_exists($nreventotaxa, $eventos)){
                                $vlrAnterior            = $eventos[$nreventotaxa];
                                $eventos[$nreventotaxa] += $vreventotaxa; 
                                $vlrPosterior           = $eventos[$nreventotaxa];
                                $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $nreventotaxa, $vlrAnterior, $vlrPosterior);
        
                            }else{
                                $eventos[$nreventotaxa] = $vreventotaxa; 

                                $this->validaQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento, $eventos, $nreventotaxa);
                            }
                            $eventoEparcelas[$nreventotaxa] = intval($beneficio['QTDPARCELAS']);
                        }
                    }

                    $this->persistirHistoricoCalculoDIRF_Mensal(
                        $nrcalculobenef,
                        $beneficio['NRBENEFICIOM'],
                        $beneficiario->getNrvinculom(), 
                        $beneficiario->getNrpessoa(),
                        $proporcao,
                        $vincBenefiarioEvento, 
                        $vincBenefiarioEvento_mens, 
                        $vincBenefiarioEvento_vinc, 
                        $vincBenefiarioEvento_empresa
                    );
    
                }else if($tpperiodo === 'DIARIO'){

                    if($eventVinc){
                        $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                            $eventVinc, 
                            $this->hcmParameters->getNrorgTrabalho(), 
                            $this->hcmParameters->getNrorgPadrao(), 
                            $this->hcmParameters->getDtCompetencia() 
                        );                    
    
                        if( !$subsidio100PorAfastamentoOuDemissao && isset($vlrPiso) ){
                            $vlrPiso = Valor::arredonda(
                                $vlrPiso, 
                                $eventoh->historico->getIdtipoarredonda(), 
                                $eventoh->historico->getNrdigarredonda(),
                                $eventoh->historico->getVrlimitearred()
                            );           
                        }else
                            $vlrPiso = null;
    
                        if( !$subsidio100PorAfastamentoOuDemissao && isset($vlrTeto) ){
                            $vlrTeto = Valor::arredonda(
                                $vlrTeto, 
                                $eventoh->historico->getIdtipoarredonda(), 
                                $eventoh->historico->getNrdigarredonda(),
                                $eventoh->historico->getVrlimitearred()
                            );          
                        }else
                            $vlrTeto = null;
                    }
                    
                    $eventEmpresa = array('EVENTO' => $eventEmpresa, 'VALOR' => $eventos[$eventEmpresa]);
                    $eventVinc = array('EVENTO' => $eventVinc, 'VALOR' => $eventos[$eventVinc]);
                    $eventomensal = array('EVENTO' => $nreventomensa, 'VALOR' => $eventos[$nreventomensa]);
                    $eventoBeneficiario = array('EVENTO' => $eventoBeneficiario, 'VALOR' => $eventos[$eventoBeneficiario]);
                    
                    $this->calculaHistorico_Diario(
                        $foiCalculado,
                        $nrcalculobenef,
                        $beneficio['NRBENEFICIOM'],
                        $beneficiario->getNrvinculom(), 
                        $beneficiario->getQtbeneficio(),
                        $arrayDiasCalculados,
                        $vlrPisoMens,
                        $vlrTetoMens,
                        $vlrPiso,
                        $vlrTeto,
                        $eventEmpresa,
                        $eventVinc,
                        $eventomensal,
                        $eventoBeneficiario,
                        $qtdiasbenef
                    );
                 }

                $this->resetarFlagArrayQtdeBeneficiariosPerEvento($qtdBeneficiariosPerEvento);
            }
        }
    }

    private function validaJornadaReduzida($beneficio, $nrvinculom, &$vlrlinearbeneficio){
        $qtdeHorasJrndReduz = isset($beneficio['QTMAXHSREDUZIDA']) ? $beneficio['QTMAXHSREDUZIDA'] : null;
        $vlrJornadaReduz = isset($beneficio['VRHSREDUZIDA']) ? $beneficio['VRHSREDUZIDA'] : null;
        $hrsTrabalhadasMes = null;
        
        $objDtCompetencia = DateUtil::getDataDeString( substr($this->hcmParameters->getDtCompetencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $objUltDiaCompetencia = DateUtil::getDataDeString( substr($this->hcmParameters->getUltimoDiaMes(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        $escalaTrabVinc = $this->entityManager->getRepository(Repositories::GPE_ALTEESCALA)->obterEscalaEntrePeriodo($objDtCompetencia, $objUltDiaCompetencia, $this->hcmParameters->getDtCompetencia(), $nrvinculom, $this->hcmParameters->getNrorgTrabalho());
        
        if ($escalaTrabVinc) {
            $escalaTrabalho = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->_retornaUltimoHistorico(
                $escalaTrabVinc[0]['NRESCALATRABM'], 
                $this->hcmParameters->getNrorgTrabalho(), 
                $this->hcmParameters->getDtCompetencia()
            );
        }
        
        if($escalaTrabalho && $escalaTrabalho->getQthrescalatrabh() > 0) $hrsTrabalhadasMes = $escalaTrabalho->getQthrescalatrabh() * 30;

        if($hrsTrabalhadasMes && $qtdeHorasJrndReduz && $vlrJornadaReduz && $hrsTrabalhadasMes <= $qtdeHorasJrndReduz) 
            $vlrlinearbeneficio = $vlrJornadaReduz;
    }
    
    
    public function validaQtdeBeneficiariosPerEvento(&$qtdBeneficiariosPerEvento, $eventos, $evento, $vlrAnterior = null, $vlrPosterior = null){

        if( is_null($vlrAnterior) && is_null($vlrPosterior) ){

            if( $eventos[$evento] > 0 ) // Se flag for 1, e se o evento for calculado novamente p/ o msm beneficiario, a 'qtde' não aumentará
                $qtdBeneficiariosPerEvento[$evento] = ['qtde'=>1, 'flag'=>1];
            else
                $qtdBeneficiariosPerEvento[$evento] = ['qtde'=>0, 'flag'=>0];
                
        }else if( $qtdBeneficiariosPerEvento[$evento]['flag'] == 0 && $vlrAnterior != $vlrPosterior ){
            
            $qtdBeneficiariosPerEvento[$evento]['qtde']++;
            $qtdBeneficiariosPerEvento[$evento]['flag']++;

        }
    }
     
    public function resetarFlagArrayQtdeBeneficiariosPerEvento(&$qtdBeneficiariosPerEvento){
        foreach($qtdBeneficiariosPerEvento as &$value){
            $value['flag'] = 0;
        }
    } 
        
    public function calcularEventoBeneficiario(&$vincBenefiarioEvento, $eventoBeneficiario, $beneficio, $beneficiario, $nrtabelafolha, $proporcao, $tpperiodo, $vlrBeneficio = 0){
        
        $vlrArredondado = $vlrNaoArredondado = null;
        
        $qtdeBeneficio = $beneficiario->getQtbeneficio();
        $qtdeBeneficio = $qtdeBeneficio ? $qtdeBeneficio : 1; 
        
        $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
            $eventoBeneficiario, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $this->hcmParameters->getNrorgPadrao(), 
            $this->hcmParameters->getDtCompetencia() 
        );
        
        switch($beneficiario->getIdvalordifebenef()){
            case 'REFERENCIA':
                
                $referencia = $this->valorReferenciaService->getReferenciaPorNrValorReferencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getDtCompetencia(), 
                    $beneficiario->getNrvalorreferenciam()
                );
                
                if($tpperiodo == 'MENSAL'){
                    $vlrArredondado = Valor::arredonda(
                        ($referencia['VRREFERENCIA'] * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrArredondado * $qtdeBeneficio);
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Referencia) '.$referencia['VRREFERENCIA'].' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrArredondado * $qtdeBeneficio);

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, null, $beneficiario->getIdvalordifebenef(), $referencia['VRREFERENCIA']);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $vlrNaoArredondado = ($referencia['VRREFERENCIA'] * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrNaoArredondado * $qtdeBeneficio);
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Referencia) '.$referencia['VRREFERENCIA'].' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrNaoArredondado * $qtdeBeneficio);
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, null, $beneficiario->getIdvalordifebenef(), $referencia['VRREFERENCIA']);
                }
                
                break;
            case 'TABELA':
                $vlrBeneficioTabela = $this->calcularValorTipoTabela($beneficiario, $nrtabelafolha); 

                if($tpperiodo == 'MENSAL'){
                    $vlrArredondado = Valor::arredonda(
                        ($vlrBeneficioTabela * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrArredondado * $qtdeBeneficio); 
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Vr Tabela) '.$vlrBeneficioTabela.' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrArredondado * $qtdeBeneficio);

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, $vlrBeneficioTabela, $beneficiario->getIdvalordifebenef(), null);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $vlrNaoArredondado = ($vlrBeneficioTabela * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrNaoArredondado * $qtdeBeneficio);
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Vr Tabela) '.$vlrBeneficioTabela.' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrNaoArredondado * $qtdeBeneficio);
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, $vlrBeneficioTabela, $beneficiario->getIdvalordifebenef(), null);
                }
                
                break;
            case 'VALOR':

                if($tpperiodo == 'MENSAL'){
                    $vlrArredondado = Valor::arredonda(
                        ($beneficiario->getVrbeneficio() * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrArredondado *  $qtdeBeneficio);
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$beneficiario->getVrbeneficio().' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrArredondado * $qtdeBeneficio);

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, null, $beneficiario->getIdvalordifebenef(), null);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $vlrNaoArredondado = ($beneficiario->getVrbeneficio() * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $benefiarioEventos[$eventoBeneficiario] = ($vlrNaoArredondado *  $qtdeBeneficio);
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$beneficiario->getVrbeneficio().' = ('.$vlrArredondado.' * (Quantidade) '.$qtdeBeneficio.') = '.($vlrNaoArredondado * $qtdeBeneficio);
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, 0, 0, null, $beneficiario->getIdvalordifebenef(), null);
                }  
                
                break;
        }
        
        return $vlrBeneficio;
    }
    
    public function calcularEventoMensalidade(&$vincBenefiarioEvento_mens, $nreventomensa, $vlrMultiplicador, $beneficio, $beneficiario, $nrtabelafolha, &$vlrEventoMensal, $vlrlinearbeneficio, $tpperiodo, $proporcao, $vlrPisoMens, $vlrTetoMens, $vlrBeneficio = 0){
   
        $vlrAntesDeArredondar = $vlrArredondado = $vlrNaoArredondado = null;
        
        $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
            $nreventomensa, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $this->hcmParameters->getNrorgPadrao(), 
            $this->hcmParameters->getDtCompetencia() 
        );

        //O beneficio e um vale combustivel quando possui um valor de referencia vinculado ao beneficioe e e calculado quando o possui.
        if($beneficio['NRVALORREFERENCIAM']){ 
            $valorReferencia = FpaValorreferenciam::findOneByNrvalorreferenciam($beneficio['NRVALORREFERENCIAM']);
            if (is_object($valorReferencia)) {
                $valorReferencia = $valorReferencia->retornaUltimoHistoricoCompetencia($this->hcmParameters->getDtcompetencia())->getVrreferencia();
            }

            $alteSalario = $this->alteSalarioService->getSalarioPorCompetencia(
                $this->hcmParameters->getNrorgTrabalho(), 
                $beneficiario->getNrvinculom(), 
                $this->hcmParameters->getDtCompetencia()
            );

            $valorSal = floatval($alteSalario['VRSALARIO']);
            $faixasTabela = $this->entityManager->getRepository(Repositories::FPA_FAIXATABELA)->retornaFaixasPorTabela($beneficio['NRTABELAFOLHATERC'], $this->hcmParameters->getDtCompetencia());
            $calculoBeneficio = '(Valor de Referencia): '.$valorReferencia.' * '.$beneficiario->getQtbeneficio();
            
            //Beneficio vale combustivel mensal.
            if($tpperiodo == 'MENSAL'){
                $vlrBeneficio = $valorReferencia * $beneficiario->getQtbeneficio();

                $this->calculaFaixasTabelaComb($faixasTabela, $valorSal, $vlrBeneficio, $calculoBeneficio);
            }
            //Beneficio vale combustivel diário.
            else if($tpperiodo == 'DIARIO') {
                //Quando for diário deve-se calcular a referência vezes a qtde de km/dia do beneficiário.
                
                $vlrBeneficio = $valorReferencia * $beneficiario->getQtbeneficio();
                
                //Comparar o valor diário com a tabela.
                $this->calculaFaixasTabelaComb($faixasTabela, $valorSal, $vlrBeneficio, $calculoBeneficio);

                //Dividir o resultado pela qtde de beneficio para obter o valor real do km.
                $vlrBeneficio = $vlrBeneficio / $beneficiario->getQtbeneficio();
            }
            $vincBenefiarioEvento_mens[$nreventomensa] = $vlrEventoMensal = $vlrArredondado = $vlrBeneficio;
            MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens);

        } else if($vlrlinearbeneficio){
            if( $tpperiodo == 'MENSAL' ){
                $vlrArredondado = Valor::arredonda(
                    $vlrAntesDeArredondar = ($vlrlinearbeneficio * $proporcao * $vlrMultiplicador), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados e multiplicador, este parâmetro real já é passado proporcionalizado e multiplicado
                    $evento->historico->getIdtipoarredonda(), 
                    $evento->historico->getNrdigarredonda(),
                    $evento->historico->getVrlimitearred()
                );

                if( isset($vlrPisoMens) && $vlrAntesDeArredondar < $vlrPisoMens ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
                    $vlrArredondado = Valor::arredonda(
                        $vlrPisoMens, 
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                }
                if( isset($vlrTetoMens) && $vlrAntesDeArredondar > $vlrTetoMens ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
                    $vlrArredondado = Valor::arredonda(
                        $vlrTetoMens, 
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                }    

                $vlrBeneficio += $vincBenefiarioEvento_mens[$nreventomensa] = $vlrEventoMensal = $vlrArredondado;
                $calculoBeneficio = '(Valor) '.$vlrlinearbeneficio.' * (Proporcao) '.$proporcao.' * (Multiplicador) '.$vlrMultiplicador.' = '.$vlrArredondado;
                
                MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens);
                
            }elseif( $tpperiodo == 'DIARIO' ){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                $vlrNaoArredondado = ($vlrlinearbeneficio * $proporcao);
                $vlrBeneficio += $vincBenefiarioEvento_mens[$nreventomensa] = $vlrEventoMensal = $vlrNaoArredondado;
                
                $calculoBeneficio = '(Valor) '.$vlrlinearbeneficio.' * (Proporcao) '.$proporcao.' * (Multiplicador) '.$vlrMultiplicador.' = '.$vlrNaoArredondado;
                MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens);
            }
            
        }else{
            
            if( $tpperiodo == 'MENSAL' ){
                $valor = $this->calcularValorTipoTabela($beneficiario, $nrtabelafolha);
                $vlrArredondado = Valor::arredonda(
                    $vlrAntesDeArredondar = ($valor * $proporcao * $vlrMultiplicador), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados e multiplicador, este parâmetro real já é passado proporcionalizado e multiplicado
                    $evento->historico->getIdtipoarredonda(),
                    $evento->historico->getNrdigarredonda(),
                    $evento->historico->getVrlimitearred()
                );

                if( isset($vlrPisoMens) && $vlrAntesDeArredondar < $vlrPisoMens ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
                    $vlrArredondado = Valor::arredonda(
                        $vlrPisoMens, 
                        $evento->historico->getIdtipoarredonda(),
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                }
                if( isset($vlrTetoMens) && $vlrAntesDeArredondar > $vlrTetoMens ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
                    $vlrArredondado = Valor::arredonda(
                        $vlrTetoMens, 
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                }    

                $vlrBeneficio += $vincBenefiarioEvento_mens[$nreventomensa] = $vlrEventoMensal = $vlrArredondado;
                
                $calculoBeneficio = '(Valor) '.$valor.' * (Proporcao) '.$proporcao.' * (Multiplicador) '.$vlrMultiplicador.' = '.$vlrArredondado;

                MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens, $nrtabelafolha);
                
            }elseif( $tpperiodo == 'DIARIO' ){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                $vlrNaoArredondado = ($this->calcularValorTipoTabela($beneficiario, $nrtabelafolha) * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                $vlrBeneficio += $vincBenefiarioEvento_mens[$nreventomensa] = $vlrEventoMensal = $vlrNaoArredondado;
                
                $calculoBeneficio = '(Valor) '.$valor.' * (Proporcao) '.$proporcao.' * (Multiplicador) '.$vlrMultiplicador.' = '.$vlrNaoArredondado;
                MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, $vlrMultiplicador, $vlrPisoMens, $vlrTetoMens, $nrtabelafolha);
            }
        }
        
        return $vlrBeneficio;
    }

    private function calculaFaixasTabelaComb($faixasTabela, $valorSal, &$vlrBeneficio, &$calculoBeneficio) {
        foreach($faixasTabela as $faixa) {
            if(($faixa->getVrmaxresultcalc() >= $valorSal) && ($faixa->getVrlimitsupfaixa() <= $valorSal)) {
                
                if($vlrBeneficio >= $faixa->getVraplicaresult()) {
                    $vlrBeneficio = $faixa->getVraplicaresult();
                    $calculoBeneficio = 'De acordo com a tabela salarial, o valor do vale combustivel foi superior ao limite e portanto o Vale Combustivel terá o valor de: '.$vlrBeneficio;
                    continue;
                }
            }
        }
    }
    
    public function getMultiplicadorMensalidade($beneficio, $vinculo, $histVinc, $nreventomensa){
        $multiplicar = true;
        $vlrMultiplicador = isset($beneficio['VRMULTIPLICADOR']) && !empty($beneficio['VRMULTIPLICADOR']) ? floatval($beneficio['VRMULTIPLICADOR']) : 1;

        // ===== ID: "Vínculos Empregatícios que não considerarão o multiplicador:"
        // Verifica se o tipo de vínculo do vínculo é o tipo de vínculo do benefício CCT.
        // Se for, o multiplicador será 1.
        
        if(isset($beneficio['DSVINCULOEMPREG']) && !empty($beneficio['DSVINCULOEMPREG'])){
            $tpvinculos = explode(", ", $beneficio['DSVINCULOEMPREG']);
            foreach($tpvinculos as $nrtipovinc){
                if(intval($nrtipovinc) == $vinculo->getNrvinculoempreg()) $multiplicar = false;
            }
        }

        // ===== ID: "Não considerarão o multiplicador por possuírem os seguintes eventos:" e "Retroceder quantos meses para apurar os eventos (frente ao período)?"
        // Verifica se na folha da competência informada há os eventos informados pelo ID acima
        // Caso haja, o multiplicador será 1.
            $dadosRetornoValidEventos = $this->retornaEventosFolhaMensal($vinculo, $beneficio['DSINCIDEVENTO'], $beneficio['QTMESRETROCMULT'], true);
            if($dadosRetornoValidEventos['consideraMultiplicador'] == false){
               $multiplicar = false;
            }else{
                $escalaTrabalho = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->_retornaUltimoHistorico(
                    $this->histVinc['NRESCALATRABM'], 
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $this->hcmParameters->getDtCompetencia()
                );
                
                $dataInicio = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
                $dataFim = DateUtil::getUltimoDiaDoMes($dataInicio);
                
                // Verificar se período de apuração é definido na escala de trabalho do vínculo
                if($escalaTrabalho->getIdutapuratestbenef()  && ($escalaTrabalho->getIdutapuratestbenef() == 'S' || $escalaTrabalho->getIdutapuratestbenef() == 'Y')){ 
                    $diaInicialAupr = $escalaTrabalho->getNrdiainiapur();
                    $diaFinalAupr = $escalaTrabalho->getNrdiafinapur();
                    
                    $mesAnterior = DateUtil::subtraiIntervalo($dataInicio, 1, DateUtil::MES);
                    
                    $dataInicio = DateUtil::getDataDeString($diaInicialAupr.'/'.$mesAnterior->format('m/Y'));
                    $dataFim = DateUtil::getDataDeString($diaFinalAupr.'/'.$dataFim->format('m/Y'));
                
                }  
                
                $dias = $this->_quantidadeMesAfastados($dataInicio, $dataFim, $vinculo);
                
                $multiplicar = $dias > 0 ? false : $multiplicar;
            }
            
        

        // ===== ID: "Não considerar multiplicador para vínculos em período de experiência:"
        // Caso o id esteja marcado,  será verificado se data atual é menor ou igual à data de fim de experiência
        if(isset($beneficio['IDNAOGERABENPEREXP']) && !empty($beneficio['IDNAOGERABENPEREXP']) && $beneficio['IDNAOGERABENPEREXP'] == 'S'){
            $dtAtual = $dtFimContratExpe = null;
            $diasProrr = 0;

            $dtAtual = DateUtil::getDataDeString( substr(DateUtil::getDataAtual(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if(isset($histVinc['DTFIMCONTRDETERMIN']) && !empty($histVinc['DTFIMCONTRDETERMIN'])) $dtFimContratExpe = DateUtil::getDataDeString( substr($histVinc['DTFIMCONTRDETERMIN'], 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if( $dtFimContratExpe && $dtAtual->format('Y/m/d') <= $dtFimContratExpe->format('Y/m/d')) $multiplicar = false;

        }
        
        /* Condição para não gerar benefício para vínculos em período de experiência passada para a função validarMinimizadoresBeneficioCCT
        if($beneficio['IDNAOGERBENVINCEXP'] == 'S'){
            $dtAtual = $dtFimContratExpe = null;

            $dtAtual = DateUtil::getDataDeString( substr(DateUtil::getDataAtual(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if(isset($histVinc['DTFIMCONTRDETERMIN']) && !empty($histVinc['DTFIMCONTRDETERMIN'])) $dtFimContratExpe = DateUtil::getDataDeString( substr($histVinc['DTFIMCONTRDETERMIN'], 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            
            if( $dtFimContratExpe && $dtAtual->format('Y/m/d') <= $dtFimContratExpe->format('Y/m/d')) $multiplicar = 0;
            
        }*/
        
        // ===== ID: "Não considerar multiplicador para vínculos rescindidos:"
        // Caso o id esteja marcado e haja rescisão do vínculo, o multiplicador será 1
        if(isset($beneficio['IDNAOGERABENRESC']) && !empty($beneficio['IDNAOGERABENRESC']) && $beneficio['IDNAOGERABENRESC'] == 'S'){
            if($vinculo->getDtrescisaovinc() && $vinculo->getDtrescisaovinc()->format('d/m/Y') <= $this->hcmParameters->getUltimoDiaMes()){ 
                $multiplicar = false;
            }
        }
        
        // Caso não seja para multiplicar devido às dcondições acima o multiplicador deve ter valor default (1).
        if($multiplicar === false) $vlrMultiplicador = 1;
        if($multiplicar === 0) $vlrMultiplicador = 0;
        
        return $vlrMultiplicador;
    }
    
    public function _quantidadeMesAfastados($dt_inicio, $dt_fim, $vinculo){
        
        $alteracao_situacao_funcional = new GpealtesitufuncEntity($this->entityManager, $this->hcmParameters);
        $situacaoFuncional = new GpesitufuncmEntity($this->entityManager, $this->hcmParameters);
        $alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
           $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        
        $mes_ini = $dt_inicio->format('m');
        $mes_fim = $dt_fim->format('m');
        $dt_aux_inicio = $dt_inicio;
        $mes_afastado = 0;
        
        for ($i = $dt_inicio; $i <= $dt_fim; $i = DateUtil::adicionaIntervalo($i, 1, DateUtil::MES)) {
            
            if ($i == $dt_inicio) {
                $dt_aux_inicio = $dt_inicio;
                $dt_aux_fim = DateUtil::adicionaIntervalo($dt_inicio, 1, DateUtil::MES);
                if($dt_aux_fim > $dt_fim){                          
                    $dt_aux_fim = $dt_fim;      
                }
            } elseif ($i == $dt_fim) {
                $dt_aux_inicio = DateUtil::setDay($dt_fim, 1);
                $dt_aux_fim = $dt_fim;
            }else {
                $dt_aux_inicio = $i;
                $dt_aux_fim = DateUtil::adicionaIntervalo($dt_aux_inicio, 1, DateUtil::MES);
            }
            
            $afastamento = $alteracao_situacao_funcional->retornaDiasAfastamento(
                $situacaoFuncional, $dt_aux_inicio, $dt_aux_fim, false
            );
            $dias_afastados = 0;
            for ($x=0; $x < count($afastamento); $x++) {
                $sit_func = $situacaoFuncional->retornaSituacaoFuncional(
                    $this->hcmParameters->getNrorgPadrao(), $this->hcmParameters->getNrorgTrabalho(), $afastamento[$x]
                );
                if ($sit_func == true) {
                    if (($sit_func->getNrsitufuncm() === 12) or 
                        ($sit_func->getNrsitufuncm() === 15) or 
                        ($sit_func->getNrsitufuncm() === 16) or 
                        ($sit_func->getNrsitufuncm() === 100042)) {
                        $dias_afastados++;
                    }
                }
            }
        }
        return $dias_afastados;
    }
    
    public function calcularEventoVinculo(&$vincBenefiarioEvento_vinc, $tpperiodo, $eventVinc, $vlrPiso, $vlrTeto, $beneficio, $beneficiario, &$vlrEventoVinc, $vlrEventoMensal, $tpParticipacao, $percentOuVlrParticipacao, $nrFaixaSalarial, $proporcao, $vlrBeneficio = 0){

        $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
            $eventVinc, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $this->hcmParameters->getNrorgPadrao(), 
            $this->hcmParameters->getDtCompetencia() 
        );
        
        switch($tpParticipacao){
            case 'FAIXA_SAL':

                $vlrAntesDeArredondar = $vlrArredondado = $vlrNaoArredondado = null;
                
                if($tpperiodo == 'MENSAL'){
                    $valor = $this->calcularValorTipoTabela($beneficiario, $nrFaixaSalarial, 'faixaSalarial');
                    $vlrArredondado = Valor::arredonda(
                        $vlrAntesDeArredondar = ($valor * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );

                    if( isset($vlrPiso) && $vlrAntesDeArredondar < $vlrPiso ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrPiso, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }
                    
                    if( isset($vlrTeto) && $vlrAntesDeArredondar > $vlrTeto ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrTeto, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }    
                    
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$valor.' = '.$vlrArredondado;

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $valor = $this->calcularValorTipoTabela($beneficiario, $nrFaixaSalarial, 'faixaSalarial');
                    
                    $vlrNaoArredondado = ($this->calcularValorTipoTabela($beneficiario, $nrFaixaSalarial, 'faixaSalarial') * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrNaoArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$valor.' = '.$vlrNaoArredondado;
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                }    

                break;
            

            case 'VALOR':

                $vlrAntesDeArredondar = $vlrArredondado = $vlrNaoArredondado = null;
                
                if($tpperiodo == 'MENSAL'){
                
                    $vlrArredondado = Valor::arredonda(
                        $vlrAntesDeArredondar = ($percentOuVlrParticipacao * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                    if( isset($vlrPiso) && $vlrAntesDeArredondar < $vlrPiso ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrPiso, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }    
                    
                    if( isset($vlrTeto) && $vlrAntesDeArredondar > $vlrTeto ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrTeto, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }    
    
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$percentOuVlrParticipacao.' = '.$vlrArredondado;

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $vlrNaoArredondado = ($percentOuVlrParticipacao * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrNaoArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$percentOuVlrParticipacao.' = '.$vlrNaoArredondado;
                    
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                }    

                break;
            
            case 'PERC_SAL':
                
                $vlrAntesDeArredondar = $vlrArredondado = $vlrNaoArredondado = null;
                
                $alteSalario = $this->alteSalarioService->getSalarioPorCompetencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $beneficiario->getNrvinculom(), 
                    $this->hcmParameters->getDtCompetencia()
                );

                if($tpperiodo == 'MENSAL'){
                    $valor = $alteSalario['VRSALARIO'] * ($percentOuVlrParticipacao/100);
                    $vlrArredondado = Valor::arredonda(
                        $vlrAntesDeArredondar = ($valor * $proporcao), // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                        $evento->historico->getIdtipoarredonda(), 
                        $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred()
                    );
                    
                    if( isset($vlrPiso) && $vlrAntesDeArredondar < $vlrPiso ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrPiso, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }    
                    
                    if( isset($vlrTeto) && $vlrAntesDeArredondar > $vlrTeto ){ // Teto e Piso para Diário considera depois de multiplicar pela quantidade de dias
    
                        $vlrArredondado = Valor::arredonda(
                            $vlrTeto, 
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                    }    
    
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$valor.' = '.$vlrArredondado;

                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                
                }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                    $valor = $alteSalario['VRSALARIO'] * ($percentOuVlrParticipacao/100);
                    
                    $vlrNaoArredondado = ($alteSalario['VRSALARIO'] * ($percentOuVlrParticipacao/100) * $proporcao); // Caso seja benefício mensal e deva haver proporcionalização por dias trabalhados, este parâmetro real já é passado proporcionalizado
                    $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrNaoArredondado;
                    
                    $calculoBeneficio = '(Proporcao) '.$proporcao.' * (Valor) '.$valor.' = '.$vlrNaoArredondado;
                    MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $proporcao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                }    
                
                break;
            
            case 'PERC_MENS':
                if($vlrEventoMensal){
                    
                    $vlrAntesDeArredondar = $vlrArredondado = $vlrNaoArredondado = null;
                    
                    if($tpperiodo == 'MENSAL'){

                        $vlrArredondado = Valor::arredonda(
                            $vlrAntesDeArredondar = $vlrEventoMensal * ($percentOuVlrParticipacao/100), // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizado
                            $evento->historico->getIdtipoarredonda(), 
                            $evento->historico->getNrdigarredonda(),
                            $evento->historico->getVrlimitearred()
                        );
    
                        if( isset($vlrPiso) && $vlrAntesDeArredondar < $vlrPiso ){ // Teto e Piso para Diário é considerado depois de multiplicar pela quantidade de dias
    
                            $vlrArredondado = Valor::arredonda(
                                $vlrPiso, 
                                $evento->historico->getIdtipoarredonda(), 
                                $evento->historico->getNrdigarredonda(),
                                $evento->historico->getVrlimitearred()
                            );
    
    
                            $vlrAntesDeArredondar = $vlrPiso;
                        }    
                        
                        if( isset($vlrTeto) && $vlrAntesDeArredondar > $vlrTeto ){ // Teto e Piso para Diário é considerado depois de multiplicar pela quantidade de dias
    
                            $vlrArredondado = Valor::arredonda(
                                $vlrTeto, 
                                $evento->historico->getIdtipoarredonda(), 
                                $evento->historico->getNrdigarredonda(),
                                $evento->historico->getVrlimitearred()
                            );
    
                        }    
    
                        $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrArredondado;
                        
                        $calculoBeneficio = '((Valor mensal) '.$vlrEventoMensal.' * (Percentual) '.$percentOuVlrParticipacao.' / 100) = '.$vlrArredondado;

                        MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $percentOuVlrParticipacao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                
                    }elseif($tpperiodo == 'DIARIO'){ // Como no cálculo diario há a multiplicação pelo número de dias, o arredondamento deve ocorrer depois dessa multiplicação.
                        $vlrNaoArredondado = $vlrEventoMensal * ($percentOuVlrParticipacao/100); // Se deve haver proporcionalização por dias trabalhados, $vlrEventoMensal já está proporcionalizado
                        $vlrBeneficio += $vincBenefiarioEvento_vinc[$eventVinc] = $vlrEventoVinc = $vlrNaoArredondado;
                        
                        $calculoBeneficio = '((Valor mensal) '.$vlrEventoMensal.' * (Percentual) '.$percentOuVlrParticipacao.' / 100) = '.$vlrNaoArredondado;
                        MemoriaBeneficio::getInstance()->setCalcBenefVinc($evento->getNreventom(), $vlrBeneficio, $calculoBeneficio, $percentOuVlrParticipacao, 0, $vlrPiso, $vlrTeto, null, $tpParticipacao, null);
                    }    
                    
                }    
                break;
        }
        
        return $vlrBeneficio;
    }
    
    public function calcularValorTipoTabela($beneficiario, $nrtabelafolha, $tpCalc = 'faixaEtaria'){

        $dtcompetencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
        // $faixasTabela = FpaFaixatabela::findByNrtabelafolha($nrtabelafolha);
        $faixasTabela = $this->entityManager->getRepository(Repositories::FPA_FAIXATABELA)->retornaFaixasPorTabela($nrtabelafolha, $dtcompetencia);
        $pessoa = GpePessoa::findOneByNrorgAndNrpessoa($beneficiario->getNrorg(), $beneficiario->getNrpessoa());
        $vlrBeneficioTabela = 0;
        $idadeOuSalario = null;
        
        
        if (is_object($pessoa)) {

            if($tpCalc === 'faixaEtaria'){
                
                $dtNascPessoa = $pessoa->getHistorico($dtcompetencia)->getDtnascpessoa();
                
                $objDtCompetencia = DateUtil::getDataDeString( substr($dtcompetencia, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
                

                if (($dtNascPessoa instanceof DateTime) === false) 
                    $dtNascPessoa = DateUtil::getDataDeString( substr($dtNascPessoa, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
                else 
                    $dtNascPessoa = DateUtil::getDataDeString( $dtNascPessoa->format('d/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
                

                if(    $dtNascPessoa // Se houver a data de nascimento cadastrada
                    && $objDtCompetencia->format('m/d') <= $dtNascPessoa->format('m/d') // E se o aniversário estiver dentro da competencia,
                    && $dtNascPessoa->format('m/d') <= $objDtCompetencia->format('m/t') // este será equivalente ao primeiro dia da competência
                ){  
                    $dtNascPessoa = DateUtil::getDataDeString( $dtNascPessoa->format('01/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
                }    

                $idadeOuSalario = $dtNascPessoa ? $dtNascPessoa->diff($objDtCompetencia)->format('%y') : null;

            }else if($tpCalc === 'faixaSalarial'){
                $alteSalario = $this->alteSalarioService->getSalarioPorCompetencia(
                    $this->hcmParameters->getNrorgTrabalho(), 
                    $beneficiario->getNrvinculom(), 
                    $this->hcmParameters->getDtCompetencia()
                );
                $idadeOuSalario = $alteSalario['VRSALARIO'];
            }

            foreach ($faixasTabela as $faixa) {
                
                if ( isset($idadeOuSalario) 
                     && $idadeOuSalario >= $faixa->getVrlimitsupfaixa() 
                     && $idadeOuSalario <= $faixa->getVrmaxresultcalc() 
                  ){
                    $percentCalc = $faixa->getVrpecalculoresu();
                    $vraplicaresult = $faixa->getVraplicaresult();
                    if(isset($percentCalc) && !empty($percentCalc)){
                        $vlrBeneficioTabela += $vraplicaresult*($percentCalc/100);    
                    }else{
                        $vlrBeneficioTabela += $vraplicaresult;    
                    }                                
                }
                
            }

        }

        return $vlrBeneficioTabela;

    }
    
    public function getEventosParaRetroceder($beneficio, $beneficiario){
        $eventosBeneficiario = [];
        $eventoBenef  = intval($beneficiario->getNreventom()); 
        
        if( $beneficiario->getIdtpbeneficiario() === "T" ){
            $nreventomensa = $beneficio['NREVENTOMENSA'];
            $eventVinc     = $beneficio['NREVETITULARVINC'];
            $eventEmpresa  = $beneficio['NREVETITULAREMP'];
        }else{
            $nreventomensa = $beneficio['NREVENTOMENSADEP'];
            $eventVinc     = $beneficio['NREVEDEPEVINC'];
            $eventEmpresa  = $beneficio['NREVEDEPEMPRESA'];
        }

        $eventoBenef   ? $eventosBeneficiario['0'.$eventoBenef]   = $eventoBenef   : null;
        $nreventomensa ? $eventosBeneficiario['0'.$nreventomensa] = $nreventomensa : null;
        $eventVinc     ? $eventosBeneficiario['0'.$eventVinc]     = $eventVinc     : null;
        $eventEmpresa  ? $eventosBeneficiario['0'.$eventEmpresa]  = $eventEmpresa  : null;
        
        return $eventosBeneficiario;
    }
    

    
    

    /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    -=                                             -=
    -= ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO  -=
    -=                                             -=
    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

    public function calcular_Diario($dsordem, $dsinicio, $dsfim, $dtinicio, $dtfinal, $dtpagamento, $nrtpbeneficio, $nrestruturam, $dtmescompetenc, $nrorg) {
        try {
            $foiCalculado = false;
            $nrcalculobenef = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_BENEFICIO);
            $vinculos = $this->buscaVinculos_Diario($nrorg, $dtmescompetenc, $dsordem, $dsinicio, $dsfim, $dtfinal, $nrcalculobenef, $nrestruturam, $nrtpbeneficio);

            foreach ($vinculos as $vinculo) {
                $this->setDadosCalculo_Diario($vinculo);
                $this->executaCalculo_Diario($nrorg, $dtmescompetenc, $dtinicio, $dtfinal, $nrtpbeneficio, $nrestruturam);
            }
            if (!empty($this->beneficios)) {
                foreach ($this->beneficios as $beneficiosVinc) {
                    $this->addHistorico_Diario($beneficiosVinc, $dtinicio, $dtfinal, $dtpagamento, $nrcalculobenef);
                }
                $this->entityManager->flush();
                $foiCalculado = true;
            } else {
                throw new \Exception(Messages::HCM02000_VAB_BENEFICIARIO_VINC_N_ENCONTR_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
            
            return $foiCalculado;
            
        } catch (\Exception $e) {
            throw $e;
        }
    }

    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    public function buscaVinculos_Diario($nrorg, $competencia, $ordem, $dsinicio, $dsfim, $dtfinal, $nrcalculobenef, $nrestruturam, $nrtpbeneficio){
        try {
            $dtmescompetencia = DateUtil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true);
            $dtmescompetencia->add(new \DateInterval('P1M'));
            $dtiniperiodo = $dtmescompetencia->format('d/m/Y');
            $dtfinalbenef = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
            $dtfinalbenef = $dtfinalbenef->format('d/m/Y');

            $condEstrutBenef = ($nrestruturam ? "AND VAB_BENEFICIOH.NRESTRUTURAM = $nrestruturam" : "");
            $condTipoBenef = ($nrtpbeneficio ? "AND VAB_BENEFICIOH.NRTPBENEFICIO = $nrtpbeneficio" : "");
            $cond_beneficiario =
                " AND EXISTS (SELECT * FROM VAB_BENEFICIARIO
                                JOIN VAB_BENEFICIOH
                                  ON VAB_BENEFICIOH.NRORG = VAB_BENEFICIARIO.NRORG
                                 AND VAB_BENEFICIOH.NRBENEFICIOM = VAB_BENEFICIARIO.NRBENEFICIOM
                                 $condEstrutBenef
                                 $condTipoBenef
                               WHERE VAB_BENEFICIARIO.NRORG = e.NRORG
                                 AND VAB_BENEFICIARIO.NRVINCULOM = e.NRVINCULOM)";

            // Filtra somente vínculos que não estejam em situação funcional de afastamento (exceto atestado médico)
            $cond_afastados =
                " AND NOT EXISTS (SELECT * FROM GPE_ALTESITUFUNC
                                   WHERE NRORG         = e.NRORG
                                     AND NRVINCULOM    = e.NRVINCULOM
                                     AND NRSITUFUNCM IN (SELECT GPE_SITUFUNCH.NRSITUFUNCM
                                                           FROM GPE_SITUFUNCH
                                                          WHERE GPE_SITUFUNCH.IDGERVALETRANSP = 'N'
                                                            AND GPE_SITUFUNCH.NRSITUFUNCM NOT IN (12, 15, 16)
                                                            AND GPE_SITUFUNCH.DTEFETIVA = ( SELECT MAX(DTEFETIVA) DTEFETIVA
                                                                                              FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                                                                             WHERE MAX_SITUFUNCH.DTEFETIVA <= TO_DATE('$dtfinalbenef','DD/MM/YYYY')
                                                                                               AND MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM))
                                     AND DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                            FROM GPE_ALTESITUFUNC B
                                                           WHERE B.NRORG       = e.NRORG
                                                             AND B.NRVINCULOM  = e.NRVINCULOM
                                                             AND DTINISITUFUNC <= TO_DATE('$dtfinalbenef','DD/MM/YYYY'))
                                     AND (DTFIMSITUFUNC >= TO_DATE('$dtfinalbenef','DD/MM/YYYY') OR DTFIMSITUFUNC IS NULL))";

            switch($ordem)
            {
                case 'ALFABETICA':
                {
                    $param = array(':P_INICIO' => $dsinicio,
                        ':P_FIM' => $dsfim,
                        ':P_NRORG' => $nrorg);

                    //Nome Inicial
                    $whereinivinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_INICIO"; /** @var GpeVinculom $objinivinculo */
                    $objinivinculo = GpeVinculom::getObjectByWhere($whereinivinculo, $param);

                    //Nome Final
                    $wherefimvinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_FIM"; /** @var GpeVinculom $objfimvinculo */
                    $objfimvinculo = GpeVinculom::getObjectByWhere($wherefimvinculo, $param);

                    $nomeInicio = $objinivinculo->getNmvinculom();
                    $nomeFinal = $objfimvinculo->getNmvinculom();

                    if($nomeFinal<$nomeInicio){
                        $aux = $nomeFinal;
                        $nomeFinal = $nomeInicio;
                        $nomeInicio = $aux;
                    }

                    $param = array( ':P_INICIO' => $nomeInicio,
                        ':P_FIM' => $nomeFinal,
                        ':P_NRORG' => $nrorg);
                    $where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NMVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $msgerro = Messages::HCM00000_GER_VINCS_N_ENCONT_NOMES_ERROR;
                    break;
                }
                case 'MATRICULA':{
                    $param = array(
                        'P_INICIO' => $dsinicio,
                        'P_FIM' => $dsfim,
                        'P_NRORG' => $nrorg);
                    $where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $msgerro = Messages::HCM00000_GER_VINCS_N_ENCONT_MATRICS_ERROR;
                    break;
                }
                case 'DATA_ADMISSAO':{
                    $param = array(':P_NRORG' => $nrorg);
                    $where = "(DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN '$dsinicio' AND '$dsfim' AND NRORG = :P_NRORG";
                    $msgerro = Messages::HCM00000_GER_VINCS_N_ENCONT_DATAS_ERROR;
                    break;
                }
                case 'ESTRUTURA':{
                    $param = array( 'P_NRORG' => $nrorg,
                        'P_NRESTRUTLEGAL' =>$dsinicio,
                        'P_NRESTRUTGEREN' =>$dsfim);
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > '$dtiniperiodo' OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= '$dtiniperiodo' AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND (NRESTRUTGEREN = :P_NRESTRUTGEREN OR :P_NRESTRUTGEREN IS NULL) AND NRESTRUTLEGAL = :P_NRESTRUTLEGAL AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG))";
                    $msgerro = Messages::HCM00000_GER_VINCS_N_ENCONT_ESTRUTS_ERROR;
                    break;
                }
                default: {
                    $where = "1=2";
                    $msgerro = Messages::HCM00000_GER_VINC_N_ENCONTR_FILTRO_INF_ERROR;
                }
            }

            $where .= $cond_afastados;

            $historicos = VabHistbenefvinc::getObjectsByWhere(
                "NRORG = $nrorg AND
                DTMESCOMPETENC = '$competencia' AND
                NRCALCULOFOLHA = $nrcalculobenef AND
                NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where
                                AND EXISTS (SELECT * FROM VAB_BENEFICIARIO
                                              JOIN VAB_BENEFICIOH
                                                ON VAB_BENEFICIOH.NRORG = VAB_BENEFICIARIO.NRORG
                                               AND VAB_BENEFICIOH.NRBENEFICIOM = VAB_BENEFICIARIO.NRBENEFICIOM
                                                $condEstrutBenef
                                                $condTipoBenef
                                             WHERE VAB_BENEFICIARIO.NRORG = e.NRORG
                                               AND VAB_BENEFICIARIO.NRVINCULOM = e.NRVINCULOM
                                               AND VAB_BENEFICIARIO.NRBENEFICIOM = e.NRBENEFICIOM))", $param
            );

            if ($historicos) {
                throw new \Exception(Messages::HCM01000_FPA_VINC_CALC_FV_RETROC_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
                
            $condVinculoH = "
             AND EXISTS (SELECT * FROM GPE_VINCULOH VH WHERE VH.NRVINCULOM = e.NRVINCULOM AND VH.NRORG = e.NRORG 
                                                    AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                            FROM GPE_VINCULOH VHH
                                                           WHERE VHH.NRORG       = VH.NRORG
                                                             AND VHH.NRVINCULOM  = VH.NRVINCULOM
                                                             AND VHH.DTMESCOMPETENC <= TO_DATE('$competencia','DD/MM/YYYY')))
            ";
                
            $where .= $condVinculoH;
            $where .= $cond_beneficiario;
            
            $result = GpeVinculom::getObjectsByWhere($where, $param);
            
            if ($result) {
                return $result;
            } else {
                if ($condEstrutBenef || $condTipoBenef) {
                    throw new \Exception(Messages::HCM00000_GER_VINC_N_ENCONTR_FILTRO_INF_ERROR, Messages::ERROR_MESSAGE_CODE);
                } else {
                    throw new \Exception($msgerro, Messages::ERROR_MESSAGE_CODE);
                }
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }

    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    private function setDadosCalculo_Diario($vinculo) {
        $this->vinculo = $vinculo;
        $this->dsdiadescansosemanal = self::SABDOM;
        $this->nrafastamento = 0;
        $this->nrfalta = 0;
        $this->nrdiasferias = 0;
        $this->nrdiasproxmes = 0;
        $this->nrdiasaviso = 0;
        $this->diastotaisconsideracao = 0;
    }

    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    public function retroceder_Diario($ordem, $inicial, $final, $competencia, $nrorg) {
        try {
            $foiRetrocedido = false;
            
            $nrcalculobenef = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_BENEFICIO);
            $dtmescompetencia = DateUtil::getDataDeString($competencia, DateUtil::FORMATO_BRASILEIRO, true);
            $dtmescompetencia->add(new \DateInterval('P1M'));
            $dtiniperiodo = $dtmescompetencia->format('d/m/Y');
            $nrtipomoviment = FpaTipomoviment::TP_MOV_BENEFICIO;

            $param = array(
                'P_INICIO'       => $inicial,
                'P_FIM'          => $final,
                'P_NRORG'        => $nrorg,
                'P_DTINIPERIODO' => $dtiniperiodo);

            switch($ordem)
            {
                case 'ALFABETICA':
                {
                    $param = array(
                        ':P_INICIO' => $inicial,
                        ':P_FIM'    => $final,
                        ':P_NRORG'  => $nrorg
                    );

                    //Nome Inicial
                    $whereinivinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_INICIO"; /** @var GpeVinculom $objinivinculo */
                    $objinivinculo = GpeVinculom::getObjectByWhere($whereinivinculo, $param);

                    //Nome Final
                    $wherefimvinculo = "NRORG = :P_NRORG AND NRVINCULOM = :P_FIM"; /** @var GpeVinculom $objfimvinculo */
                    $objfimvinculo = GpeVinculom::getObjectByWhere($wherefimvinculo, $param);

                    $nomeInicio = $objinivinculo->getNmvinculom();
                    $nomeFinal = $objfimvinculo->getNmvinculom();

                    if($nomeFinal<$nomeInicio){
                        $aux = $nomeFinal;
                        $nomeFinal = $nomeInicio;
                        $nomeInicio = $aux;
                    }

                    $param = array(
                        'P_INICIO'       => $nomeInicio,
                        'P_FIM'          => $nomeFinal,
                        'P_NRORG'        => $nrorg,
                        'P_DTINIPERIODO' => $dtiniperiodo);
                    $where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NMVINCULOM BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'MATRICULA':{
                    $where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND TO_CHAR(DTADMISSAOVINC, 'DD/MM/YYYY') <= :P_DTINIPERIODO AND CDMATRICULA BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'DATA_ADMISSAO':{
                    $where = "(DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC BETWEEN :P_INICIO AND :P_FIM AND NRORG = :P_NRORG";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
                case 'ESTRUTURA':{
                    $where = "NRORG = :P_NRORG AND (DTRESCISAOVINC > :P_DTINIPERIODO OR DTRESCISAOVINC IS NULL) AND DTADMISSAOVINC <= :P_DTINIPERIODO AND NRVINCULOM IN ( SELECT NRVINCULOM FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND ((NRESTRUTGEREN = :P_FIM) OR (:P_FIM IS NULL)) AND NRESTRUTLEGAL = :P_INICIO AND DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND DTMESCOMPETENC <= :P_DTINIPERIODO))";
                    $result = \Folha\Entities\GpeVinculom::getObjectsByWhere($where, $param);
                    break;
                }
            }

            /**
             * @var \Folha\Entities\GpeVinculom $reg
             * @var VabHistbenefvinc $hist
             */
            if($result){
                $liquido = FpaTipoassoceve::ASSOC_LIQUIDO;
                $liquidos = FpaItecalcfolha::getObjectsByWhere(
                    "NRCALCULOFOLHA = $nrcalculobenef AND
                     NRORG = $nrorg AND
                     NREVENTOM = $liquido AND
                     NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where)", $param);

                if(empty($liquidos)) {
                    $hists = VabHistbenefvinc::getObjectsByWhere(
                        "NRORG = $nrorg AND
                         TRUNC(DTMESCOMPETENC, 'DD') = '$competencia' AND
                         NRCALCULOFOLHA  = (SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA WHERE NRCALCULOFOLHA = $nrcalculobenef AND NRORG = $nrorg AND NRTIPOMOVIMENT = $nrtipomoviment) AND
                         NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where)", $param);

                    if (!empty($hists)) {
                        $itens = FpaItecalcfolha::getObjectsByWhere(
                            "NRCALCULOFOLHA = $nrcalculobenef AND
                             NRORG = $nrorg AND
                             NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE $where)", $param);

                        if (!empty($itens)) {
                            foreach ($itens as $itemcalc) {
                                $itemcalc->delete();
                                $foiRetrocedido = true;
                            }
                        }

                        foreach ($hists as $hist) {
                            $hist->delete();
                            $foiRetrocedido = true;
                        }

                        \Setforms2\Shared\Registry::getEntityManager()->flush();
                    } else {
                        throw new \Exception(Messages::HCM01000_FPA_RETROCED_ITENS_N_ENCONT_ALERT, Messages::ERROR_MESSAGE_CODE);
                    }
                } else {
                    throw new \Exception(Messages::HCM02000_VAB_VINC_GRAVAD_RETROC_BENEF_ERROR, Messages::ERROR_MESSAGE_CODE);
                }
            } else {
                throw new \Exception(Messages::HCM00000_GER_VINC_N_ENCONTR_FILTRO_INF_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
            return $foiRetrocedido;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    public function executaCalculo_Diario($nrorg, $dtmescompetenc, $dtinicio, $dtfinal, $nrtpbeneficio, $nrestruturam){
        try {
            $dtiniperiodo = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO);
            $dtfimperiodo = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO);
            $this->dtiniperiodobenef = $dtiniperiodo;
            $this->dtfimperiodobenef = $dtfimperiodo;

            $this->dtiniperiodocalculo = clone $dtiniperiodo;
            $this->dtfimperiodocalculo = clone $dtfimperiodo;
            $this->dtiniperiodocalculo->sub(new \DateInterval('P1M'));
            $this->dtfimperiodocalculo->sub(new \DateInterval('P1M'));
            
            $this->setDescansoSemanal_Diario();
            $this->nrafastamento = $this->getNrAfastamento_Diario();
            $this->nrfalta = $this->getNrFalta_Diario();
            $this->nrdiasferias = $this->getNrDiasFerias_Diario($this->dtiniperiodobenef, $this->dtfimperiodobenef);
            $this->nrdiasproxmes = $this->getNrDiasCalculo_Diario($this->dtiniperiodobenef, $this->dtfimperiodobenef);
            $this->nrdiasaviso = $this->getNrDiasAviso_Diario($this->dtiniperiodobenef, $this->dtfimperiodobenef);
            $referenciaDesconta = $this->valorReferenciaService->getReferenciaPorDescricao(0, $nrorg, $dtmescompetenc, 'DESCONTA_BENEFICIO');
            
            $referenciaDescontaSemFaltas = $this->valorReferenciaService->getReferenciaPorDescricao(0, $nrorg, $dtmescompetenc, 'DESCONTA_BENEFICIO_SEM_FALTAS');

            if(count($referenciaDescontaSemFaltas) > 0){
                if ($this->nrdiasaviso) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrafastamento;
                } else {
                    $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrafastamento;
                }
            }
            else if (empty($referenciaDesconta)) {
                if ($this->nrdiasaviso) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                } else {
                    $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                }
            }else{
                if ($this->nrdiasaviso) {
                    $this->diastotaisconsideracao = (int)$this->nrdiasaviso;
                } else {
                    $this->diastotaisconsideracao = (int)$this->nrdiasproxmes;
                }
            }

            $beneficiosVinc = $this->getBeneficiosVinc_Diario($nrtpbeneficio, $nrestruturam);
            if(!empty($beneficiosVinc)) {
                $this->beneficios[$this->vinculo->getNrvinculom()] = $beneficiosVinc;
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * VERIFICA A QUANTIDADE DE DIAS QUE SERÁ DEPOSITADO DE ACORDO COM A ESCALA DE TRABALHO.
     * Opção feita para aquelas pessoas que trabalham com uma escala de trabalho onde é difícil se definir quando será
     * seus dias de descanso remunerado
     */
    private function setDescansoSemanal_Diario(){
        try {
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $competencia = $this->hcmParameters->getDtCompetencia();
            $iniperiodo = clone $this->dtiniperiodobenef;
            $fimperiodo = clone $this->dtfimperiodobenef;

            /**
             * @var GpeEscalatrabh $escalaTrab
             * @var GpeAlteescala $escalaTrabVinc
             */
            $params = array('P_NRORG' => $nrorg,
                'P_NRVINCULOM' => $this->vinculo->getNrvinculom());
            $where = "NRVINCULOM = :P_NRVINCULOM AND NRORG = :P_NRORG AND '{$iniperiodo->format('d/m/Y')}' BETWEEN DTINIESCALA AND NVL(DTFIMESCALA, '{$fimperiodo->format('d/m/Y')}') AND DTINIESCALA = (SELECT MAX(DTINIESCALA) DTINIESCALA FROM GPE_ALTEESCALA MAX_ALTEESCALA WHERE MAX_ALTEESCALA.NRORG = e.NRORG AND MAX_ALTEESCALA.NRVINCULOM = e.NRVINCULOM)";
            $escalaTrabVinc = GpeAlteescala::getObjectByWhere($where, $params);
            if ($escalaTrabVinc) {
                $where = "(NRORG = :P_NRORG OR NRORG = 0 OR NRORG IS NULL) AND NRESCALATRABM = :P_NRESCALATRABM AND NRESCALATRABH IN (SELECT NRESCALATRABH FROM GPE_ESCALATRABH WHERE (NRORG = :P_NRORG OR NRORG = 0 OR NRORG IS NULL) AND NRESCALATRABM = :P_NRESCALATRABM AND DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC) FROM GPE_ESCALATRABH MAX_ESCALATRABH WHERE MAX_ESCALATRABH.DTMESCOMPETENC <= '$competencia' AND MAX_ESCALATRABH.NRESCALATRABM = GPE_ESCALATRABH.NRESCALATRABM AND MAX_ESCALATRABH.NRORG = GPE_ESCALATRABH.NRORG))";
                $escalatrabalho = GpeEscalatrabh::getObjectByWhere($where, array('P_NRESCALATRABM' => $escalaTrabVinc->getNrescalatrabm(), 'P_NRORG' => $nrorg));

                $dsdescansosemanal = $escalatrabalho->getDescansosemanal();

                switch ($dsdescansosemanal) {
                    case('SABADO'): {
                        $this->dsdiadescansosemanal = self::SABADO;
                        break;
                    }
                    case('SAB/DOM'): {
                        $this->dsdiadescansosemanal = self::SABDOM;
                        break;
                    }
                    case('DOMINGO'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                    case('SEGUNDA'): {
                        $this->dsdiadescansosemanal = self::SEGUNDA;
                        break;
                    }
                    case('TERCA'): {
                        $this->dsdiadescansosemanal = self::TERCA;
                        break;
                    }
                    case('QUARTA'): {
                        $this->dsdiadescansosemanal = self::QUARTA;
                        break;
                    }
                    case('QUINTA'): {
                        $this->dsdiadescansosemanal = self::QUINTA;
                        break;
                    }
                    case('SEXTA'): {
                        $this->dsdiadescansosemanal = self::SEXTA;
                        break;
                    }
                }
            }
            else {
                //throw new \Exception('Vínculo '.$vinculo->getNrvinculom().' - '.$vinculo->getNmvinculom().' não possui escala.');
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * NÚMERO DE AFASTAMENTOS QUE O VÍNCULO OBTEVE DURANTE DO PERÍODO
     * Considera-se o número de dias em que o vínculo de afastou da empresa e tais afastamentos não geraram vales/benefícios,
     * tais como atestados médicos, afastamento por acidente (de trabalho ou não), afastamento por gravidez,
     * afastamentos por serviços sociais (militares ou parecidos).
     */
    private function getNrAfastamento_Diario(){
        $dtiniperiodo    = clone $this->dtiniperiodocalculo;
        $dtfimperiodo    = clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = clone $this->dtiniperiodocalculo;
        $dtfimperiodoAnt = clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = $dtiniperiodoAnt->sub(new \DateInterval('P1M'));
        $dtfimperiodoAnt = $dtfimperiodoAnt->sub(new \DateInterval('P1M'));
        $dtmescompetencia = $this->hcmParameters->getDtCompetencia();
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        
        //$nrestrutlegal = $this->vinculo->retornaUltimoHistoricoCompetencia($dtmescompetencia)->getNrestrutlegal();
        
        $nrsitufuncm = GpeSitufunch::getAfastamentoIncideVale($dtmescompetencia);
        $nrsitufuncm = implode(', ', $nrsitufuncm);
        $total = 0;
        $where = "NRORG = :P_NRORG AND
                  NRVINCULOM = :P_NRVINCULOM AND
                  ((DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) OR
                   (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) OR
                   (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16)) OR
                   (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                   (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                   (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16)) OR
                   (DTFIMSITUFUNC IS NULL) OR
                   (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                       FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                      WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                        AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM) AND NRSITUFUNCM NOT IN (12, 15, 16))) AND
                  NRSITUFUNCM IN ($nrsitufuncm)";
        $param = array(
            'P_NRORG' => $nrorg,
            'P_NRVINCULOM' => $this->vinculo->getNrvinculom());
        //$altesitfuncs = GpeAltesitufunc::getObjectsByWhere("NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND ((DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo') OR (DTFIMSITUFUNC IS NULL OR DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo')) AND NRSITUFUNCM IN ($nrsitufuncm)",$param);
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);
        
        foreach($altesitfuncs as $altesitfunc){
            if (($altesitfunc->getNrsitufuncm() == 12) or ($altesitfunc->getNrsitufuncm() == 15) or ($altesitfunc->getNrsitufuncm() == 16)) {
                if ($altesitfunc->getDtinisitufunc() < $dtiniperiodoAnt) {
                    $dtiniafastamento = $dtiniperiodoAnt;
                } else {
                    $dtiniafastamento = $altesitfunc->getDtinisitufunc();
                }
                if (!$altesitfunc->getDtfimsitufunc()) {
                    //Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
                    $dtinisitufunc = $altesitfunc->getDtinisitufunc();
                    $where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodoAnt' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
                    $param = array(
                        'P_NRORG' => $nrorg,
                        'P_NRVINCULOM' => $this->vinculo->getNrvinculom());
                    $prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

                    if ($prox_altesitufunc) {
                        //Dia anterior da próxima situação geradora de vale
                        $dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
                        //Caso o afastamento não esteja no período de apuração, é desconsiderado
                        if ($dtfimafastamento < $dtiniafastamento) {
                            continue;
                        }
                    } else {
                        //Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
                        $dtfimafastamento = clone $dtfimperiodoAnt;
                    }

                } else {
                    if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodoAnt) {
                        $dtfimafastamento = $dtfimperiodoAnt;
                    } else {
                        $dtfimafastamento = $altesitfunc->getDtfimsitufunc();
                    }
                }
            } else
            {
                if ($altesitfunc->getDtinisitufunc() < $dtiniperiodo) {
                    $dtiniafastamento = $dtiniperiodo;
                } else {
                    $dtiniafastamento = $altesitfunc->getDtinisitufunc();
                }
                if (!$altesitfunc->getDtfimsitufunc()) {
                    //Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
                    $dtinisitufunc = $altesitfunc->getDtinisitufunc();
                    $where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodo' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
                    $param = array(
                        'P_NRORG' => $nrorg,
                        'P_NRVINCULOM' => $this->vinculo->getNrvinculom());
                    $prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

                    if ($prox_altesitufunc) {
                        //Dia anterior da próxima situação geradora de vale
                        $dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
                        //Caso o afastamento não esteja no período de apuração, é desconsiderado
                        if ($dtfimafastamento < $dtiniafastamento) {
                            continue;
                        }
                    } else {
                        //Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
                        $dtfimafastamento = clone $dtfimperiodo;
                    }

                } else {
                    if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodo) {
                        $dtfimafastamento = $dtfimperiodo;
                    } else {
                        $dtfimafastamento = $altesitfunc->getDtfimsitufunc();
                    }
                }
            }

            if ($dtfimafastamento >= $dtiniafastamento) {
                $qnt = $dtiniafastamento->diff($dtfimafastamento, true);
                $qnt->d++;
                $arFeriados = $this->seekFeriado_Diario($dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'));
                $arDsr      = $this->seekDsr_Diario($dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'), $this->dsdiadescansosemanal);
                //quantidade de dias que coincidem DSR e Feriados
                $intersecao = count(array_intersect($arDsr, $arFeriados));
                $feriados = count($arFeriados);
                $dsr      = count($arDsr);
                $total+= ($qnt->d + $qnt->m*30 + $qnt->y*365) - $feriados - $dsr + $intersecao;
            } else {
                $total = 0;
            }
        }
        return $total;
    }

    /**
     * NÚMERO DE FALTAS
     * Considera-se faltas não justificadas durante o período avaliado.
     */
    private function getNrFalta_Diario(){
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrtpmovimento = '1';
        $nreventom = "490, 495, 1040, 1043";
        if($nrorg == 1193){
            $dtiniperiodoAnt = clone $this->dtiniperiodocalculo;
            $dtmescomp_falta = DateUtil::getPrimeiroDiaDoMes( $dtiniperiodoAnt->sub(new \DateInterval('P1M')) );
        }else
            $dtmescomp_falta = DateUtil::getPrimeiroDiaDoMes($this->dtiniperiodocalculo);
        
        $faltas = FpaCalculofolha::getSomaItemCalculo($this->vinculo->getNrvinculom(), $nrorg, $dtmescomp_falta, $dtmescomp_falta, $nreventom, $nrtpmovimento, $dtmescomp_falta);
        return (int)$faltas['VALOR'];
    }

    /**
     * NÚMERO DE DIAS DE FÉRIAS
     * Considera-se dias que o vínculo ficou afastado por causa de férias.
     */
    private function getNrDiasFerias_Diario(\DateTime $dtinicio, \DateTime $dtfinal){
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $ferias = FpaFerias::getPeriodoGozoFerias($this->vinculo->getNrvinculom(), $dtinicio, $dtfinal, $nrorg);
        if ($ferias) {
            //$inicio = substr($ferias['DTINIGOZOFERIAS'], 0, 10);
            $inicio = DateUtil::retornaMaiorData(substr($ferias['DTINIGOZOFERIAS'], 0, 10),$dtinicio->format('d/m/Y'));
            //$final = substr($ferias['DTFIMGOZOFERIAS'], 0, 10);
            $final = DateUtil::retornaMenorData(substr($ferias['DTFIMGOZOFERIAS'], 0, 10),$dtfinal->format('d/m/Y'));
            $descRemunerado = $this->seekDsr_Diario($inicio, $final, $this->dsdiadescansosemanal);
            $dias_ferias = DateUtil::getDataDeString($inicio)->diff(DateUtil::getDataDeString($final));
            //return (((int)$ferias['QUANTIDADE']) - count($descRemunerado));
            return (($dias_ferias->d+1) - count($descRemunerado));
        } else {
            return 0;
        }
    }

    /**
     * NÚMERO DE DIAS DE AVISO
     * Considera-se dias que o vínculo ficou trabalhando cumprindo aviso prévio.
     */
    private function getNrDiasAviso_Diario(\DateTime $dtinicio, \DateTime $dtfinal){
        if ($this->vinculo->getDtrescisaovinc()) {
            $dtrescisao = DateUtil::getDataDeString($this->vinculo->getDtrescisaovinc(), DateUtil::FORMATO_BRASILEIRO, true);
            $iniperiodo = $dtinicio;
            $fimperiodo = $dtfinal;

            //if ($this->vinculo->getDtavisoprevio() and $dtrescisao->isBetween($iniperiodo, $fimperiodo)) {
            if ($this->vinculo->getDtavisoprevio() and DateUtil::comparaDatas($iniperiodo,$dtrescisao) and DateUtil::comparaDatas($dtrescisao,$fimperiodo)) {
                $nrdiasaviso = DateUtil::getQtdeDiasEntre($iniperiodo, $dtrescisao) + 1;
                $nrdsr = $this->seekDsr_Diario($iniperiodo->format('d/m/Y'), $dtrescisao->format('d/m/Y'), $this->dsdiadescansosemanal);
                $nrdiasaviso = $nrdiasaviso - count($nrdsr);
                return $nrdiasaviso;
            }
            else {
                return 0;
            }
        } else {
            return 0;
        }
    }

    //INFORMAÇÕES SOBRE O MÊS
    /**
     * COMPOSIÇÃO DO PRÓXIMO MÊS
     * considera-se quantos dias úteis haverão no próximo dia útil.
     *
     * @param \DateTime $dtiniperiodobenef
     * @param \DateTime $dtfimperiodobenef
     *
     * @return int
     *
     */
    private function getNrDiasCalculo_Diario(\DateTime $dtiniperiodobenef,\DateTime $dtfimperiodobenef){
        $dtinicio = clone $dtiniperiodobenef;
        $dtfinal = clone $dtfimperiodobenef;

        if(!($dtinicio instanceof \DateTime)){
            $dtinicio = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true);
        }
        if(!($dtfinal instanceof \DateTime)){
            $dtfinal = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
        }
        $dias = $dtfinal->diff($dtinicio, true);
        $dias->d++;
        $arFeriados = $this->seekFeriado_Diario($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'));
        $arDsr      = $this->seekDsr_Diario($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'), $this->dsdiadescansosemanal);
        
        //quantidade de dias que coincidem DSR e Feriados
        $intersecao = count(array_intersect($arDsr, $arFeriados));
        $feriados        = count($arFeriados);
        $descansosemanal = count($arDsr);
        $this->nrdiasdsr = $descansosemanal - $feriados + $intersecao;
        
        return $dias->d - $descansosemanal - $feriados + $intersecao;
    }

    //FUNÇÕES DE SUPORTE
    /**
     * VERIFICA DSR
     * Verifica os quantos dias de descanso remunerado houveram em um determinado período.
     * @param string $dtiniperiodoapur (Formato 'dd/mm/yyyy')
     * @param string $dtfimperiodoapur (Formato 'dd/mm/yyyy')
     * @return array
     */
    private function seekDsr_Diario($dtiniperiodoapur, $dtfimperiodoapur, $dsdiadescansosemanal){
        $dtiniperiodoapur = DateUtil::getDataDeString($dtiniperiodoapur);
        $dtfimperiodoapur = DateUtil::getDataDeString($dtfimperiodoapur);

        $diasDsr = array();

        switch($dsdiadescansosemanal){
            case (self::SABADO):{
                while($dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::DOMINGO):{
                while($dtiniperiodoapur->format('N') != 7){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SABDOM):{
                while($dtiniperiodoapur->format('N') != 7 and $dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                if($dtiniperiodoapur->format('N') == 7){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                while($dtiniperiodoapur<$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                if(($dtfimperiodoapur->format('N') == 6 or $dtfimperiodoapur->format('N') == 7) and ($dtiniperiodoapur<=$dtfimperiodoapur)){
                    $diasDsr[] = $dtfimperiodoapur->format('d/m/Y');
                }
                break;
            }
            case (self::SEGUNDA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::TERCA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUARTA):{
                while($dtiniperiodoapur->format('N') != 3){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUINTA):{
                while($dtiniperiodoapur->format('N') != 4){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SEXTA):{
                while($dtiniperiodoapur->format('N') != 5){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
        }
        return $diasDsr;
    }

    /**
     * BUSCAR FERIADOS
     * Verifica quantos feriados existem em um período de datas passadas por parâmetros.
     * @param string $dtiniperiodoapur
     * @param string $dtfimperiodoapur
     * @return int
     */
    private function seekFeriado_Diario($dtiniperiodoapur, $dtfimperiodoapur){
        $vinculoh = $this->vinculo->retornaUltimoHistoricoCompetencia($this->hcmParameters->getDtCompetencia());
        
        if(is_object($vinculoh)){
            $nrestrutlegal = $vinculoh->getNrestrutlegal();
        }
        
        $paramOrg = FPA::getGpeParametrosOrganizacao();
        
        //Busca calendario da estrutra de movimentacao.
        if($paramOrg->getNrtpestrutcalend()){
            
            $movimentacoes = $this->_movimentosVinculo->carregaMovimentacoesPorTipoEstrutura($vinculo->getNrorg(), $vinculo->getNrvinculom(), $this->hcmParameters->getUltimoDiaMes(), $paramOrg->getNrtpestrutcalend());
            
            if($movimentacoes){
                
                foreach ($movimentacoes as $movimentacao){
                    $nrestrutlegal = $movimentacao->getNrestruturam();
                }
            }
        }
        
        $feriados = \Geral\Repositories\Estruturah::getFeriados($dtiniperiodoapur, $dtfimperiodoapur, $nrestrutlegal, $this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho());
        $result = array();
        foreach($feriados as $feriado){
            $result[] = substr($feriado['DTCALENDARIO'], 0, 10);
        }
        return $result;
    }

    //INFORMAÇÕES SOBRE O BENEFÍCIO
    /**
     * QUANTIDADES E VALORES POR BENEFÍCIO
     */
    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
     private function getBeneficiosVinc_Diario($nrtpbeneficio, $nrestruturam){
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $beneficiosVinc = array();
        $valorCartao = 0;
        $beneficiarios = $this->buscaBeneficiarios_Diario($nrorg, $this->vinculo->getNrvinculom(), $dtmescompetenc, $this->dtiniperiodobenef->format('d/m/Y'), $this->dtfimperiodobenef->format('d/m/Y'), $nrtpbeneficio, $nrestruturam);
        if($beneficiarios){
            /** @var VabBeneficiario $beneficiario */
            foreach ($beneficiarios as $beneficiario) {
                $valorBeneficio = $this->getVrBeneficio_Diario($beneficiario);
                if (array_key_exists($beneficiario->getNrbeneficiom().$beneficiario->getNreventom(), $beneficiosVinc)) {
                    $beneficiosVinc[$beneficiario->getNrbeneficiom().$beneficiario->getNreventom()]['TOTAL'] += ($beneficiario->getQtbeneficio() * $valorBeneficio * $this->diastotaisconsideracao);
                } else {
                    $beneficiosVinc[$beneficiario->getNrbeneficiom().$beneficiario->getNreventom()] = array(
                        'NRBENEFICIOM' => $beneficiario->getNrbeneficiom(),
                        'NRVINCULOM' => $beneficiario->getNrvinculom(),
                        'NREVENTOM' => $beneficiario->getNreventom(),
                        'QUANTIDADE' => $beneficiario->getQtbeneficio(),
                        'DIAS' => $this->diastotaisconsideracao,
                        'AFASTAMENTO' => $this->nrafastamento,
                        'FALTAS' => $this->nrfalta,
                        'FERIAS' => $this->nrdiasferias,
                        'AVISO' => $this->nrdiasaviso,
                        'DSR' => $this->nrdiasdsr,
                        'VALOR' => $valorBeneficio,
                        'DEDUCAO' => $valorCartao,
                        'TOTAL' => ($beneficiario->getQtbeneficio() * $valorBeneficio * $this->diastotaisconsideracao)
                    );
                }
            }
        }
        return $beneficiosVinc;
    }
    
    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    public function buscaBeneficiarios_Diario($nrorg, $nrvinculom, $dtmescompetenc, $dtinicial, $dtfinal, $nrtpbeneficio=null, $nrestruturam=null){
        $condTpbeneficio = $nrtpbeneficio ? "AND BH.NRTPBENEFICIO = $nrtpbeneficio" : "";
        $condEstrutura = $nrestruturam ? "AND BH.NRESTRUTURAM = $nrestruturam" : "";
        $where =
            "NRVINCULOM = $nrvinculom AND
            NRORG = $nrorg AND
            NRBENEFICIOM IN (SELECT BM.NRBENEFICIOM
                               FROM VAB_BENEFICIOM BM
                               JOIN VAB_BENEFICIOH BH ON BH.NRORG = BM.NRORG
                                                     AND BH.NRBENEFICIOM = BM.NRBENEFICIOM
                                                     AND BH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                                               WHERE NRORG = BH.NRORG
                                                                                 AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                                                 AND DTMESCOMPETENC <= '$dtmescompetenc')
                              WHERE BM.NRORG = $nrorg
                                AND BM.IDATIVO = 'S'
                                AND BM.DTINICIOVIGENCIA < '$dtfinal'
                                AND (BM.DTFINALVIGENCIA > '$dtinicial' OR BM.DTFINALVIGENCIA IS NULL)
                                AND BH.TPPERIODOBENEF = 'DIARIO'
                                $condTpbeneficio
                                $condEstrutura)";
        $beneficiarios = VabBeneficiario::getObjectsByWhere($where, array(), 'NRBENEFICIOM ASC, NREVENTOM ASC');
        return $beneficiarios;
    }

    /**
     * @param VabBeneficiario $beneficiario
     */
    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    private function getVrBeneficio_Diario($beneficiario) {
        $dtcompetencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
        
        $vlrBeneficio = 0;
        
        switch ($beneficiario->getIdvalordifebenef()) {
            case 'TABELA':
                /** @var VabBeneficiom $beneficio */
                // $beneficio = VabBeneficiom::findOneByNrorgAndNrbeneficiom($beneficiario->getNrorg(), $beneficiario->getNrbeneficiom());
                $beneficio = $this->calculoBeneficioRepository->getBeneficioPorVinculo($this->hcmParameters->getDtCompetencia(), $this->hcmParameters->getNrorgTrabalho(), $beneficiario->getNrbeneficiom());
                if ( isset($beneficio) && !empty($beneficio) ) {
                    if ($beneficiario->getIdtpbeneficiario() == 'D') {
                        $nrtabelafolha = explode(", ", $beneficio['NRTABELAFOLHASEC']);
                    } else {
                        $nrtabelafolha = explode(", ", $beneficio['NRTABELAFOLHAPRI']);
                    }
                    $faixasTabela = FpaFaixatabela::findByNrtabelafolha($nrtabelafolha);
                    if (!empty($faixasTabela)) {
                        /** @var GpePessoa $pessoa */
                        $pessoa = GpePessoa::findOneByNrorgAndNrpessoa($beneficiario->getNrorg(), $beneficiario->getNrpessoa());
                        if (is_object($pessoa)) {
                            $dtNascPessoa = $pessoa->getHistorico($dtcompetencia)->getDtnascpessoa();
                            if (($dtNascPessoa instanceof DateTime) === false) {
                                $dtNascPessoa = DateUtil::getDataDeString($dtNascPessoa);
                            }
                            $idadePessoa = $dtNascPessoa->diff(DateUtil::getDataAtual())->format('%y');
                            /** @var FpaFaixatabela $faixa */
                            foreach ($faixasTabela as $faixa) {
                                if($idadePessoa >= $faixa->getVrlimitsupfaixa() && $idadePessoa <= $faixa->getVrmaxresultcalc()){
                                    $percentCalc = $faixa->getVrpecalculoresu();
                                    $vraplicaresult = $faixa->getVraplicaresult();
                                    if(isset($percentCalc) && !empty($percentCalc)){
                                        $vlrBeneficio += $vraplicaresult*($percentCalc/100);    
                                    }else{
                                        $vlrBeneficio += $vraplicaresult;    
                                    }
                                }                                
                            }
                            
                        }
                    }
                    
                }
                break;
            
            case 'REFERENCIA':
                /** @var FpaValorreferenciam $valorReferencia */
                $valorReferencia = FpaValorreferenciam::findOneByNrvalorreferenciam($beneficiario->getNrvalorreferenciam());
                if (is_object($valorReferencia)) 
                    $vlrBeneficio += $valorReferencia->retornaUltimoHistoricoCompetencia($dtcompetencia)->getVrreferencia();
                break;    
            
            case 'VALOR':
                $vlrBeneficio += $beneficiario->getVrbeneficio();
                break;
                
        }

        return $vlrBeneficio;
    }

    /**
     * Adiciona os vínculos de líquido no histórico para os mesmos
     * @param array $info
     * @return void
     */
    //ABAIXO, REFERENTE AO ANTIGO CÁLCULO DIARIO
    public function addHistorico_Diario($beneficiosVinc, $dtiniapurbenef, $dtfimapurbenef, $dtpagamento, $nrcalculobenef){
        foreach ($beneficiosVinc as $info) {
            if ($info['DIAS'] > 0) {
                $hist = new VabHistbenefvinc();
                $hist->setNrhistbenefvinc(NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'VAB_HISTBENEFVINC', 1, 22, true));
                $hist->setNrbeneficiom($info['NRBENEFICIOM']);
                $hist->setNrvinculom($info['NRVINCULOM']);
                $hist->setNrcalculofolha($nrcalculobenef);
                $hist->setNreventom($info['NREVENTOM']);
                $hist->setNrorg($this->hcmParameters->getNrorgTrabalho());
                $hist->setDtmescompetenc(DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setDtiniapurbenef(DateUtil::getDataDeString($dtiniapurbenef, DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setDtfinapurbenef(DateUtil::getDataDeString($dtfimapurbenef, DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setDtpgtobenef(DateUtil::getDataDeString($dtpagamento, DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setQtapurbenef($info['QUANTIDADE']);
                $hist->setQtdiasbenef($info['DIAS']);
                $hist->setQtdiasafasta($info['AFASTAMENTO']);
                $hist->setQtdiasfaltas($info['FALTAS']);
                $hist->setQtdiasferias($info['FERIAS']);
                $hist->setQtdiasaviso($info['AVISO']);
                $hist->setQtdiasdsr($info['DSR']);
                $hist->setVrbeneficio($info['VALOR']);
                $hist->setVrdeducaobenef($info['DEDUCAO']);
                $hist->setVrtotalbenef($info['TOTAL']);
                $hist->setIdativo('S');
                $hist->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                $hist->setDtinclusao(DateUtil::getDataAtual());
                $hist->setCdoperinclusao($this->hcmParameters->getCdoperador());
                $hist->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                $hist->setDtultatu(DateUtil::getDataAtual());
                $hist->setCdoperultatu($this->hcmParameters->getCdoperador());

                $hist->persist();
            }
        }
    }
}